/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20230113(212670ceb460441b3ebed29e6ca30aa1e9bdde85)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Q=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(U){for(var i=[],A=0,e=U.length;A<e;A++)i[A]=Q[U[A]];return i},Ee=this,Re=typeof global=="object"?global:{},ae;(function(U){U.global=Ee;var i=function(){function A(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(A.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),A.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=A._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},A._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},A}();U.Environment=i})(ae||(ae={}));var ae;(function(U){var i=function(){function E(l,p,v){this.type=l,this.detail=p,this.timestamp=v}return E}();U.LoaderEvent=i;var A=function(){function E(l){this._events=[new i(1,"",l)]}return E.prototype.record=function(l,p){this._events.push(new i(l,p,U.Utilities.getHighPerformanceTimestamp()))},E.prototype.getEvents=function(){return this._events},E}();U.LoaderEventRecorder=A;var e=function(){function E(){}return E.prototype.record=function(l,p){},E.prototype.getEvents=function(){return[]},E.INSTANCE=new E,E}();U.NullLoaderEventRecorder=e})(ae||(ae={}));var ae;(function(U){var i=function(){function A(){}return A.fileUriToFilePath=function(e,E){if(E=decodeURI(E).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(E))return E.substr(8);if(/^file:\/\//.test(E))return E.substr(5)}else if(/^file:\/\//.test(E))return E.substr(7);return E},A.startsWith=function(e,E){return e.length>=E.length&&e.substr(0,E.length)===E},A.endsWith=function(e,E){return e.length>=E.length&&e.substr(e.length-E.length)===E},A.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},A.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},A.forEachProperty=function(e,E){if(e){var l=void 0;for(l in e)e.hasOwnProperty(l)&&E(l,e[l])}},A.isEmpty=function(e){var E=!0;return A.forEachProperty(e,function(){E=!1}),E},A.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var E=Array.isArray(e)?[]:{};return A.forEachProperty(e,function(l,p){p&&typeof p=="object"?E[l]=A.recursiveClone(p):E[l]=p}),E},A.generateAnonymousModule=function(){return"===anonymous"+A.NEXT_ANONYMOUS_ID+++"==="},A.isAnonymousModule=function(e){return A.startsWith(e,"===anonymous")},A.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()},A.NEXT_ANONYMOUS_ID=1,A.PERFORMANCE_NOW_PROBED=!1,A.HAS_PERFORMANCE_NOW=!1,A}();U.Utilities=i})(ae||(ae={}));var ae;(function(U){function i(E){if(E instanceof Error)return E;var l=new Error(E.message||String(E)||"Unknown Error");return E.stack&&(l.stack=E.stack),l}U.ensureError=i;var A=function(){function E(){}return E.validateConfigurationOptions=function(l){function p(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError>"u"&&(l.catchError=!1),typeof l.recordStats>"u"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=p),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(U.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags>"u"&&(l.preferScriptTags=!1),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var v=i(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",l.onError(v),l.nodeCachedData=void 0}return l},E.mergeConfigurationOptions=function(l,p){l===void 0&&(l=null),p===void 0&&(p=null);var v=U.Utilities.recursiveClone(p||{});return U.Utilities.forEachProperty(l,function(o,f){o==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(f):o==="paths"&&typeof v.paths<"u"?U.Utilities.forEachProperty(f,function(S,t){return v.paths[S]=t}):o==="config"&&typeof v.config<"u"?U.Utilities.forEachProperty(f,function(S,t){return v.config[S]=t}):v[o]=U.Utilities.recursiveClone(f)}),E.validateConfigurationOptions(v)},E}();U.ConfigurationOptionsUtil=A;var e=function(){function E(l,p){if(this._env=l,this.options=A.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var v=this.options.nodeRequire.main.filename,o=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,o+1)}}return E.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},E.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,function(p,v){Array.isArray(v)?l.sortedPathsRules.push({from:p,to:v}):l.sortedPathsRules.push({from:p,to:[v]})}),this.sortedPathsRules.sort(function(p,v){return v.from.length-p.from.length})},E.prototype.cloneAndMerge=function(l){return new E(this._env,A.mergeConfigurationOptions(l,this.options))},E.prototype.getOptionsLiteral=function(){return this.options},E.prototype._applyPaths=function(l){for(var p,v=0,o=this.sortedPathsRules.length;v<o;v++)if(p=this.sortedPathsRules[v],U.Utilities.startsWith(l,p.from)){for(var f=[],S=0,t=p.to.length;S<t;S++)f.push(p.to[S]+l.substr(p.from.length));return f}return[l]},E.prototype._addUrlArgsToUrl=function(l){return U.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},E.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},E.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var p=0,v=l.length;p<v;p++)l[p]=this._addUrlArgsToUrl(l[p]);return l},E.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var p=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(p)return this.isBuild()?["empty:"]:["node|"+l]}var v=l,o;if(!U.Utilities.endsWith(v,".js")&&!U.Utilities.isAbsolutePath(v)){o=this._applyPaths(v);for(var f=0,S=o.length;f<S;f++)this.isBuild()&&o[f]==="empty:"||(U.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!U.Utilities.endsWith(o[f],".js")&&!U.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!U.Utilities.endsWith(v,".js")&&!U.Utilities.containsQueryString(v)&&(v=v+".js"),o=[v];return this._addUrlArgsIfNecessaryToUrls(o)},E.prototype.requireToUrl=function(l){var p=l;return U.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],U.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)},E.prototype.isBuild=function(){return this.options.isBuild},E.prototype.shouldInvokeFactory=function(l){return!!(!this.options.isBuild||U.Utilities.isAnonymousModule(l)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[l])},E.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},E.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},E.prototype.shouldCatchError=function(){return this.options.catchError},E.prototype.shouldRecordStats=function(){return this.options.recordStats},E.prototype.onError=function(l){this.options.onError(l)},E}();U.Configuration=e})(ae||(ae={}));var ae;(function(U){var i=function(){function o(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(f,S,t,w){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new E;else if(this._env.isElectronRenderer){var m=f.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new A:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new A;var L={callback:t,errorback:w};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(L);return}this._callbackMap[S]=[L],this._scriptLoader.load(f,S,function(){return h.triggerCallback(S)},function(y){return h.triggerErrorback(S,y)})},o.prototype.triggerCallback=function(f){var S=this._callbackMap[f];delete this._callbackMap[f];for(var t=0;t<S.length;t++)S[t].callback()},o.prototype.triggerErrorback=function(f,S){var t=this._callbackMap[f];delete this._callbackMap[f];for(var w=0;w<t.length;w++)t[w].errorback(S)},o}(),A=function(){function o(){}return o.prototype.attachListeners=function(f,S,t){var w=function(){f.removeEventListener("load",h),f.removeEventListener("error",m)},h=function(L){w(),S()},m=function(L){w(),t(L)};f.addEventListener("load",h),f.addEventListener("error",m)},o.prototype.load=function(f,S,t,w){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||U.global.nodeRequire),L=S.split("|"),y=null;try{y=m(L[1])}catch(u){w(u);return}f.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var _=document.createElement("script");_.setAttribute("async","async"),_.setAttribute("type","text/javascript"),this.attachListeners(_,t,w);var g=f.getConfig().getOptionsLiteral().trustedTypesPolicy;g&&(S=g.createScriptURL(S)),_.setAttribute("src",S);var C=f.getConfig().getOptionsLiteral().cspNonce;C&&_.setAttribute("nonce",C),document.getElementsByTagName("head")[0].appendChild(_)}},o}();function e(o){var f=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var S=f?self.eval(f.createScript("","true")):new Function("true");return S.call(self),!0}catch{return!1}}var E=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(f)),this._cachedCanUseEval},o.prototype.load=function(f,S,t,w){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||U.global.nodeRequire),L=S.split("|"),y=null;try{y=m(L[1])}catch(C){w(C);return}f.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var _=f.getConfig().getOptionsLiteral().trustedTypesPolicy,g=/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin;if(!g&&this._canUseEval(f)){fetch(S).then(function(C){if(C.status!==200)throw new Error(C.statusText);return C.text()}).then(function(C){C=C+`
//# sourceURL=`+S;var u=_?self.eval(_.createScript("",C)):new Function(C);u.call(self),t()}).then(void 0,w);return}try{_&&(S=_.createScriptURL(S)),importScripts(S),t()}catch(C){w(C)}}},o}(),l=function(){function o(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},o.prototype._initNodeRequire=function(f,S){var t=S.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,h=f("module");function m(L){var y=L.constructor,_=function(C){try{return L.require(C)}finally{}};return _.resolve=function(C,u){return y._resolveFilename(C,L,!1,u)},_.resolve.paths=function(C){return y._resolveLookupPaths(C,L)},_.main=process.mainModule,_.extensions=y._extensions,_.cache=y._cache,_}h.prototype._compile=function(L,y){var _=h.wrap(L.replace(/^#!.*/,"")),g=S.getRecorder(),C=w._getCachedDataPath(t,y),u={filename:y},d;try{var s=w._fs.readFileSync(C);d=s.slice(0,16),u.cachedData=s.slice(16),g.record(60,C)}catch{g.record(61,C)}var a=new w._vm.Script(_,u),r=a.runInThisContext(u),c=w._path.dirname(y),b=m(this),N=[this.exports,b,this,y,c,process,Re,Buffer],M=r.apply(this.exports,N);return w._handleCachedData(a,_,C,!u.cachedData,S),w._verifyCachedData(a,_,C,d,S),M}},o.prototype.load=function(f,S,t,w){var h=this,m=f.getConfig().getOptionsLiteral(),L=p(f.getRecorder(),m.nodeRequire||U.global.nodeRequire),y=m.nodeInstrumenter||function(r){return r};this._init(L),this._initNodeRequire(L,f);var _=f.getRecorder();if(/^node\|/.test(S)){var g=S.split("|"),C=null;try{C=L(g[1])}catch(r){w(r);return}f.enqueueDefineAnonymousModule([],function(){return C}),t()}else{S=U.Utilities.fileUriToFilePath(this._env.isWindows,S);var u=this._path.normalize(S),d=this._getElectronRendererScriptPathOrUri(u),s=Boolean(m.nodeCachedData),a=s?this._getCachedDataPath(m.nodeCachedData,S):void 0;this._readSourceAndCachedData(u,a,_,function(r,c,b,N){if(r){w(r);return}var M;c.charCodeAt(0)===o._BOM?M=o._PREFIX+c.substring(1)+o._SUFFIX:M=o._PREFIX+c+o._SUFFIX,M=y(M,u);var R={filename:d,cachedData:b},P=h._createAndEvalScript(f,M,R,t,w);h._handleCachedData(P,M,a,s&&!b,f),h._verifyCachedData(P,M,a,N,f)})}},o.prototype._createAndEvalScript=function(f,S,t,w,h){var m=f.getRecorder();m.record(31,t.filename);var L=new this._vm.Script(S,t),y=L.runInThisContext(t),_=f.getGlobalAMDDefineFunc(),g=!1,C=function(){return g=!0,_.apply(null,arguments)};return C.amd=_.amd,y.call(U.global,f.getGlobalAMDRequireFunc(),C,t.filename,this._path.dirname(t.filename)),m.record(32,t.filename),g?w():h(new Error("Didn't receive define call in "+t.filename+"!")),L},o.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var S=f.match(/^([a-z])\:(.*)/i);return S?"file:///"+(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/"):"file://"+f},o.prototype._getCachedDataPath=function(f,S){var t=this._crypto.createHash("md5").update(S,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(S).replace(/\.js$/,"");return this._path.join(f.path,w+"-"+t+".code")},o.prototype._handleCachedData=function(f,S,t,w,h){var m=this;f.cachedDataRejected?this._fs.unlink(t,function(L){h.getRecorder().record(62,t),m._createAndWriteCachedData(f,S,t,h),L&&h.getConfig().onError(L)}):w&&this._createAndWriteCachedData(f,S,t,h)},o.prototype._createAndWriteCachedData=function(f,S,t,w){var h=this,m=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,y=0,_=void 0,g=function(){setTimeout(function(){_||(_=h._crypto.createHash("md5").update(S,"utf8").digest());var C=f.createCachedData();if(!(C.length===0||C.length===L||y>=5)){if(C.length<L){g();return}L=C.length,h._fs.writeFile(t,Buffer.concat([_,C]),function(u){u&&w.getConfig().onError(u),w.getRecorder().record(63,t),g()})}},m*Math.pow(4,y++))};g()},o.prototype._readSourceAndCachedData=function(f,S,t,w){if(!S)this._fs.readFile(f,{encoding:"utf8"},w);else{var h=void 0,m=void 0,L=void 0,y=2,_=function(g){g?w(g):--y===0&&w(void 0,h,m,L)};this._fs.readFile(f,{encoding:"utf8"},function(g,C){h=C,_(g)}),this._fs.readFile(S,function(g,C){!g&&C&&C.length>0?(L=C.slice(0,16),m=C.slice(16),t.record(60,S)):t.record(61,S),_()})}},o.prototype._verifyCachedData=function(f,S,t,w,h){var m=this;!w||f.cachedDataRejected||setTimeout(function(){var L=m._crypto.createHash("md5").update(S,"utf8").digest();w.equals(L)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(t,function(y){y&&h.getConfig().onError(y)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function p(o,f){if(f.__$__isRecorded)return f;var S=function(w){o.record(33,w);try{return f(w)}finally{o.record(34,w)}};return S.__$__isRecorded=!0,S}U.ensureRecordedNodeRequire=p;function v(o){return new i(o)}U.createScriptLoader=v})(ae||(ae={}));var ae;(function(U){var i=function(){function v(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return v._normalizeModuleId=function(o){var f=o,S;for(S=/\/\.\//;S.test(f);)f=f.replace(S,"/");for(f=f.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(f);)f=f.replace(S,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},v.prototype.resolveModule=function(o){var f=o;return U.Utilities.isAbsolutePath(f)||(U.Utilities.startsWith(f,"./")||U.Utilities.startsWith(f,"../"))&&(f=v._normalizeModuleId(this.fromModulePath+f)),f},v.ROOT=new v(""),v}();U.ModuleIdResolver=i;var A=function(){function v(o,f,S,t,w,h){this.id=o,this.strId=f,this.dependencies=S,this._callback=t,this._errorback=w,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return v._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(U.global,f),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},v._invokeFactory=function(o,f,S,t){return o.shouldInvokeFactory(f)?o.shouldCatchError()?this._safeInvokeFunction(S,t):{returnedValue:S.apply(U.global,t),producedError:null}:{returnedValue:null,producedError:null}},v.prototype.complete=function(o,f,S,t){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var h=v._invokeFactory(f,this.strId,this._callback,S);w=h.producedError,o.record(22,this.strId),!w&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(w){var m=U.ensureError(w);m.phase="factory",m.moduleId=this.strId,m.neededBy=t(this.id),this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},v.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},v.prototype.isComplete=function(){return this._isComplete},v}();U.Module=A;var e=function(){function v(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return v.prototype.getMaxModuleId=function(){return this._nextId},v.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},v.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},v}(),E=function(){function v(o){this.id=o}return v.EXPORTS=new v(0),v.MODULE=new v(1),v.REQUIRE=new v(2),v}();U.RegularDependency=E;var l=function(){function v(o,f,S){this.id=o,this.pluginId=f,this.pluginParam=S}return v}();U.PluginDependency=l;var p=function(){function v(o,f,S,t,w){w===void 0&&(w=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=w,this._defineFunc=S,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return v.prototype.reset=function(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},v.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},v.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},v._findRelevantLocationInStack=function(o,f){for(var S=function(u){return u.replace(/\\/g,"/")},t=S(o),w=f.split(/\n/),h=0;h<w.length;h++){var m=w[h].match(/(.*):(\d+):(\d+)\)?$/);if(m){var L=m[1],y=m[2],_=m[3],g=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(g),L=S(L),L===t){var C={line:parseInt(y,10),col:parseInt(_,10)};return C.line===1&&(C.col-=53),C}}}throw new Error("Could not correlate define call site for needle "+o)},v.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,S=0,t=this._modules2.length;S<t;S++){var w=this._modules2[S];if(!!w){var h=this._buildInfoPath[w.id]||null,m=this._buildInfoDefineStack[w.id]||null,L=this._buildInfoDependencies[w.id];o[f++]={id:w.strId,path:h,defineLocation:h&&m?v._findRelevantLocationInStack(h,m):null,dependencies:L,shim:null,exports:w.exports}}}return o},v.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder},v.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},v.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:o,callback:f}},v.prototype.defineModule=function(o,f,S,t,w,h){var m=this;h===void 0&&(h=new i(o));var L=this._moduleIdProvider.getModuleId(o);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var y=new A(L,o,this._normalizeDependencies(f,h),S,t,h);this._modules2[L]=y,this._config.isBuild()&&(this._buildInfoDefineStack[L]=w,this._buildInfoDependencies[L]=(y.dependencies||[]).map(function(_){return m._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(y)},v.prototype._normalizeDependency=function(o,f){if(o==="exports")return E.EXPORTS;if(o==="module")return E.MODULE;if(o==="require")return E.REQUIRE;var S=o.indexOf("!");if(S>=0){var t=f.resolveModule(o.substr(0,S)),w=f.resolveModule(o.substr(S+1)),h=this._moduleIdProvider.getModuleId(t+"!"+w),m=this._moduleIdProvider.getModuleId(t);return new l(h,m,w)}return new E(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},v.prototype._normalizeDependencies=function(o,f){for(var S=[],t=0,w=0,h=o.length;w<h;w++)S[t++]=this._normalizeDependency(o[w],f);return S},v.prototype._relativeRequire=function(o,f,S,t){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(U.Utilities.generateAnonymousModule(),f,S,t,null,o)},v.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new i(o));var S=this._normalizeDependency(o,f),t=this._modules2[S.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},v.prototype.configure=function(o,f){var S=this._config.shouldRecordStats();f?this._config=new U.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},v.prototype.getConfig=function(){return this._config},v.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},v.prototype._createLoadError=function(o,f){var S=this,t=this._moduleIdProvider.getStrModuleId(o),w=(this._inverseDependencies2[o]||[]).map(function(m){return S._moduleIdProvider.getStrModuleId(m)}),h=U.ensureError(f);return h.phase="loading",h.moduleId=t,h.neededBy=w,h},v.prototype._onLoadError=function(o,f){var S=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new A(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var t=[],w=0,h=this._moduleIdProvider.getMaxModuleId();w<h;w++)t[w]=!1;var m=!1,L=[];for(L.push(o),t[o]=!0;L.length>0;){var y=L.shift(),_=this._modules2[y];_&&(m=_.onDependencyError(S)||m);var g=this._inverseDependencies2[y];if(g)for(var w=0,h=g.length;w<h;w++){var C=g[w];t[C]||(L.push(C),t[C]=!0)}}m||this._config.onError(S)},v.prototype._hasDependencyPath=function(o,f){var S=this._modules2[o];if(!S)return!1;for(var t=[],w=0,h=this._moduleIdProvider.getMaxModuleId();w<h;w++)t[w]=!1;var m=[];for(m.push(S),t[o]=!0;m.length>0;){var L=m.shift(),y=L.dependencies;if(y)for(var w=0,h=y.length;w<h;w++){var _=y[w];if(_.id===f)return!0;var g=this._modules2[_.id];g&&!t[_.id]&&(t[_.id]=!0,m.push(g))}}return!1},v.prototype._findCyclePath=function(o,f,S){if(o===f||S===50)return[o];var t=this._modules2[o];if(!t)return null;var w=t.dependencies;if(w)for(var h=0,m=w.length;h<m;h++){var L=this._findCyclePath(w[h].id,f,S+1);if(L!==null)return L.push(o),L}return null},v.prototype._createRequire=function(o){var f=this,S=function(t,w,h){return f._relativeRequire(o,t,w,h)};return S.toUrl=function(t){return f._config.requireToUrl(o.resolveModule(t))},S.getStats=function(){return f.getLoaderEvents()},S.hasDependencyCycle=function(){return f._hasDependencyCycle},S.config=function(t,w){w===void 0&&(w=!1),f.configure(t,w)},S.__$__nodeRequire=U.global.nodeRequire,S},v.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var S=this._moduleIdProvider.getStrModuleId(o),t=this._config.moduleIdToPaths(S),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||w.test(S))&&t.push("node|"+S);var h=-1,m=function(L){if(h++,h>=t.length)f._onLoadError(o,L);else{var y=t[h],_=f.getRecorder();if(f._config.isBuild()&&y==="empty:"){f._buildInfoPath[o]=y,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}_.record(10,y),f._scriptLoader.load(f,y,function(){f._config.isBuild()&&(f._buildInfoPath[o]=y),_.record(11,y),f._onLoad(o)},function(g){_.record(12,y),m(g)})}};m(null)}},v.prototype._loadPluginDependency=function(o,f){var S=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var t=function(w){S.defineModule(S._moduleIdProvider.getStrModuleId(f.id),[],w,null,null)};t.error=function(w){S._config.onError(S._createLoadError(f.id,w))},o.load(f.pluginParam,this._createRequire(i.ROOT),t,this._config.getOptionsLiteral())}},v.prototype._resolve=function(o){var f=this,S=o.dependencies;if(S)for(var t=0,w=S.length;t<w;t++){var h=S[t];if(h===E.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(h===E.MODULE){o.unresolvedDependenciesCount--;continue}if(h===E.REQUIRE){o.unresolvedDependenciesCount--;continue}var m=this._modules2[h.id];if(m&&m.isComplete()){if(m.error){o.onDependencyError(m.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var L=this._findCyclePath(h.id,o.id,0)||[];L.reverse(),L.push(h.id),console.warn(L.map(function(g){return f._moduleIdProvider.getStrModuleId(g)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(o.id),h instanceof l){var y=this._modules2[h.pluginId];if(y&&y.isComplete()){this._loadPluginDependency(y.exports,h);continue}var _=this._inversePluginDependencies2.get(h.pluginId);_||(_=[],this._inversePluginDependencies2.set(h.pluginId,_)),_.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},v.prototype._onModuleComplete=function(o){var f=this,S=this.getRecorder();if(!o.isComplete()){var t=o.dependencies,w=[];if(t)for(var h=0,m=t.length;h<m;h++){var L=t[h];if(L===E.EXPORTS){w[h]=o.exports;continue}if(L===E.MODULE){w[h]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(L===E.REQUIRE){w[h]=this._createRequire(o.moduleIdResolver);continue}var y=this._modules2[L.id];if(y){w[h]=y.exports;continue}w[h]=null}var _=function(s){return(f._inverseDependencies2[s]||[]).map(function(a){return f._moduleIdProvider.getStrModuleId(a)})};o.complete(S,this._config,w,_);var g=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,g)for(var h=0,m=g.length;h<m;h++){var C=g[h],u=this._modules2[C];u.unresolvedDependenciesCount--,u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}var d=this._inversePluginDependencies2.get(o.id);if(d){this._inversePluginDependencies2.delete(o.id);for(var h=0,m=d.length;h<m;h++)this._loadPluginDependency(o.exports,d[h])}}},v}();U.ModuleManager=p})(ae||(ae={}));var X,ae;(function(U){var i=new U.Environment,A=null,e=function(v,o,f){typeof v!="string"&&(f=o,o=v,v=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),v?A.defineModule(v,o,f,null,null):A.enqueueDefineAnonymousModule(o,f)};e.amd={jQuery:!0};var E=function(v,o){o===void 0&&(o=!1),A.configure(v,o)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){E(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=E,l.getConfig=function(){return A.getConfig().getOptionsLiteral()},l.reset=function(){A=A.reset()},l.getBuildInfo=function(){return A.getBuildInfo()},l.getStats=function(){return A.getLoaderEvents()},l.define=e;function p(){if(typeof U.global.require<"u"||typeof require<"u"){var v=U.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){var o=U.ensureRecordedNodeRequire(A.getRecorder(),v);U.global.nodeRequire=o,l.nodeRequire=o,l.__$__nodeRequire=o}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=l:(i.isElectronRenderer||(U.global.define=e),U.global.require=l)}U.init=p,(typeof U.global.define!="function"||!U.global.define.amd)&&(A=new U.ModuleManager(i,U.createScriptLoader(i),e,l,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require<"u"&&typeof U.global.require!="function"&&l.config(U.global.require),X=function(){return e.apply(null,arguments)},X.amd=e.amd,typeof doNotInitLoader>"u"&&p())})(ae||(ae={}));var le=this&&this.__awaiter||function(U,i,A,e){function E(l){return l instanceof A?l:new A(function(p){p(l)})}return new(A||(A=Promise))(function(l,p){function v(S){try{f(e.next(S))}catch(t){p(t)}}function o(S){try{f(e.throw(S))}catch(t){p(t)}}function f(S){S.done?l(S.value):E(S.value).then(v,o)}f((e=e.apply(U,i||[])).next())})};X(Q[21],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=i.create=i.setPseudoTranslation=i.getConfiguredDefaultLocale=i.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const e="i-default";function E(m,L){let y;return L.length===0?y=m:y=m.replace(/\{(\d+)\}/g,(_,g)=>{const C=g[0],u=L[C];let d=_;return typeof u=="string"?d=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(d=String(u)),d}),A&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function l(m,L){let y=m[L];return y||(y=m["*"],y)?y:null}function p(m){return m.charAt(m.length-1)==="/"?m:m+"/"}function v(m,L,y){return le(this,void 0,void 0,function*(){const _=p(m)+p(L)+"vscode/"+p(y),g=yield fetch(_);if(g.ok)return yield g.json();throw new Error(`${g.status} - ${g.statusText}`)})}function o(m){return function(L,y){const _=Array.prototype.slice.call(arguments,2);return E(m[L],_)}}function f(m,L,...y){return E(L,y)}i.localize=f;function S(m){}i.getConfiguredDefaultLocale=S;function t(m){A=m}i.setPseudoTranslation=t;function w(m,L){var y;return{localize:o(L[m]),getConfiguredDefaultLocale:(y=L.getConfiguredDefaultLocale)!==null&&y!==void 0?y:_=>{}}}i.create=w;function h(m,L,y,_){var g;const C=(g=_["vs/nls"])!==null&&g!==void 0?g:{};if(!m||m.length===0)return y({localize:f,getConfiguredDefaultLocale:()=>{var r;return(r=C.availableLanguages)===null||r===void 0?void 0:r["*"]}});const u=C.availableLanguages?l(C.availableLanguages,m):null,d=u===null||u===e;let s=".nls";d||(s=s+"."+u);const a=r=>{Array.isArray(r)?r.localize=o(r):r.localize=o(r[m]),r.getConfiguredDefaultLocale=()=>{var c;return(c=C.availableLanguages)===null||c===void 0?void 0:c["*"]},y(r)};typeof C.loadBundle=="function"?C.loadBundle(m,u,(r,c)=>{r?L([m+".nls"],a):a(c)}):C.translationServiceUrl&&!d?le(this,void 0,void 0,function*(){var r;try{const c=yield v(C.translationServiceUrl,u,m);return a(c)}catch(c){if(!u.includes("-"))return console.error(c),L([m+".nls"],a);try{const b=u.split("-")[0],N=yield v(C.translationServiceUrl,b,m);return(r=C.availableLanguages)!==null&&r!==void 0||(C.availableLanguages={}),C.availableLanguages["*"]=b,a(N)}catch(b){return console.error(b),L([m+".nls"],a)}}}):L([m+s],a,r=>{if(s===".nls"){console.error("Failed trying to load default language strings",r);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,r),L([m+".nls"],a)})}i.load=h}),function(){var U,i;const A=self.MonacoEnvironment,e=A&&A.baseUrl?A.baseUrl:"../../../",E=typeof((U=self.trustedTypes)===null||U===void 0?void 0:U.createPolicy)=="function"?(i=self.trustedTypes)===null||i===void 0?void 0:i.createPolicy("amdLoader",{createScriptURL:t=>t,createScript:(t,...w)=>{const h=w.slice(0,-1).join(","),m=w.pop().toString();return`(function anonymous(${h}) { ${m}
})`}}):void 0;function l(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function p(){return new Promise((t,w)=>{if(typeof self.define=="function"&&self.define.amd)return t();const h=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&l()){fetch(h).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${h}`,(E?self.eval(E.createScript("",L)):new Function(L)).call(self),t()}).then(void 0,w);return}E?importScripts(E.createScriptURL(h)):importScripts(h),t()})}function v(){require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//})}function o(t){p().then(()=>{v(),require([t],function(w){setTimeout(function(){const h=w.create((m,L)=>{self.postMessage(m,L)},null);for(self.onmessage=m=>h.onmessage(m.data,m.ports);S.length>0;)self.onmessage(S.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&v();let f=!0;const S=[];self.onmessage=t=>{if(!f){S.push(t);return}f=!1,o(t.data)}}(),X(Q[22],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CallbackIterable=i.ArrayQueue=i.findMinBy=i.findLastMaxBy=i.findMaxBy=i.numberComparator=i.compareBy=i.CompareResult=i.splice=i.insertInto=i.asArray=i.pushMany=i.pushToEnd=i.pushToStart=i.arrayInsert=i.range=i.firstOrDefault=i.lastIndex=i.findLast=i.distinct=i.isNonEmptyArray=i.isFalsyOrEmpty=i.coalesce=i.groupBy=i.quickSelect=i.findFirstInSorted=i.binarySearch2=i.binarySearch=i.removeFastWithoutKeepingOrder=i.equals=i.tail2=i.tail=void 0;function A(k,I=0){return k[k.length-(1+I)]}i.tail=A;function e(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}i.tail2=e;function E(k,I,T=(W,H)=>W===H){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let W=0,H=k.length;W<H;W++)if(!T(k[W],I[W]))return!1;return!0}i.equals=E;function l(k,I){const T=k.length-1;I<T&&(k[I]=k[T]),k.pop()}i.removeFastWithoutKeepingOrder=l;function p(k,I,T){return v(k.length,W=>T(k[W],I))}i.binarySearch=p;function v(k,I){let T=0,W=k-1;for(;T<=W;){const H=(T+W)/2|0,n=I(H);if(n<0)T=H+1;else if(n>0)W=H-1;else return H}return-(T+1)}i.binarySearch2=v;function o(k,I){let T=0,W=k.length;if(W===0)return 0;for(;T<W;){const H=Math.floor((T+W)/2);I(k[H])?W=H:T=H+1}return T}i.findFirstInSorted=o;function f(k,I,T){if(k=k|0,k>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],H=[],n=[],se=[];for(const de of I){const ge=T(de,W);ge<0?H.push(de):ge>0?n.push(de):se.push(de)}return k<H.length?f(k,H,T):k<H.length+se.length?se[0]:f(k-(H.length+se.length),n,T)}i.quickSelect=f;function S(k,I){const T=[];let W;for(const H of k.slice(0).sort(I))!W||I(W[0],H)!==0?(W=[H],T.push(W)):W.push(H);return T}i.groupBy=S;function t(k){return k.filter(I=>!!I)}i.coalesce=t;function w(k){return!Array.isArray(k)||k.length===0}i.isFalsyOrEmpty=w;function h(k){return Array.isArray(k)&&k.length>0}i.isNonEmptyArray=h;function m(k,I=T=>T){const T=new Set;return k.filter(W=>{const H=I(W);return T.has(H)?!1:(T.add(H),!0)})}i.distinct=m;function L(k,I){const T=y(k,I);if(T!==-1)return k[T]}i.findLast=L;function y(k,I){for(let T=k.length-1;T>=0;T--){const W=k[T];if(I(W))return T}return-1}i.lastIndex=y;function _(k,I){return k.length>0?k[0]:I}i.firstOrDefault=_;function g(k,I){let T=typeof I=="number"?k:0;typeof I=="number"?T=k:(T=0,I=k);const W=[];if(T<=I)for(let H=T;H<I;H++)W.push(H);else for(let H=T;H>I;H--)W.push(H);return W}i.range=g;function C(k,I,T){const W=k.slice(0,I),H=k.slice(I);return W.concat(T,H)}i.arrayInsert=C;function u(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.unshift(I))}i.pushToStart=u;function d(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.push(I))}i.pushToEnd=d;function s(k,I){for(const T of I)k.push(T)}i.pushMany=s;function a(k){return Array.isArray(k)?k:[k]}i.asArray=a;function r(k,I,T){const W=b(k,I),H=k.length,n=T.length;k.length=H+n;for(let se=H-1;se>=W;se--)k[se+n]=k[se];for(let se=0;se<n;se++)k[se+W]=T[se]}i.insertInto=r;function c(k,I,T,W){const H=b(k,I),n=k.splice(H,T);return r(k,H,W),n}i.splice=c;function b(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}var N;(function(k){function I(H){return H<0}k.isLessThan=I;function T(H){return H>0}k.isGreaterThan=T;function W(H){return H===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(N=i.CompareResult||(i.CompareResult={}));function M(k,I){return(T,W)=>I(k(T),k(W))}i.compareBy=M;const R=(k,I)=>k-I;i.numberComparator=R;function P(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const H=k[W];I(H,T)>0&&(T=H)}return T}i.findMaxBy=P;function F(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const H=k[W];I(H,T)>=0&&(T=H)}return T}i.findLastMaxBy=F;function V(k,I){return P(k,(T,W)=>-I(T,W))}i.findMinBy=V;class O{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let T=this.c;for(;T<this.f.length&&I(this.f[T]);)T++;const W=T===this.c?null:this.f.slice(this.c,T);return this.c=T,W}takeFromEndWhile(I){let T=this.d;for(;T>=0&&I(this.f[T]);)T--;const W=T===this.d?null:this.f.slice(T+1,this.d+1);return this.d=T,W}peek(){if(this.length!==0)return this.f[this.c]}dequeue(){const I=this.f[this.c];return this.c++,I}takeCount(I){const T=this.f.slice(this.c,this.c+I);return this.c+=I,T}}i.ArrayQueue=O;class q{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(T=>(I.push(T),!0)),I}filter(I){return new q(T=>this.iterate(W=>I(W)?T(W):!0))}map(I){return new q(T=>this.iterate(W=>T(I(W))))}findLast(I){let T;return this.iterate(W=>(I(W)&&(T=W),!0)),T}findLastMaxBy(I){let T,W=!0;return this.iterate(H=>((W||N.isGreaterThan(I(H,T)))&&(W=!1,T=H),!0)),T}}i.CallbackIterable=q,q.empty=new q(k=>{})}),X(Q[23],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CachedFunction=i.LRUCachedFunction=void 0;class A{constructor(l){this.c=l,this.a=void 0,this.b=void 0}get(l){const p=JSON.stringify(l);return this.b!==p&&(this.b=p,this.a=this.c(l)),this.a}}i.LRUCachedFunction=A;class e{get cachedValues(){return this.a}constructor(l){this.b=l,this.a=new Map}get(l){if(this.a.has(l))return this.a.get(l);const p=this.b(l);return this.a.set(l,p),p}}i.CachedFunction=e}),X(Q[24],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CSSIcon=i.Codicon=i.getCodiconAriaLabel=void 0;function A(l){return l?l.replace(/\$\((.*?)\)/g,(p,v)=>` ${v} `).trim():""}i.getCodiconAriaLabel=A;class e{constructor(p,v,o){this.id=p,this.fontCharacter=v,this.description=o,e.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e.a}}i.Codicon=e,e.a=[],e.add=new e("add","\\ea60"),e.plus=new e("plus",e.add.fontCharacter),e.gistNew=new e("gist-new",e.add.fontCharacter),e.repoCreate=new e("repo-create",e.add.fontCharacter),e.lightbulb=new e("lightbulb","\\ea61"),e.lightBulb=new e("light-bulb","\\ea61"),e.repo=new e("repo","\\ea62"),e.repoDelete=new e("repo-delete","\\ea62"),e.gistFork=new e("gist-fork","\\ea63"),e.repoForked=new e("repo-forked","\\ea63"),e.gitPullRequest=new e("git-pull-request","\\ea64"),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned","\\ea64"),e.recordKeys=new e("record-keys","\\ea65"),e.keyboard=new e("keyboard","\\ea65"),e.tag=new e("tag","\\ea66"),e.tagAdd=new e("tag-add","\\ea66"),e.tagRemove=new e("tag-remove","\\ea66"),e.person=new e("person","\\ea67"),e.personFollow=new e("person-follow","\\ea67"),e.personOutline=new e("person-outline","\\ea67"),e.personFilled=new e("person-filled","\\ea67"),e.gitBranch=new e("git-branch","\\ea68"),e.gitBranchCreate=new e("git-branch-create","\\ea68"),e.gitBranchDelete=new e("git-branch-delete","\\ea68"),e.sourceControl=new e("source-control","\\ea68"),e.mirror=new e("mirror","\\ea69"),e.mirrorPublic=new e("mirror-public","\\ea69"),e.star=new e("star","\\ea6a"),e.starAdd=new e("star-add","\\ea6a"),e.starDelete=new e("star-delete","\\ea6a"),e.starEmpty=new e("star-empty","\\ea6a"),e.comment=new e("comment","\\ea6b"),e.commentAdd=new e("comment-add","\\ea6b"),e.alert=new e("alert","\\ea6c"),e.warning=new e("warning","\\ea6c"),e.search=new e("search","\\ea6d"),e.searchSave=new e("search-save","\\ea6d"),e.logOut=new e("log-out","\\ea6e"),e.signOut=new e("sign-out","\\ea6e"),e.logIn=new e("log-in","\\ea6f"),e.signIn=new e("sign-in","\\ea6f"),e.eye=new e("eye","\\ea70"),e.eyeUnwatch=new e("eye-unwatch","\\ea70"),e.eyeWatch=new e("eye-watch","\\ea70"),e.circleFilled=new e("circle-filled","\\ea71"),e.primitiveDot=new e("primitive-dot",e.circleFilled.fontCharacter),e.closeDirty=new e("close-dirty",e.circleFilled.fontCharacter),e.debugBreakpoint=new e("debug-breakpoint",e.circleFilled.fontCharacter),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",e.circleFilled.fontCharacter),e.debugHint=new e("debug-hint",e.circleFilled.fontCharacter),e.primitiveSquare=new e("primitive-square","\\ea72"),e.edit=new e("edit","\\ea73"),e.pencil=new e("pencil","\\ea73"),e.info=new e("info","\\ea74"),e.issueOpened=new e("issue-opened","\\ea74"),e.gistPrivate=new e("gist-private","\\ea75"),e.gitForkPrivate=new e("git-fork-private","\\ea75"),e.lock=new e("lock","\\ea75"),e.mirrorPrivate=new e("mirror-private","\\ea75"),e.close=new e("close","\\ea76"),e.removeClose=new e("remove-close","\\ea76"),e.x=new e("x","\\ea76"),e.repoSync=new e("repo-sync","\\ea77"),e.sync=new e("sync","\\ea77"),e.clone=new e("clone","\\ea78"),e.desktopDownload=new e("desktop-download","\\ea78"),e.beaker=new e("beaker","\\ea79"),e.microscope=new e("microscope","\\ea79"),e.vm=new e("vm","\\ea7a"),e.deviceDesktop=new e("device-desktop","\\ea7a"),e.file=new e("file","\\ea7b"),e.fileText=new e("file-text","\\ea7b"),e.more=new e("more","\\ea7c"),e.ellipsis=new e("ellipsis","\\ea7c"),e.kebabHorizontal=new e("kebab-horizontal","\\ea7c"),e.mailReply=new e("mail-reply","\\ea7d"),e.reply=new e("reply","\\ea7d"),e.organization=new e("organization","\\ea7e"),e.organizationFilled=new e("organization-filled","\\ea7e"),e.organizationOutline=new e("organization-outline","\\ea7e"),e.newFile=new e("new-file","\\ea7f"),e.fileAdd=new e("file-add","\\ea7f"),e.newFolder=new e("new-folder","\\ea80"),e.fileDirectoryCreate=new e("file-directory-create","\\ea80"),e.trash=new e("trash","\\ea81"),e.trashcan=new e("trashcan","\\ea81"),e.history=new e("history","\\ea82"),e.clock=new e("clock","\\ea82"),e.folder=new e("folder","\\ea83"),e.fileDirectory=new e("file-directory","\\ea83"),e.symbolFolder=new e("symbol-folder","\\ea83"),e.logoGithub=new e("logo-github","\\ea84"),e.markGithub=new e("mark-github","\\ea84"),e.github=new e("github","\\ea84"),e.terminal=new e("terminal","\\ea85"),e.console=new e("console","\\ea85"),e.repl=new e("repl","\\ea85"),e.zap=new e("zap","\\ea86"),e.symbolEvent=new e("symbol-event","\\ea86"),e.error=new e("error","\\ea87"),e.stop=new e("stop","\\ea87"),e.variable=new e("variable","\\ea88"),e.symbolVariable=new e("symbol-variable","\\ea88"),e.array=new e("array","\\ea8a"),e.symbolArray=new e("symbol-array","\\ea8a"),e.symbolModule=new e("symbol-module","\\ea8b"),e.symbolPackage=new e("symbol-package","\\ea8b"),e.symbolNamespace=new e("symbol-namespace","\\ea8b"),e.symbolObject=new e("symbol-object","\\ea8b"),e.symbolMethod=new e("symbol-method","\\ea8c"),e.symbolFunction=new e("symbol-function","\\ea8c"),e.symbolConstructor=new e("symbol-constructor","\\ea8c"),e.symbolBoolean=new e("symbol-boolean","\\ea8f"),e.symbolNull=new e("symbol-null","\\ea8f"),e.symbolNumeric=new e("symbol-numeric","\\ea90"),e.symbolNumber=new e("symbol-number","\\ea90"),e.symbolStructure=new e("symbol-structure","\\ea91"),e.symbolStruct=new e("symbol-struct","\\ea91"),e.symbolParameter=new e("symbol-parameter","\\ea92"),e.symbolTypeParameter=new e("symbol-type-parameter","\\ea92"),e.symbolKey=new e("symbol-key","\\ea93"),e.symbolText=new e("symbol-text","\\ea93"),e.symbolReference=new e("symbol-reference","\\ea94"),e.goToFile=new e("go-to-file","\\ea94"),e.symbolEnum=new e("symbol-enum","\\ea95"),e.symbolValue=new e("symbol-value","\\ea95"),e.symbolRuler=new e("symbol-ruler","\\ea96"),e.symbolUnit=new e("symbol-unit","\\ea96"),e.activateBreakpoints=new e("activate-breakpoints","\\ea97"),e.archive=new e("archive","\\ea98"),e.arrowBoth=new e("arrow-both","\\ea99"),e.arrowDown=new e("arrow-down","\\ea9a"),e.arrowLeft=new e("arrow-left","\\ea9b"),e.arrowRight=new e("arrow-right","\\ea9c"),e.arrowSmallDown=new e("arrow-small-down","\\ea9d"),e.arrowSmallLeft=new e("arrow-small-left","\\ea9e"),e.arrowSmallRight=new e("arrow-small-right","\\ea9f"),e.arrowSmallUp=new e("arrow-small-up","\\eaa0"),e.arrowUp=new e("arrow-up","\\eaa1"),e.bell=new e("bell","\\eaa2"),e.bold=new e("bold","\\eaa3"),e.book=new e("book","\\eaa4"),e.bookmark=new e("bookmark","\\eaa5"),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified","\\eaa6"),e.debugBreakpointConditional=new e("debug-breakpoint-conditional","\\eaa7"),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled","\\eaa7"),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified","\\eaa8"),e.debugBreakpointData=new e("debug-breakpoint-data","\\eaa9"),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled","\\eaa9"),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified","\\eaaa"),e.debugBreakpointLog=new e("debug-breakpoint-log","\\eaab"),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled","\\eaab"),e.briefcase=new e("briefcase","\\eaac"),e.broadcast=new e("broadcast","\\eaad"),e.browser=new e("browser","\\eaae"),e.bug=new e("bug","\\eaaf"),e.calendar=new e("calendar","\\eab0"),e.caseSensitive=new e("case-sensitive","\\eab1"),e.check=new e("check","\\eab2"),e.checklist=new e("checklist","\\eab3"),e.chevronDown=new e("chevron-down","\\eab4"),e.dropDownButton=new e("drop-down-button",e.chevronDown.fontCharacter),e.chevronLeft=new e("chevron-left","\\eab5"),e.chevronRight=new e("chevron-right","\\eab6"),e.chevronUp=new e("chevron-up","\\eab7"),e.chromeClose=new e("chrome-close","\\eab8"),e.chromeMaximize=new e("chrome-maximize","\\eab9"),e.chromeMinimize=new e("chrome-minimize","\\eaba"),e.chromeRestore=new e("chrome-restore","\\eabb"),e.circle=new e("circle","\\eabc"),e.circleOutline=new e("circle-outline",e.circle.fontCharacter),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",e.circle.fontCharacter),e.circleSlash=new e("circle-slash","\\eabd"),e.circuitBoard=new e("circuit-board","\\eabe"),e.clearAll=new e("clear-all","\\eabf"),e.clippy=new e("clippy","\\eac0"),e.closeAll=new e("close-all","\\eac1"),e.cloudDownload=new e("cloud-download","\\eac2"),e.cloudUpload=new e("cloud-upload","\\eac3"),e.code=new e("code","\\eac4"),e.collapseAll=new e("collapse-all","\\eac5"),e.colorMode=new e("color-mode","\\eac6"),e.commentDiscussion=new e("comment-discussion","\\eac7"),e.compareChanges=new e("compare-changes","\\eafd"),e.creditCard=new e("credit-card","\\eac9"),e.dash=new e("dash","\\eacc"),e.dashboard=new e("dashboard","\\eacd"),e.database=new e("database","\\eace"),e.debugContinue=new e("debug-continue","\\eacf"),e.debugDisconnect=new e("debug-disconnect","\\ead0"),e.debugPause=new e("debug-pause","\\ead1"),e.debugRestart=new e("debug-restart","\\ead2"),e.debugStart=new e("debug-start","\\ead3"),e.debugStepInto=new e("debug-step-into","\\ead4"),e.debugStepOut=new e("debug-step-out","\\ead5"),e.debugStepOver=new e("debug-step-over","\\ead6"),e.debugStop=new e("debug-stop","\\ead7"),e.debug=new e("debug","\\ead8"),e.deviceCameraVideo=new e("device-camera-video","\\ead9"),e.deviceCamera=new e("device-camera","\\eada"),e.deviceMobile=new e("device-mobile","\\eadb"),e.diffAdded=new e("diff-added","\\eadc"),e.diffIgnored=new e("diff-ignored","\\eadd"),e.diffModified=new e("diff-modified","\\eade"),e.diffRemoved=new e("diff-removed","\\eadf"),e.diffRenamed=new e("diff-renamed","\\eae0"),e.diff=new e("diff","\\eae1"),e.discard=new e("discard","\\eae2"),e.editorLayout=new e("editor-layout","\\eae3"),e.emptyWindow=new e("empty-window","\\eae4"),e.exclude=new e("exclude","\\eae5"),e.extensions=new e("extensions","\\eae6"),e.eyeClosed=new e("eye-closed","\\eae7"),e.fileBinary=new e("file-binary","\\eae8"),e.fileCode=new e("file-code","\\eae9"),e.fileMedia=new e("file-media","\\eaea"),e.filePdf=new e("file-pdf","\\eaeb"),e.fileSubmodule=new e("file-submodule","\\eaec"),e.fileSymlinkDirectory=new e("file-symlink-directory","\\eaed"),e.fileSymlinkFile=new e("file-symlink-file","\\eaee"),e.fileZip=new e("file-zip","\\eaef"),e.files=new e("files","\\eaf0"),e.filter=new e("filter","\\eaf1"),e.flame=new e("flame","\\eaf2"),e.foldDown=new e("fold-down","\\eaf3"),e.foldUp=new e("fold-up","\\eaf4"),e.fold=new e("fold","\\eaf5"),e.folderActive=new e("folder-active","\\eaf6"),e.folderOpened=new e("folder-opened","\\eaf7"),e.gear=new e("gear","\\eaf8"),e.gift=new e("gift","\\eaf9"),e.gistSecret=new e("gist-secret","\\eafa"),e.gist=new e("gist","\\eafb"),e.gitCommit=new e("git-commit","\\eafc"),e.gitCompare=new e("git-compare","\\eafd"),e.gitMerge=new e("git-merge","\\eafe"),e.githubAction=new e("github-action","\\eaff"),e.githubAlt=new e("github-alt","\\eb00"),e.globe=new e("globe","\\eb01"),e.grabber=new e("grabber","\\eb02"),e.graph=new e("graph","\\eb03"),e.gripper=new e("gripper","\\eb04"),e.heart=new e("heart","\\eb05"),e.home=new e("home","\\eb06"),e.horizontalRule=new e("horizontal-rule","\\eb07"),e.hubot=new e("hubot","\\eb08"),e.inbox=new e("inbox","\\eb09"),e.issueClosed=new e("issue-closed","\\eba4"),e.issueReopened=new e("issue-reopened","\\eb0b"),e.issues=new e("issues","\\eb0c"),e.italic=new e("italic","\\eb0d"),e.jersey=new e("jersey","\\eb0e"),e.json=new e("json","\\eb0f"),e.kebabVertical=new e("kebab-vertical","\\eb10"),e.key=new e("key","\\eb11"),e.law=new e("law","\\eb12"),e.lightbulbAutofix=new e("lightbulb-autofix","\\eb13"),e.linkExternal=new e("link-external","\\eb14"),e.link=new e("link","\\eb15"),e.listOrdered=new e("list-ordered","\\eb16"),e.listUnordered=new e("list-unordered","\\eb17"),e.liveShare=new e("live-share","\\eb18"),e.loading=new e("loading","\\eb19"),e.location=new e("location","\\eb1a"),e.mailRead=new e("mail-read","\\eb1b"),e.mail=new e("mail","\\eb1c"),e.markdown=new e("markdown","\\eb1d"),e.megaphone=new e("megaphone","\\eb1e"),e.mention=new e("mention","\\eb1f"),e.milestone=new e("milestone","\\eb20"),e.mortarBoard=new e("mortar-board","\\eb21"),e.move=new e("move","\\eb22"),e.multipleWindows=new e("multiple-windows","\\eb23"),e.mute=new e("mute","\\eb24"),e.noNewline=new e("no-newline","\\eb25"),e.note=new e("note","\\eb26"),e.octoface=new e("octoface","\\eb27"),e.openPreview=new e("open-preview","\\eb28"),e.package_=new e("package","\\eb29"),e.paintcan=new e("paintcan","\\eb2a"),e.pin=new e("pin","\\eb2b"),e.play=new e("play","\\eb2c"),e.run=new e("run","\\eb2c"),e.plug=new e("plug","\\eb2d"),e.preserveCase=new e("preserve-case","\\eb2e"),e.preview=new e("preview","\\eb2f"),e.project=new e("project","\\eb30"),e.pulse=new e("pulse","\\eb31"),e.question=new e("question","\\eb32"),e.quote=new e("quote","\\eb33"),e.radioTower=new e("radio-tower","\\eb34"),e.reactions=new e("reactions","\\eb35"),e.references=new e("references","\\eb36"),e.refresh=new e("refresh","\\eb37"),e.regex=new e("regex","\\eb38"),e.remoteExplorer=new e("remote-explorer","\\eb39"),e.remote=new e("remote","\\eb3a"),e.remove=new e("remove","\\eb3b"),e.replaceAll=new e("replace-all","\\eb3c"),e.replace=new e("replace","\\eb3d"),e.repoClone=new e("repo-clone","\\eb3e"),e.repoForcePush=new e("repo-force-push","\\eb3f"),e.repoPull=new e("repo-pull","\\eb40"),e.repoPush=new e("repo-push","\\eb41"),e.report=new e("report","\\eb42"),e.requestChanges=new e("request-changes","\\eb43"),e.rocket=new e("rocket","\\eb44"),e.rootFolderOpened=new e("root-folder-opened","\\eb45"),e.rootFolder=new e("root-folder","\\eb46"),e.rss=new e("rss","\\eb47"),e.ruby=new e("ruby","\\eb48"),e.saveAll=new e("save-all","\\eb49"),e.saveAs=new e("save-as","\\eb4a"),e.save=new e("save","\\eb4b"),e.screenFull=new e("screen-full","\\eb4c"),e.screenNormal=new e("screen-normal","\\eb4d"),e.searchStop=new e("search-stop","\\eb4e"),e.server=new e("server","\\eb50"),e.settingsGear=new e("settings-gear","\\eb51"),e.settings=new e("settings","\\eb52"),e.shield=new e("shield","\\eb53"),e.smiley=new e("smiley","\\eb54"),e.sortPrecedence=new e("sort-precedence","\\eb55"),e.splitHorizontal=new e("split-horizontal","\\eb56"),e.splitVertical=new e("split-vertical","\\eb57"),e.squirrel=new e("squirrel","\\eb58"),e.starFull=new e("star-full","\\eb59"),e.starHalf=new e("star-half","\\eb5a"),e.symbolClass=new e("symbol-class","\\eb5b"),e.symbolColor=new e("symbol-color","\\eb5c"),e.symbolCustomColor=new e("symbol-customcolor","\\eb5c"),e.symbolConstant=new e("symbol-constant","\\eb5d"),e.symbolEnumMember=new e("symbol-enum-member","\\eb5e"),e.symbolField=new e("symbol-field","\\eb5f"),e.symbolFile=new e("symbol-file","\\eb60"),e.symbolInterface=new e("symbol-interface","\\eb61"),e.symbolKeyword=new e("symbol-keyword","\\eb62"),e.symbolMisc=new e("symbol-misc","\\eb63"),e.symbolOperator=new e("symbol-operator","\\eb64"),e.symbolProperty=new e("symbol-property","\\eb65"),e.wrench=new e("wrench","\\eb65"),e.wrenchSubaction=new e("wrench-subaction","\\eb65"),e.symbolSnippet=new e("symbol-snippet","\\eb66"),e.tasklist=new e("tasklist","\\eb67"),e.telescope=new e("telescope","\\eb68"),e.textSize=new e("text-size","\\eb69"),e.threeBars=new e("three-bars","\\eb6a"),e.thumbsdown=new e("thumbsdown","\\eb6b"),e.thumbsup=new e("thumbsup","\\eb6c"),e.tools=new e("tools","\\eb6d"),e.triangleDown=new e("triangle-down","\\eb6e"),e.triangleLeft=new e("triangle-left","\\eb6f"),e.triangleRight=new e("triangle-right","\\eb70"),e.triangleUp=new e("triangle-up","\\eb71"),e.twitter=new e("twitter","\\eb72"),e.unfold=new e("unfold","\\eb73"),e.unlock=new e("unlock","\\eb74"),e.unmute=new e("unmute","\\eb75"),e.unverified=new e("unverified","\\eb76"),e.verified=new e("verified","\\eb77"),e.versions=new e("versions","\\eb78"),e.vmActive=new e("vm-active","\\eb79"),e.vmOutline=new e("vm-outline","\\eb7a"),e.vmRunning=new e("vm-running","\\eb7b"),e.watch=new e("watch","\\eb7c"),e.whitespace=new e("whitespace","\\eb7d"),e.wholeWord=new e("whole-word","\\eb7e"),e.window=new e("window","\\eb7f"),e.wordWrap=new e("word-wrap","\\eb80"),e.zoomIn=new e("zoom-in","\\eb81"),e.zoomOut=new e("zoom-out","\\eb82"),e.listFilter=new e("list-filter","\\eb83"),e.listFlat=new e("list-flat","\\eb84"),e.listSelection=new e("list-selection","\\eb85"),e.selection=new e("selection","\\eb85"),e.listTree=new e("list-tree","\\eb86"),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified","\\eb87"),e.debugBreakpointFunction=new e("debug-breakpoint-function","\\eb88"),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled","\\eb88"),e.debugStackframeActive=new e("debug-stackframe-active","\\eb89"),e.circleSmallFilled=new e("circle-small-filled","\\eb8a"),e.debugStackframeDot=new e("debug-stackframe-dot",e.circleSmallFilled.fontCharacter),e.debugStackframe=new e("debug-stackframe","\\eb8b"),e.debugStackframeFocused=new e("debug-stackframe-focused","\\eb8b"),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported","\\eb8c"),e.symbolString=new e("symbol-string","\\eb8d"),e.debugReverseContinue=new e("debug-reverse-continue","\\eb8e"),e.debugStepBack=new e("debug-step-back","\\eb8f"),e.debugRestartFrame=new e("debug-restart-frame","\\eb90"),e.callIncoming=new e("call-incoming","\\eb92"),e.callOutgoing=new e("call-outgoing","\\eb93"),e.menu=new e("menu","\\eb94"),e.expandAll=new e("expand-all","\\eb95"),e.feedback=new e("feedback","\\eb96"),e.groupByRefType=new e("group-by-ref-type","\\eb97"),e.ungroupByRefType=new e("ungroup-by-ref-type","\\eb98"),e.account=new e("account","\\eb99"),e.bellDot=new e("bell-dot","\\eb9a"),e.debugConsole=new e("debug-console","\\eb9b"),e.library=new e("library","\\eb9c"),e.output=new e("output","\\eb9d"),e.runAll=new e("run-all","\\eb9e"),e.syncIgnored=new e("sync-ignored","\\eb9f"),e.pinned=new e("pinned","\\eba0"),e.githubInverted=new e("github-inverted","\\eba1"),e.debugAlt=new e("debug-alt","\\eb91"),e.serverProcess=new e("server-process","\\eba2"),e.serverEnvironment=new e("server-environment","\\eba3"),e.pass=new e("pass","\\eba4"),e.stopCircle=new e("stop-circle","\\eba5"),e.playCircle=new e("play-circle","\\eba6"),e.record=new e("record","\\eba7"),e.debugAltSmall=new e("debug-alt-small","\\eba8"),e.vmConnect=new e("vm-connect","\\eba9"),e.cloud=new e("cloud","\\ebaa"),e.merge=new e("merge","\\ebab"),e.exportIcon=new e("export","\\ebac"),e.graphLeft=new e("graph-left","\\ebad"),e.magnet=new e("magnet","\\ebae"),e.notebook=new e("notebook","\\ebaf"),e.redo=new e("redo","\\ebb0"),e.checkAll=new e("check-all","\\ebb1"),e.pinnedDirty=new e("pinned-dirty","\\ebb2"),e.passFilled=new e("pass-filled","\\ebb3"),e.circleLargeFilled=new e("circle-large-filled","\\ebb4"),e.circleLarge=new e("circle-large","\\ebb5"),e.circleLargeOutline=new e("circle-large-outline",e.circleLarge.fontCharacter),e.combine=new e("combine","\\ebb6"),e.gather=new e("gather","\\ebb6"),e.table=new e("table","\\ebb7"),e.variableGroup=new e("variable-group","\\ebb8"),e.typeHierarchy=new e("type-hierarchy","\\ebb9"),e.typeHierarchySub=new e("type-hierarchy-sub","\\ebba"),e.typeHierarchySuper=new e("type-hierarchy-super","\\ebbb"),e.gitPullRequestCreate=new e("git-pull-request-create","\\ebbc"),e.runAbove=new e("run-above","\\ebbd"),e.runBelow=new e("run-below","\\ebbe"),e.notebookTemplate=new e("notebook-template","\\ebbf"),e.debugRerun=new e("debug-rerun","\\ebc0"),e.workspaceTrusted=new e("workspace-trusted","\\ebc1"),e.workspaceUntrusted=new e("workspace-untrusted","\\ebc2"),e.workspaceUnspecified=new e("workspace-unspecified","\\ebc3"),e.terminalCmd=new e("terminal-cmd","\\ebc4"),e.terminalDebian=new e("terminal-debian","\\ebc5"),e.terminalLinux=new e("terminal-linux","\\ebc6"),e.terminalPowershell=new e("terminal-powershell","\\ebc7"),e.terminalTmux=new e("terminal-tmux","\\ebc8"),e.terminalUbuntu=new e("terminal-ubuntu","\\ebc9"),e.terminalBash=new e("terminal-bash","\\ebca"),e.arrowSwap=new e("arrow-swap","\\ebcb"),e.copy=new e("copy","\\ebcc"),e.personAdd=new e("person-add","\\ebcd"),e.filterFilled=new e("filter-filled","\\ebce"),e.wand=new e("wand","\\ebcf"),e.debugLineByLine=new e("debug-line-by-line","\\ebd0"),e.inspect=new e("inspect","\\ebd1"),e.layers=new e("layers","\\ebd2"),e.layersDot=new e("layers-dot","\\ebd3"),e.layersActive=new e("layers-active","\\ebd4"),e.compass=new e("compass","\\ebd5"),e.compassDot=new e("compass-dot","\\ebd6"),e.compassActive=new e("compass-active","\\ebd7"),e.azure=new e("azure","\\ebd8"),e.issueDraft=new e("issue-draft","\\ebd9"),e.gitPullRequestClosed=new e("git-pull-request-closed","\\ebda"),e.gitPullRequestDraft=new e("git-pull-request-draft","\\ebdb"),e.debugAll=new e("debug-all","\\ebdc"),e.debugCoverage=new e("debug-coverage","\\ebdd"),e.runErrors=new e("run-errors","\\ebde"),e.folderLibrary=new e("folder-library","\\ebdf"),e.debugContinueSmall=new e("debug-continue-small","\\ebe0"),e.beakerStop=new e("beaker-stop","\\ebe1"),e.graphLine=new e("graph-line","\\ebe2"),e.graphScatter=new e("graph-scatter","\\ebe3"),e.pieChart=new e("pie-chart","\\ebe4"),e.bracket=new e("bracket",e.json.fontCharacter),e.bracketDot=new e("bracket-dot","\\ebe5"),e.bracketError=new e("bracket-error","\\ebe6"),e.lockSmall=new e("lock-small","\\ebe7"),e.azureDevops=new e("azure-devops","\\ebe8"),e.verifiedFilled=new e("verified-filled","\\ebe9"),e.newLine=new e("newline","\\ebea"),e.layout=new e("layout","\\ebeb"),e.layoutActivitybarLeft=new e("layout-activitybar-left","\\ebec"),e.layoutActivitybarRight=new e("layout-activitybar-right","\\ebed"),e.layoutPanelLeft=new e("layout-panel-left","\\ebee"),e.layoutPanelCenter=new e("layout-panel-center","\\ebef"),e.layoutPanelJustify=new e("layout-panel-justify","\\ebf0"),e.layoutPanelRight=new e("layout-panel-right","\\ebf1"),e.layoutPanel=new e("layout-panel","\\ebf2"),e.layoutSidebarLeft=new e("layout-sidebar-left","\\ebf3"),e.layoutSidebarRight=new e("layout-sidebar-right","\\ebf4"),e.layoutStatusbar=new e("layout-statusbar","\\ebf5"),e.layoutMenubar=new e("layout-menubar","\\ebf6"),e.layoutCentered=new e("layout-centered","\\ebf7"),e.layoutSidebarRightOff=new e("layout-sidebar-right-off","\\ec00"),e.layoutPanelOff=new e("layout-panel-off","\\ec01"),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off","\\ec02"),e.target=new e("target","\\ebf8"),e.indent=new e("indent","\\ebf9"),e.recordSmall=new e("record-small","\\ebfa"),e.errorSmall=new e("error-small","\\ebfb"),e.arrowCircleDown=new e("arrow-circle-down","\\ebfc"),e.arrowCircleLeft=new e("arrow-circle-left","\\ebfd"),e.arrowCircleRight=new e("arrow-circle-right","\\ebfe"),e.arrowCircleUp=new e("arrow-circle-up","\\ebff"),e.heartFilled=new e("heart-filled","\\ec04"),e.map=new e("map","\\ec05"),e.mapFilled=new e("map-filled","\\ec06"),e.circleSmall=new e("circle-small","\\ec07"),e.bellSlash=new e("bell-slash","\\ec08"),e.bellSlashDot=new e("bell-slash-dot","\\ec09"),e.commentUnresolved=new e("comment-unresolved","\\ec0a"),e.gitPullRequestGoToChanges=new e("git-pull-request-go-to-changes","\\ec0b"),e.gitPullRequestNewChanges=new e("git-pull-request-new-changes","\\ec0c"),e.searchFuzzy=new e("search-fuzzy","\\ec0d"),e.commentDraft=new e("comment-draft","\\ec0e"),e.dialogError=new e("dialog-error",e.error.fontCharacter),e.dialogWarning=new e("dialog-warning",e.warning.fontCharacter),e.dialogInfo=new e("dialog-info",e.info.fontCharacter),e.dialogClose=new e("dialog-close",e.close.fontCharacter),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.fontCharacter),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.fontCharacter),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.fontCharacter),e.treeFilterClear=new e("tree-filter-clear",e.close.fontCharacter),e.treeItemLoading=new e("tree-item-loading",e.loading.fontCharacter),e.menuSelection=new e("menu-selection",e.check.fontCharacter),e.menuSubmenu=new e("menu-submenu",e.chevronRight.fontCharacter),e.menuBarMore=new e("menubar-more",e.more.fontCharacter),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.fontCharacter),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.fontCharacter),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.fontCharacter),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.fontCharacter),e.toolBarMore=new e("toolbar-more",e.more.fontCharacter),e.quickInputBack=new e("quick-input-back",e.arrowLeft.fontCharacter);var E;(function(l){l.iconNameSegment="[A-Za-z0-9]+",l.iconNameExpression="[A-Za-z0-9-]+",l.iconModifierExpression="~[A-Za-z]+",l.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${l.iconNameExpression})(${l.iconModifierExpression})?$`);function v(S){if(S instanceof e)return["codicon","codicon-"+S.id];const t=p.exec(S.id);if(!t)return v(e.error);const[,w,h]=t,m=["codicon","codicon-"+w];return h&&m.push("codicon-modifier-"+h.substring(1)),m}l.asClassNameArray=v;function o(S){return v(S).join(" ")}l.asClassName=o;function f(S){return"."+v(S).join(".")}l.asCSSSelector=f})(E=i.CSSIcon||(i.CSSIcon={}))}),X(Q[25],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffChange=void 0;class A{constructor(E,l,p,v){this.originalStart=E,this.originalLength=l,this.modifiedStart=p,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.DiffChange=A}),X(Q[8],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BugIndicatingError=i.ErrorNoTelemetry=i.NotSupportedError=i.illegalState=i.illegalArgument=i.canceled=i.CancellationError=i.isCancellationError=i.transformErrorForSerialization=i.onUnexpectedExternalError=i.onUnexpectedError=i.errorHandler=i.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(y){setTimeout(()=>{throw y.stack?h.isErrorNoTelemetry(y)?new h(y.message+`

`+y.stack):new Error(y.message+`

`+y.stack):y},0)}}c(y){this.b.forEach(_=>{_(y)})}onUnexpectedError(y){this.a(y),this.c(y)}onUnexpectedExternalError(y){this.a(y)}}i.ErrorHandler=A,i.errorHandler=new A;function e(L){v(L)||i.errorHandler.onUnexpectedError(L)}i.onUnexpectedError=e;function E(L){v(L)||i.errorHandler.onUnexpectedExternalError(L)}i.onUnexpectedExternalError=E;function l(L){if(L instanceof Error){const{name:y,message:_}=L,g=L.stacktrace||L.stack;return{$isError:!0,name:y,message:_,stack:g,noTelemetry:h.isErrorNoTelemetry(L)}}return L}i.transformErrorForSerialization=l;const p="Canceled";function v(L){return L instanceof o?!0:L instanceof Error&&L.name===p&&L.message===p}i.isCancellationError=v;class o extends Error{constructor(){super(p),this.name=this.message}}i.CancellationError=o;function f(){const L=new Error(p);return L.name=L.message,L}i.canceled=f;function S(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}i.illegalArgument=S;function t(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}i.illegalState=t;class w extends Error{constructor(y){super("NotSupported"),y&&(this.message=y)}}i.NotSupportedError=w;class h extends Error{constructor(y){super(y),this.name="CodeExpectedError"}static fromError(y){if(y instanceof h)return y;const _=new h;return _.message=y.message,_.stack=y.stack,_}static isErrorNoTelemetry(y){return y.name==="CodeExpectedError"}}i.ErrorNoTelemetry=h;class m extends Error{constructor(y){super(y||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}i.BugIndicatingError=m}),X(Q[9],J([0,1,8]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.checkAdjacentItems=i.assertFn=i.assertNever=i.ok=void 0;function e(v,o){if(!v)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}i.ok=e;function E(v,o="Unreachable"){throw new Error(o)}i.assertNever=E;function l(v){if(!v()){debugger;v(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}i.assertFn=l;function p(v,o){let f=0;for(;f<v.length-1;){const S=v[f],t=v[f+1];if(!o(S,t))return!1;f++}return!0}i.checkAdjacentItems=p}),X(Q[26],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.once=void 0;function A(e){const E=this;let l=!1,p;return function(){return l||(l=!0,p=e.apply(E,arguments)),p}}i.once=A}),X(Q[13],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var A;(function(e){function E(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}e.is=E;const l=Object.freeze([]);function p(){return l}e.empty=p;function*v(u){yield u}e.single=v;function o(u){return E(u)?u:v(u)}e.wrap=o;function f(u){return u||l}e.from=f;function S(u){return!u||u[Symbol.iterator]().next().done===!0}e.isEmpty=S;function t(u){return u[Symbol.iterator]().next().value}e.first=t;function w(u,d){for(const s of u)if(d(s))return!0;return!1}e.some=w;function h(u,d){for(const s of u)if(d(s))return s}e.find=h;function*m(u,d){for(const s of u)d(s)&&(yield s)}e.filter=m;function*L(u,d){let s=0;for(const a of u)yield d(a,s++)}e.map=L;function*y(...u){for(const d of u)for(const s of d)yield s}e.concat=y;function _(u,d,s){let a=s;for(const r of u)a=d(a,r);return a}e.reduce=_;function*g(u,d,s=u.length){for(d<0&&(d+=u.length),s<0?s+=u.length:s>u.length&&(s=u.length);d<s;d++)yield u[d]}e.slice=g;function C(u,d=Number.POSITIVE_INFINITY){const s=[];if(d===0)return[s,u];const a=u[Symbol.iterator]();for(let r=0;r<d;r++){const c=a.next();if(c.done)return[s,e.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return a}}]}e.consume=C})(A=i.Iterable||(i.Iterable={}))}),X(Q[27],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyChord=i.KeyCodeUtils=i.IMMUTABLE_KEY_CODE_TO_CODE=i.IMMUTABLE_CODE_TO_KEY_CODE=i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=i.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,h){this._keyCodeToStr[w]=h,this._strToKeyCode[h.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const e=new A,E=new A,l=new A;i.EVENT_KEY_CODE_MAP=new Array(230),i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],v=Object.create(null),o=Object.create(null);i.IMMUTABLE_CODE_TO_KEY_CODE=[],i.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)i.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)i.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],h=[],m=[];for(const L of w){const[y,_,g,C,u,d,s,a,r,c]=L;if(m[g]||(m[g]=!0,p[g]=C,v[C]=g,o[C.toLowerCase()]=g,_&&(i.IMMUTABLE_CODE_TO_KEY_CODE[g]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(i.IMMUTABLE_KEY_CODE_TO_CODE[u]=g))),!h[u]){if(h[u]=!0,!d)throw new Error(`String representation missing for key code ${u} around scan code ${C}`);e.define(u,d),E.define(u,r||d),l.define(u,c||r||d)}s&&(i.EVENT_KEY_CODE_MAP[s]=u),a&&(i.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=u)}i.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var f;(function(t){function w(g){return e.keyCodeToStr(g)}t.toString=w;function h(g){return e.strToKeyCode(g)}t.fromString=h;function m(g){return E.keyCodeToStr(g)}t.toUserSettingsUS=m;function L(g){return l.keyCodeToStr(g)}t.toUserSettingsGeneral=L;function y(g){return E.strToKeyCode(g)||l.strToKeyCode(g)}t.fromUserSettings=y;function _(g){if(g>=93&&g<=108)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(g)}t.toElectronAccelerator=_})(f=i.KeyCodeUtils||(i.KeyCodeUtils={}));function S(t,w){const h=(w&65535)<<16>>>0;return(t|h)>>>0}i.KeyChord=S}),X(Q[28],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Lazy=void 0;class A{constructor(E){this.d=E,this.a=!1}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.Lazy=A}),X(Q[10],J([0,1,26,13]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DisposableMap=i.ImmortalReference=i.SafeDisposable=i.RefCountedDisposable=i.MutableDisposable=i.Disposable=i.DisposableStore=i.toDisposable=i.combinedDisposable=i.dispose=i.isDisposable=i.markAsSingleton=i.setDisposableTracker=void 0;const E=!1;let l=null;function p(a){l=a}if(i.setDisposableTracker=p,E){const a="__is_disposable_tracked__";p(new class{trackDisposable(r){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(c)},3e3)}setParent(r,c){if(r&&r!==_.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==_.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function v(a){return l?.trackDisposable(a),a}function o(a){l?.markAsDisposed(a)}function f(a,r){l?.setParent(a,r)}function S(a,r){if(!!l)for(const c of a)l.setParent(c,r)}function t(a){return l?.markAsSingleton(a),a}i.markAsSingleton=t;function w(a){return typeof a.dispose=="function"&&a.dispose.length===0}i.isDisposable=w;function h(a){if(e.Iterable.is(a)){const r=[];for(const c of a)if(c)try{c.dispose()}catch(b){r.push(b)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}i.dispose=h;function m(...a){const r=L(()=>h(a));return S(a,r),r}i.combinedDisposable=m;function L(a){const r=v({dispose:(0,A.once)(()=>{o(r),a()})});return r}i.toDisposable=L;class y{constructor(){this.a=new Set,this.b=!1,v(this)}dispose(){this.b||(o(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(this.a.size!==0)try{h(this.a)}finally{this.a.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return f(r,this),this.b?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(r),r}}i.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this.f=new y,v(this),f(this.f,this)}dispose(){o(this),this.f.dispose()}q(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(r)}}i.Disposable=_,_.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(r){var c;this.b||r===this.a||((c=this.a)===null||c===void 0||c.dispose(),r&&f(r,this),this.a=r)}clear(){this.value=void 0}dispose(){var r;this.b=!0,o(this),(r=this.a)===null||r===void 0||r.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&f(r,null),r}}i.MutableDisposable=g;class C{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.RefCountedDisposable=C;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(r){let c=r;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,o(this))},this}}i.SafeDisposable=u;class d{constructor(r){this.object=r}dispose(){}}i.ImmortalReference=d;class s{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}get(r){return this.a.get(r)}set(r,c,b=!1){var N;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||(N=this.a.get(r))===null||N===void 0||N.dispose(),this.a.set(r,c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.DisposableMap=s}),X(Q[14],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LinkedList=void 0;class A{constructor(l){this.element=l,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class e{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let l=this.a;for(;l!==A.Undefined;){const p=l.next;l.prev=A.Undefined,l.next=A.Undefined,l=p}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(l){return this.d(l,!1)}push(l){return this.d(l,!0)}d(l,p){const v=new A(l);if(this.a===A.Undefined)this.a=v,this.b=v;else if(p){const f=this.b;this.b=v,v.prev=f,f.next=v}else{const f=this.a;this.a=v,v.next=f,f.prev=v}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(v))}}shift(){if(this.a!==A.Undefined){const l=this.a.element;return this.e(this.a),l}}pop(){if(this.b!==A.Undefined){const l=this.b.element;return this.e(this.b),l}}e(l){if(l.prev!==A.Undefined&&l.next!==A.Undefined){const p=l.prev;p.next=l.next,l.next.prev=p}else l.prev===A.Undefined&&l.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):l.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):l.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let l=this.a;for(;l!==A.Undefined;)yield l.element,l=l.next}}i.LinkedList=e}),X(Q[4],J([0,1,23,28]),function(U,i,A,e){"use strict";var E;Object.defineProperty(i,"__esModule",{value:!0}),i.InvisibleCharacters=i.AmbiguousCharacters=i.noBreakWhitespace=i.getLeftDeleteOffset=i.singleLetterHash=i.containsUppercaseCharacter=i.startsWithUTF8BOM=i.UTF8_BOM_CHARACTER=i.isEmojiImprecise=i.isFullWidthCharacter=i.containsUnusualLineTerminators=i.UNUSUAL_LINE_TERMINATORS=i.isBasicASCII=i.containsRTL=i.getCharContainingOffset=i.prevCharLength=i.nextCharLength=i.GraphemeIterator=i.CodePointIterator=i.getNextCodePoint=i.computeCodePoint=i.isLowSurrogate=i.isHighSurrogate=i.commonSuffixLength=i.commonPrefixLength=i.startsWithIgnoreCase=i.equalsIgnoreCase=i.isUpperAsciiLetter=i.isLowerAsciiLetter=i.isAsciiDigit=i.compareSubstringIgnoreCase=i.compareIgnoreCase=i.compareSubstring=i.compare=i.lastNonWhitespaceIndex=i.getLeadingWhitespace=i.firstNonWhitespaceIndex=i.splitLines=i.regExpFlags=i.regExpLeadsToEndlessLoop=i.createRegExp=i.stripWildcards=i.convertSimple2RegExpPattern=i.rtrim=i.ltrim=i.trim=i.escapeRegExpCharacters=i.escape=i.format=i.isFalsyOrWhitespace=void 0;function l(D){return!D||typeof D!="string"?!0:D.trim().length===0}i.isFalsyOrWhitespace=l;const p=/{(\d+)}/g;function v(D,...B){return B.length===0?D:D.replace(p,function(z,$){const K=parseInt($,10);return isNaN(K)||K<0||K>=B.length?z:B[K]})}i.format=v;function o(D){return D.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}i.escape=o;function f(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}i.escapeRegExpCharacters=f;function S(D,B=" "){const z=t(D,B);return w(z,B)}i.trim=S;function t(D,B){if(!D||!B)return D;const z=B.length;if(z===0||D.length===0)return D;let $=0;for(;D.indexOf(B,$)===$;)$=$+z;return D.substring($)}i.ltrim=t;function w(D,B){if(!D||!B)return D;const z=B.length,$=D.length;if(z===0||$===0)return D;let K=$,ie=-1;for(;ie=D.lastIndexOf(B,K-1),!(ie===-1||ie+z!==K);){if(ie===0)return"";K=ie}return D.substring(0,K)}i.rtrim=w;function h(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}i.convertSimple2RegExpPattern=h;function m(D){return D.replace(/\*/g,"")}i.stripWildcards=m;function L(D,B,z={}){if(!D)throw new Error("Cannot create regex from empty string");B||(D=f(D)),z.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let $="";return z.global&&($+="g"),z.matchCase||($+="i"),z.multiline&&($+="m"),z.unicode&&($+="u"),new RegExp(D,$)}i.createRegExp=L;function y(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}i.regExpLeadsToEndlessLoop=y;function _(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}i.regExpFlags=_;function g(D){return D.split(/\r\n|\r|\n/)}i.splitLines=g;function C(D){for(let B=0,z=D.length;B<z;B++){const $=D.charCodeAt(B);if($!==32&&$!==9)return B}return-1}i.firstNonWhitespaceIndex=C;function u(D,B=0,z=D.length){for(let $=B;$<z;$++){const K=D.charCodeAt($);if(K!==32&&K!==9)return D.substring(B,$)}return D.substring(B,z)}i.getLeadingWhitespace=u;function d(D,B=D.length-1){for(let z=B;z>=0;z--){const $=D.charCodeAt(z);if($!==32&&$!==9)return z}return-1}i.lastNonWhitespaceIndex=d;function s(D,B){return D<B?-1:D>B?1:0}i.compare=s;function a(D,B,z=0,$=D.length,K=0,ie=B.length){for(;z<$&&K<ie;z++,K++){const fe=D.charCodeAt(z),re=B.charCodeAt(K);if(fe<re)return-1;if(fe>re)return 1}const oe=$-z,be=ie-K;return oe<be?-1:oe>be?1:0}i.compareSubstring=a;function r(D,B){return c(D,B,0,D.length,0,B.length)}i.compareIgnoreCase=r;function c(D,B,z=0,$=D.length,K=0,ie=B.length){for(;z<$&&K<ie;z++,K++){let fe=D.charCodeAt(z),re=B.charCodeAt(K);if(fe===re)continue;if(fe>=128||re>=128)return a(D.toLowerCase(),B.toLowerCase(),z,$,K,ie);N(fe)&&(fe-=32),N(re)&&(re-=32);const ce=fe-re;if(ce!==0)return ce}const oe=$-z,be=ie-K;return oe<be?-1:oe>be?1:0}i.compareSubstringIgnoreCase=c;function b(D){return D>=48&&D<=57}i.isAsciiDigit=b;function N(D){return D>=97&&D<=122}i.isLowerAsciiLetter=N;function M(D){return D>=65&&D<=90}i.isUpperAsciiLetter=M;function R(D,B){return D.length===B.length&&c(D,B)===0}i.equalsIgnoreCase=R;function P(D,B){const z=B.length;return B.length>D.length?!1:c(D,B,0,z)===0}i.startsWithIgnoreCase=P;function F(D,B){const z=Math.min(D.length,B.length);let $;for($=0;$<z;$++)if(D.charCodeAt($)!==B.charCodeAt($))return $;return z}i.commonPrefixLength=F;function V(D,B){const z=Math.min(D.length,B.length);let $;const K=D.length-1,ie=B.length-1;for($=0;$<z;$++)if(D.charCodeAt(K-$)!==B.charCodeAt(ie-$))return $;return z}i.commonSuffixLength=V;function O(D){return 55296<=D&&D<=56319}i.isHighSurrogate=O;function q(D){return 56320<=D&&D<=57343}i.isLowSurrogate=q;function k(D,B){return(D-55296<<10)+(B-56320)+65536}i.computeCodePoint=k;function I(D,B,z){const $=D.charCodeAt(z);if(O($)&&z+1<B){const K=D.charCodeAt(z+1);if(q(K))return k($,K)}return $}i.getNextCodePoint=I;function T(D,B){const z=D.charCodeAt(B-1);if(q(z)&&B>1){const $=D.charCodeAt(B-2);if(O($))return k($,z)}return z}class W{get offset(){return this.e}constructor(B,z=0){this.c=B,this.d=B.length,this.e=z}setOffset(B){this.e=B}prevCodePoint(){const B=T(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=I(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}i.CodePointIterator=W;class H{get offset(){return this.c.offset}constructor(B,z=0){this.c=new W(B,z)}nextGraphemeLength(){const B=ne.getInstance(),z=this.c,$=z.offset;let K=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ie=z.offset,oe=B.getGraphemeBreakType(z.nextCodePoint());if(te(K,oe)){z.setOffset(ie);break}K=oe}return z.offset-$}prevGraphemeLength(){const B=ne.getInstance(),z=this.c,$=z.offset;let K=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ie=z.offset,oe=B.getGraphemeBreakType(z.prevCodePoint());if(te(oe,K)){z.setOffset(ie);break}K=oe}return $-z.offset}eol(){return this.c.eol()}}i.GraphemeIterator=H;function n(D,B){return new H(D,B).nextGraphemeLength()}i.nextCharLength=n;function se(D,B){return new H(D,B).prevGraphemeLength()}i.prevCharLength=se;function de(D,B){B>0&&q(D.charCodeAt(B))&&B--;const z=B+n(D,B);return[z-se(D,z),z]}i.getCharContainingOffset=de;let ge;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(D){return ge||(ge=ye()),ge.test(D)}i.containsRTL=Se;const Ne=/^[\t\n\r\x20-\x7E]*$/;function _e(D){return Ne.test(D)}i.isBasicASCII=_e,i.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(D){return i.UNUSUAL_LINE_TERMINATORS.test(D)}i.containsUnusualLineTerminators=Z;function j(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}i.isFullWidthCharacter=j;function Y(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}i.isEmojiImprecise=Y,i.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}i.startsWithUTF8BOM=G;function x(D,B=!1){return D?(B&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}i.containsUppercaseCharacter=x;function ee(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}i.singleLetterHash=ee;function te(D,B){return D===0?B!==5&&B!==7:D===2&&B===3?!1:D===4||D===2||D===3||B===4||B===2||B===3?!0:!(D===8&&(B===8||B===9||B===11||B===12)||(D===11||D===9)&&(B===9||B===10)||(D===12||D===10)&&B===10||B===5||B===13||B===7||D===1||D===13&&B===14||D===6&&B===6)}class ne{static getInstance(){return ne.c||(ne.c=new ne),ne.c}constructor(){this.d=we()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this.d,$=z.length/3;let K=1;for(;K<=$;)if(B<z[3*K])K=2*K;else if(B>z[3*K+1])K=2*K+1;else return z[3*K+2];return 0}}ne.c=null;function we(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(D,B){if(D===0)return 0;const z=Le(D,B);if(z!==void 0)return z;const $=new W(B,D);return $.prevCodePoint(),$.offset}i.getLeftDeleteOffset=Ce;function Le(D,B){const z=new W(B,D);let $=z.prevCodePoint();for(;ve($)||$===65039||$===8419;){if(z.offset===0)return;$=z.prevCodePoint()}if(!Y($))return;let K=z.offset;return K>0&&z.prevCodePoint()===8205&&(K=z.offset),K}function ve(D){return 127995<=D&&D<=127999}i.noBreakWhitespace="\xA0";class ue{static getInstance(B){return ue.d.get(Array.from(B))}static getLocales(){return ue.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.AmbiguousCharacters=ue,E=ue,ue.c=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.d=new A.LRUCachedFunction(D=>{function B(re){const ce=new Map;for(let he=0;he<re.length;he+=2)ce.set(re[he],re[he+1]);return ce}function z(re,ce){const he=new Map(re);for(const[pe,Ae]of ce)he.set(pe,Ae);return he}function $(re,ce){if(!re)return ce;const he=new Map;for(const[pe,Ae]of re)ce.has(pe)&&he.set(pe,Ae);return he}const K=E.c.value;let ie=D.filter(re=>!re.startsWith("_")&&re in K);ie.length===0&&(ie=["_default"]);let oe;for(const re of ie){const ce=B(K[re]);oe=$(oe,ce)}const be=B(K._common),fe=z(be,oe);return new ue(fe)}),ue.e=new e.Lazy(()=>Object.keys(ue.c.value).filter(D=>!D.startsWith("_")));class me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(me.c())),this.d}static isInvisibleCharacter(B){return me.e().has(B)}static get codePoints(){return me.e()}}i.InvisibleCharacters=me,me.d=void 0}),X(Q[29],J([0,1,4]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function e(L){return E(L,0)}i.hash=e;function E(L,y){switch(typeof L){case"object":return L===null?l(349,y):Array.isArray(L)?o(L,y):f(L,y);case"string":return v(L,y);case"boolean":return p(L,y);case"number":return l(L,y);case"undefined":return l(937,y);default:return l(617,y)}}i.doHash=E;function l(L,y){return(y<<5)-y+L|0}i.numberHash=l;function p(L,y){return l(L?433:863,y)}function v(L,y){y=l(149417,y);for(let _=0,g=L.length;_<g;_++)y=l(L.charCodeAt(_),y);return y}i.stringHash=v;function o(L,y){return y=l(104579,y),L.reduce((_,g)=>E(g,_),y)}function f(L,y){return y=l(181387,y),Object.keys(L).sort().reduce((_,g)=>(_=v(g,_),E(L[g],_)),y)}function S(L,y,_=32){const g=_-y,C=~((1<<g)-1);return(L<<y|(C&L)>>>g)>>>0}function t(L,y=0,_=L.byteLength,g=0){for(let C=0;C<_;C++)L[y+C]=g}function w(L,y,_="0"){for(;L.length<y;)L=_+L;return L}function h(L,y=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(_=>_.toString(16).padStart(2,"0")).join(""):w((L>>>0).toString(16),y/4)}i.toHexString=h;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const _=y.length;if(_===0)return;const g=this.p;let C=this.r,u=this.u,d,s;for(u!==0?(d=u,s=-1,u=0):(d=y.charCodeAt(0),s=0);;){let a=d;if(A.isHighSurrogate(d))if(s+1<_){const r=y.charCodeAt(s+1);A.isLowSurrogate(r)?(s++,a=A.computeCodePoint(d,r)):a=65533}else{u=d;break}else A.isLowSurrogate(d)&&(a=65533);if(C=this.w(g,C,a),s++,s<_)d=y.charCodeAt(s);else break}this.r=C,this.u=u}w(y,_,g){return g<128?y[_++]=g:g<2048?(y[_++]=192|(g&1984)>>>6,y[_++]=128|(g&63)>>>0):g<65536?(y[_++]=224|(g&61440)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0):(y[_++]=240|(g&1835008)>>>18,y[_++]=128|(g&258048)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0),_>=64&&(this.y(),_-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),_}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,t(this.p,this.r),this.r>56&&(this.y(),t(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=m.g,_=this.q;for(let b=0;b<64;b+=4)y.setUint32(b,_.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)y.setUint32(b,S(y.getUint32(b-12,!1)^y.getUint32(b-32,!1)^y.getUint32(b-56,!1)^y.getUint32(b-64,!1),1),!1);let g=this.h,C=this.l,u=this.m,d=this.n,s=this.o,a,r,c;for(let b=0;b<80;b++)b<20?(a=C&u|~C&d,r=1518500249):b<40?(a=C^u^d,r=1859775393):b<60?(a=C&u|C&d|u&d,r=2400959708):(a=C^u^d,r=3395469782),c=S(g,5)+a+s+r+y.getUint32(b*4,!1)&4294967295,s=d,d=u,u=S(C,30),C=g,g=c;this.h=this.h+g&4294967295,this.l=this.l+C&4294967295,this.m=this.m+u&4294967295,this.n=this.n+d&4294967295,this.o=this.o+s&4294967295}}i.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),X(Q[15],J([0,1,25,29]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LcsDiff=i.stringDiff=i.StringDiffSequence=void 0;class E{constructor(t){this.a=t}getElements(){const t=this.a,w=new Int32Array(t.length);for(let h=0,m=t.length;h<m;h++)w[h]=t.charCodeAt(h);return w}}i.StringDiffSequence=E;function l(S,t,w){return new f(new E(S),new E(t)).ComputeDiff(w).changes}i.stringDiff=l;class p{static Assert(t,w){if(!t)throw new Error(w)}}class v{static Copy(t,w,h,m,L){for(let y=0;y<L;y++)h[m+y]=t[w+y]}static Copy2(t,w,h,m,L){for(let y=0;y<L;y++)h[m+y]=t[w+y]}}class o{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(t,w){this.b=Math.min(this.b,t),this.c=Math.min(this.c,w),this.d++}AddModifiedElement(t,w){this.b=Math.min(this.b,t),this.c=Math.min(this.c,w),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(t,w,h=null){this.a=h,this.b=t,this.c=w;const[m,L,y]=f.o(t),[_,g,C]=f.o(w);this.d=y&&C,this.e=m,this.f=L,this.g=_,this.h=g,this.k=[],this.m=[]}static n(t){return t.length>0&&typeof t[0]=="string"}static o(t){const w=t.getElements();if(f.n(w)){const h=new Int32Array(w.length);for(let m=0,L=w.length;m<L;m++)h[m]=(0,e.stringHash)(w[m],0);return[w,h,!0]}return w instanceof Int32Array?[[],w,!1]:[[],new Int32Array(w),!1]}p(t,w){return this.f[t]!==this.h[w]?!1:this.d?this.e[t]===this.g[w]:!0}q(t,w){if(!this.p(t,w))return!1;const h=f.r(this.b,t),m=f.r(this.c,w);return h===m}static r(t,w){return typeof t.getStrictElement=="function"?t.getStrictElement(w):null}s(t,w){return this.f[t]!==this.f[w]?!1:this.d?this.e[t]===this.e[w]:!0}u(t,w){return this.h[t]!==this.h[w]?!1:this.d?this.g[t]===this.g[w]:!0}ComputeDiff(t){return this.v(0,this.f.length-1,0,this.h.length-1,t)}v(t,w,h,m,L){const y=[!1];let _=this.w(t,w,h,m,y);return L&&(_=this.z(_)),{quitEarly:y[0],changes:_}}w(t,w,h,m,L){for(L[0]=!1;t<=w&&h<=m&&this.p(t,h);)t++,h++;for(;w>=t&&m>=h&&this.p(w,m);)w--,m--;if(t>w||h>m){let d;return h<=m?(p.Assert(t===w+1,"originalStart should only be one more than originalEnd"),d=[new A.DiffChange(t,0,h,m-h+1)]):t<=w?(p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[new A.DiffChange(t,w-t+1,h,0)]):(p.Assert(t===w+1,"originalStart should only be one more than originalEnd"),p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const y=[0],_=[0],g=this.y(t,w,h,m,y,_,L),C=y[0],u=_[0];if(g!==null)return g;if(!L[0]){const d=this.w(t,C,h,u,L);let s=[];return L[0]?s=[new A.DiffChange(C+1,w-(C+1)+1,u+1,m-(u+1)+1)]:s=this.w(C+1,w,u+1,m,L),this.H(d,s)}return[new A.DiffChange(t,w-t+1,h,m-h+1)]}x(t,w,h,m,L,y,_,g,C,u,d,s,a,r,c,b,N,M){let R=null,P=null,F=new o,V=w,O=h,q=a[0]-b[0]-m,k=-1073741824,I=this.k.length-1;do{const T=q+t;T===V||T<O&&C[T-1]<C[T+1]?(d=C[T+1],r=d-q-m,d<k&&F.MarkNextChange(),k=d,F.AddModifiedElement(d+1,r),q=T+1-t):(d=C[T-1]+1,r=d-q-m,d<k&&F.MarkNextChange(),k=d-1,F.AddOriginalElement(d,r+1),q=T-1-t),I>=0&&(C=this.k[I],t=C[0],V=1,O=C.length-1)}while(--I>=-1);if(R=F.getReverseChanges(),M[0]){let T=a[0]+1,W=b[0]+1;if(R!==null&&R.length>0){const H=R[R.length-1];T=Math.max(T,H.getOriginalEnd()),W=Math.max(W,H.getModifiedEnd())}P=[new A.DiffChange(T,s-T+1,W,c-W+1)]}else{F=new o,V=y,O=_,q=a[0]-b[0]-g,k=1073741824,I=N?this.m.length-1:this.m.length-2;do{const T=q+L;T===V||T<O&&u[T-1]>=u[T+1]?(d=u[T+1]-1,r=d-q-g,d>k&&F.MarkNextChange(),k=d+1,F.AddOriginalElement(d+1,r+1),q=T+1-L):(d=u[T-1],r=d-q-g,d>k&&F.MarkNextChange(),k=d,F.AddModifiedElement(d+1,r+1),q=T-1-L),I>=0&&(u=this.m[I],L=u[0],V=1,O=u.length-1)}while(--I>=-1);P=F.getChanges()}return this.H(R,P)}y(t,w,h,m,L,y,_){let g=0,C=0,u=0,d=0,s=0,a=0;t--,h--,L[0]=0,y[0]=0,this.k=[],this.m=[];const r=w-t+(m-h),c=r+1,b=new Int32Array(c),N=new Int32Array(c),M=m-h,R=w-t,P=t-h,F=w-m,O=(R-M)%2===0;b[M]=t,N[R]=w,_[0]=!1;for(let q=1;q<=r/2+1;q++){let k=0,I=0;u=this.J(M-q,q,M,c),d=this.J(M+q,q,M,c);for(let W=u;W<=d;W+=2){W===u||W<d&&b[W-1]<b[W+1]?g=b[W+1]:g=b[W-1]+1,C=g-(W-M)-P;const H=g;for(;g<w&&C<m&&this.p(g+1,C+1);)g++,C++;if(b[W]=g,g+C>k+I&&(k=g,I=C),!O&&Math.abs(W-R)<=q-1&&g>=N[W])return L[0]=g,y[0]=C,H<=N[W]&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,F,b,N,g,w,L,C,m,y,O,_):null}const T=(k-t+(I-h)-q)/2;if(this.a!==null&&!this.a(k,T))return _[0]=!0,L[0]=k,y[0]=I,T>0&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,F,b,N,g,w,L,C,m,y,O,_):(t++,h++,[new A.DiffChange(t,w-t+1,h,m-h+1)]);s=this.J(R-q,q,R,c),a=this.J(R+q,q,R,c);for(let W=s;W<=a;W+=2){W===s||W<a&&N[W-1]>=N[W+1]?g=N[W+1]-1:g=N[W-1],C=g-(W-R)-F;const H=g;for(;g>t&&C>h&&this.p(g,C);)g--,C--;if(N[W]=g,O&&Math.abs(W-M)<=q&&g<=b[W])return L[0]=g,y[0]=C,H>=b[W]&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,F,b,N,g,w,L,C,m,y,O,_):null}if(q<=1447){let W=new Int32Array(d-u+2);W[0]=M-u+1,v.Copy2(b,u,W,1,d-u+1),this.k.push(W),W=new Int32Array(a-s+2),W[0]=R-s+1,v.Copy2(N,s,W,1,a-s+1),this.m.push(W)}}return this.x(M,u,d,P,R,s,a,F,b,N,g,w,L,C,m,y,O,_)}z(t){for(let w=0;w<t.length;w++){const h=t[w],m=w<t.length-1?t[w+1].originalStart:this.f.length,L=w<t.length-1?t[w+1].modifiedStart:this.h.length,y=h.originalLength>0,_=h.modifiedLength>0;for(;h.originalStart+h.originalLength<m&&h.modifiedStart+h.modifiedLength<L&&(!y||this.s(h.originalStart,h.originalStart+h.originalLength))&&(!_||this.u(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const C=this.q(h.originalStart,h.modifiedStart);if(this.q(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!C)break;h.originalStart++,h.modifiedStart++}const g=[null];if(w<t.length-1&&this.I(t[w],t[w+1],g)){t[w]=g[0],t.splice(w+1,1),w--;continue}}for(let w=t.length-1;w>=0;w--){const h=t[w];let m=0,L=0;if(w>0){const d=t[w-1];m=d.originalStart+d.originalLength,L=d.modifiedStart+d.modifiedLength}const y=h.originalLength>0,_=h.modifiedLength>0;let g=0,C=this.G(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let d=1;;d++){const s=h.originalStart-d,a=h.modifiedStart-d;if(s<m||a<L||y&&!this.s(s,s+h.originalLength)||_&&!this.u(a,a+h.modifiedLength))break;const c=(s===m&&a===L?5:0)+this.G(s,h.originalLength,a,h.modifiedLength);c>C&&(C=c,g=d)}h.originalStart-=g,h.modifiedStart-=g;const u=[null];if(w>0&&this.I(t[w-1],t[w],u)){t[w-1]=u[0],t.splice(w,1),w++;continue}}if(this.d)for(let w=1,h=t.length;w<h;w++){const m=t[w-1],L=t[w],y=L.originalStart-m.originalStart-m.originalLength,_=m.originalStart,g=L.originalStart+L.originalLength,C=g-_,u=m.modifiedStart,d=L.modifiedStart+L.modifiedLength,s=d-u;if(y<5&&C<20&&s<20){const a=this.A(_,C,u,s,y);if(a){const[r,c]=a;(r!==m.originalStart+m.originalLength||c!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=r-m.originalStart,m.modifiedLength=c-m.modifiedStart,L.originalStart=r+y,L.modifiedStart=c+y,L.originalLength=g-L.originalStart,L.modifiedLength=d-L.modifiedStart)}}}return t}A(t,w,h,m,L){if(w<L||m<L)return null;const y=t+w-L+1,_=h+m-L+1;let g=0,C=0,u=0;for(let d=t;d<y;d++)for(let s=h;s<_;s++){const a=this.B(d,s,L);a>0&&a>g&&(g=a,C=d,u=s)}return g>0?[C,u]:null}B(t,w,h){let m=0;for(let L=0;L<h;L++){if(!this.p(t+L,w+L))return 0;m+=this.e[t+L].length}return m}C(t){return t<=0||t>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[t])}D(t,w){if(this.C(t)||this.C(t-1))return!0;if(w>0){const h=t+w;if(this.C(h-1)||this.C(h))return!0}return!1}E(t){return t<=0||t>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[t])}F(t,w){if(this.E(t)||this.E(t-1))return!0;if(w>0){const h=t+w;if(this.E(h-1)||this.E(h))return!0}return!1}G(t,w,h,m){const L=this.D(t,w)?1:0,y=this.F(h,m)?1:0;return L+y}H(t,w){const h=[];if(t.length===0||w.length===0)return w.length>0?w:t;if(this.I(t[t.length-1],w[0],h)){const m=new Array(t.length+w.length-1);return v.Copy(t,0,m,0,t.length-1),m[t.length-1]=h[0],v.Copy(w,1,m,t.length,w.length-1),m}else{const m=new Array(t.length+w.length);return v.Copy(t,0,m,0,t.length),v.Copy(w,0,m,t.length,w.length),m}}I(t,w,h){if(p.Assert(t.originalStart<=w.originalStart,"Left change is not less than or equal to right change"),p.Assert(t.modifiedStart<=w.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=w.originalStart||t.modifiedStart+t.modifiedLength>=w.modifiedStart){const m=t.originalStart;let L=t.originalLength;const y=t.modifiedStart;let _=t.modifiedLength;return t.originalStart+t.originalLength>=w.originalStart&&(L=w.originalStart+w.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=w.modifiedStart&&(_=w.modifiedStart+w.modifiedLength-t.modifiedStart),h[0]=new A.DiffChange(m,L,y,_),!0}else return h[0]=null,!1}J(t,w,h,m){if(t>=0&&t<m)return t;const L=h,y=m-h-1,_=w%2===0;if(t<0){const g=L%2===0;return _===g?0:1}else{const g=y%2===0;return _===g?m-1:m-2}}}i.LcsDiff=f}),X(Q[30],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.withNullAsUndefined=i.validateConstraint=i.validateConstraints=i.isFunction=i.assertIsDefined=i.assertType=i.isUndefinedOrNull=i.isDefined=i.isUndefined=i.isBoolean=i.isIterable=i.isNumber=i.isTypedArray=i.isObject=i.isString=void 0;function A(_){return typeof _=="string"}i.isString=A;function e(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}i.isObject=e;function E(_){const g=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof g}i.isTypedArray=E;function l(_){return typeof _=="number"&&!isNaN(_)}i.isNumber=l;function p(_){return!!_&&typeof _[Symbol.iterator]=="function"}i.isIterable=p;function v(_){return _===!0||_===!1}i.isBoolean=v;function o(_){return typeof _>"u"}i.isUndefined=o;function f(_){return!S(_)}i.isDefined=f;function S(_){return o(_)||_===null}i.isUndefinedOrNull=S;function t(_,g){if(!_)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}i.assertType=t;function w(_){if(S(_))throw new Error("Assertion Failed: argument is undefined or null");return _}i.assertIsDefined=w;function h(_){return typeof _=="function"}i.isFunction=h;function m(_,g){const C=Math.min(_.length,g.length);for(let u=0;u<C;u++)L(_[u],g[u])}i.validateConstraints=m;function L(_,g){if(A(g)){if(typeof _!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(h(g)){try{if(_ instanceof g)return}catch{}if(!S(_)&&_.constructor===g||g.length===1&&g.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}i.validateConstraint=L;function y(_){return _===null?void 0:_}i.withNullAsUndefined=y}),X(Q[11],J([0,1,30]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function e(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([L,y])=>{m[L]=y&&typeof y=="object"?e(y):y}),m}i.deepClone=e;function E(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const L=m.shift();Object.freeze(L);for(const y in L)if(l.call(L,y)){const _=L[y];typeof _=="object"&&!Object.isFrozen(_)&&!(0,A.isTypedArray)(_)&&m.push(_)}}return h}i.deepFreeze=E;const l=Object.prototype.hasOwnProperty;function p(h,m){return v(h,m,new Set)}i.cloneAndChange=p;function v(h,m,L){if((0,A.isUndefinedOrNull)(h))return h;const y=m(h);if(typeof y<"u")return y;if(Array.isArray(h)){const _=[];for(const g of h)_.push(v(g,m,L));return _}if((0,A.isObject)(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const _={};for(const g in h)l.call(h,g)&&(_[g]=v(h[g],m,L));return L.delete(h),_}return h}function o(h,m,L=!0){return(0,A.isObject)(h)?((0,A.isObject)(m)&&Object.keys(m).forEach(y=>{y in h?L&&((0,A.isObject)(h[y])&&(0,A.isObject)(m[y])?o(h[y],m[y],L):h[y]=m[y]):h[y]=m[y]}),h):m}i.mixin=o;function f(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let L,y;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(L=0;L<h.length;L++)if(!f(h[L],m[L]))return!1}else{const _=[];for(y in h)_.push(y);_.sort();const g=[];for(y in m)g.push(y);if(g.sort(),!f(_,g))return!1;for(L=0;L<_.length;L++)if(!f(h[_[L]],m[_[L]]))return!1}return!0}i.equals=f;function S(h){let m=[],L=Object.getPrototypeOf(h);for(;Object.prototype!==L;)m=m.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return m}i.getAllPropertyNames=S;function t(h){const m=[];for(const L of S(h))typeof h[L]=="function"&&m.push(L);return m}i.getAllMethodNames=t;function w(h,m){const L=_=>function(){const g=Array.prototype.slice.call(arguments,0);return m(_,g)},y={};for(const _ of h)y[_]=L(_);return y}i.createProxyObject=w}),X(Q[16],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toUint32=i.toUint8=void 0;function A(E){return E<0?0:E>255?255:E|0}i.toUint8=A;function e(E){return E<0?0:E>4294967295?4294967295:E|0}i.toUint32=e}),X(Q[17],J([0,1,16]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharacterSet=i.CharacterClassifier=void 0;class e{constructor(p){const v=(0,A.toUint8)(p);this.c=v,this.a=e.d(v),this.b=new Map}static d(p){const v=new Uint8Array(256);return v.fill(p),v}set(p,v){const o=(0,A.toUint8)(v);p>=0&&p<256?this.a[p]=o:this.b.set(p,o)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.CharacterClassifier=e;class E{constructor(){this.a=new e(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}i.CharacterSet=E}),X(Q[3],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Position=void 0;class A{constructor(E,l){this.lineNumber=E,this.column=l}with(E=this.lineNumber,l=this.column){return E===this.lineNumber&&l===this.column?this:new A(E,l)}delta(E=0,l=0){return this.with(this.lineNumber+E,this.column+l)}equals(E){return A.equals(this,E)}static equals(E,l){return!E&&!l?!0:!!E&&!!l&&E.lineNumber===l.lineNumber&&E.column===l.column}isBefore(E){return A.isBefore(this,E)}static isBefore(E,l){return E.lineNumber<l.lineNumber?!0:l.lineNumber<E.lineNumber?!1:E.column<l.column}isBeforeOrEqual(E){return A.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,l){return E.lineNumber<l.lineNumber?!0:l.lineNumber<E.lineNumber?!1:E.column<=l.column}static compare(E,l){const p=E.lineNumber|0,v=l.lineNumber|0;if(p===v){const o=E.column|0,f=l.column|0;return o-f}return p-v}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new A(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}}i.Position=A}),X(Q[2],J([0,1,3]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Range=void 0;class e{constructor(l,p,v,o){l>v||l===v&&p>o?(this.startLineNumber=v,this.startColumn=o,this.endLineNumber=l,this.endColumn=p):(this.startLineNumber=l,this.startColumn=p,this.endLineNumber=v,this.endColumn=o)}isEmpty(){return e.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return e.containsPosition(this,l)}static containsPosition(l,p){return!(p.lineNumber<l.startLineNumber||p.lineNumber>l.endLineNumber||p.lineNumber===l.startLineNumber&&p.column<l.startColumn||p.lineNumber===l.endLineNumber&&p.column>l.endColumn)}static strictContainsPosition(l,p){return!(p.lineNumber<l.startLineNumber||p.lineNumber>l.endLineNumber||p.lineNumber===l.startLineNumber&&p.column<=l.startColumn||p.lineNumber===l.endLineNumber&&p.column>=l.endColumn)}containsRange(l){return e.containsRange(this,l)}static containsRange(l,p){return!(p.startLineNumber<l.startLineNumber||p.endLineNumber<l.startLineNumber||p.startLineNumber>l.endLineNumber||p.endLineNumber>l.endLineNumber||p.startLineNumber===l.startLineNumber&&p.startColumn<l.startColumn||p.endLineNumber===l.endLineNumber&&p.endColumn>l.endColumn)}strictContainsRange(l){return e.strictContainsRange(this,l)}static strictContainsRange(l,p){return!(p.startLineNumber<l.startLineNumber||p.endLineNumber<l.startLineNumber||p.startLineNumber>l.endLineNumber||p.endLineNumber>l.endLineNumber||p.startLineNumber===l.startLineNumber&&p.startColumn<=l.startColumn||p.endLineNumber===l.endLineNumber&&p.endColumn>=l.endColumn)}plusRange(l){return e.plusRange(this,l)}static plusRange(l,p){let v,o,f,S;return p.startLineNumber<l.startLineNumber?(v=p.startLineNumber,o=p.startColumn):p.startLineNumber===l.startLineNumber?(v=p.startLineNumber,o=Math.min(p.startColumn,l.startColumn)):(v=l.startLineNumber,o=l.startColumn),p.endLineNumber>l.endLineNumber?(f=p.endLineNumber,S=p.endColumn):p.endLineNumber===l.endLineNumber?(f=p.endLineNumber,S=Math.max(p.endColumn,l.endColumn)):(f=l.endLineNumber,S=l.endColumn),new e(v,o,f,S)}intersectRanges(l){return e.intersectRanges(this,l)}static intersectRanges(l,p){let v=l.startLineNumber,o=l.startColumn,f=l.endLineNumber,S=l.endColumn;const t=p.startLineNumber,w=p.startColumn,h=p.endLineNumber,m=p.endColumn;return v<t?(v=t,o=w):v===t&&(o=Math.max(o,w)),f>h?(f=h,S=m):f===h&&(S=Math.min(S,m)),v>f||v===f&&o>S?null:new e(v,o,f,S)}equalsRange(l){return e.equalsRange(this,l)}static equalsRange(l,p){return!l&&!p?!0:!!l&&!!p&&l.startLineNumber===p.startLineNumber&&l.startColumn===p.startColumn&&l.endLineNumber===p.endLineNumber&&l.endColumn===p.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(l){return new A.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(l){return new A.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,p){return new e(this.startLineNumber,this.startColumn,l,p)}setStartPosition(l,p){return new e(l,p,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}static collapseToStart(l){return new e(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}collapseToEnd(){return e.collapseToEnd(this)}static collapseToEnd(l){return new e(l.endLineNumber,l.endColumn,l.endLineNumber,l.endColumn)}delta(l){return new e(this.startLineNumber+l,this.startColumn,this.endLineNumber+l,this.endColumn)}static fromPositions(l,p=l){return new e(l.lineNumber,l.column,p.lineNumber,p.column)}static lift(l){return l?new e(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,p){return!(l.endLineNumber<p.startLineNumber||l.endLineNumber===p.startLineNumber&&l.endColumn<p.startColumn||p.endLineNumber<l.startLineNumber||p.endLineNumber===l.startLineNumber&&p.endColumn<l.startColumn)}static areIntersecting(l,p){return!(l.endLineNumber<p.startLineNumber||l.endLineNumber===p.startLineNumber&&l.endColumn<=p.startColumn||p.endLineNumber<l.startLineNumber||p.endLineNumber===l.startLineNumber&&p.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,p){if(l&&p){const f=l.startLineNumber|0,S=p.startLineNumber|0;if(f===S){const t=l.startColumn|0,w=p.startColumn|0;if(t===w){const h=l.endLineNumber|0,m=p.endLineNumber|0;if(h===m){const L=l.endColumn|0,y=p.endColumn|0;return L-y}return h-m}return t-w}return f-S}return(l?1:0)-(p?1:0)}static compareRangesUsingEnds(l,p){return l.endLineNumber===p.endLineNumber?l.endColumn===p.endColumn?l.startLineNumber===p.startLineNumber?l.startColumn-p.startColumn:l.startLineNumber-p.startLineNumber:l.endColumn-p.endColumn:l.endLineNumber-p.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}i.Range=e}),X(Q[31],J([0,1,3,2]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Selection=void 0;class E extends e.Range{constructor(p,v,o,f){super(p,v,o,f),this.selectionStartLineNumber=p,this.selectionStartColumn=v,this.positionLineNumber=o,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return E.selectionsEqual(this,p)}static selectionsEqual(p,v){return p.selectionStartLineNumber===v.selectionStartLineNumber&&p.selectionStartColumn===v.selectionStartColumn&&p.positionLineNumber===v.positionLineNumber&&p.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,v){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,p,v):new E(p,v,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,v){return this.getDirection()===0?new E(p,v,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,p,v)}static fromPositions(p,v=p){return new E(p.lineNumber,p.column,v.lineNumber,v.column)}static fromRange(p,v){return v===0?new E(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new E(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new E(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,v){if(p&&!v||!p&&v)return!1;if(!p&&!v)return!0;if(p.length!==v.length)return!1;for(let o=0,f=p.length;o<f;o++)if(!this.selectionsEqual(p[o],v[o]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,v,o,f,S){return S===0?new E(p,v,o,f):new E(o,f,p,v)}}i.Selection=E}),X(Q[32],J([0,1,17]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMapForWordSeparators=i.WordCharacterClassifier=void 0;class e extends A.CharacterClassifier{constructor(p){super(0);for(let v=0,o=p.length;v<o;v++)this.set(p.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}i.WordCharacterClassifier=e;function E(l){const p={};return v=>(p.hasOwnProperty(v)||(p[v]=l(v)),p[v])}i.getMapForWordSeparators=E(l=>new e(l))}),X(Q[18],J([0,1,13,14]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getWordAtText=i.ensureValidWordDefinition=i.DEFAULT_WORD_REGEXP=i.USUAL_WORD_SEPARATORS=void 0,i.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(f=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const t of i.USUAL_WORD_SEPARATORS)f.indexOf(t)>=0||(S+="\\"+t);return S+="\\s]+)",new RegExp(S,"g")}i.DEFAULT_WORD_REGEXP=E();function l(f){let S=i.DEFAULT_WORD_REGEXP;if(f&&f instanceof RegExp)if(f.global)S=f;else{let t="g";f.ignoreCase&&(t+="i"),f.multiline&&(t+="m"),f.unicode&&(t+="u"),S=new RegExp(f.source,t)}return S.lastIndex=0,S}i.ensureValidWordDefinition=l;const p=new e.LinkedList;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(f,S,t,w,h){if(h||(h=A.Iterable.first(p)),t.length>h.maxLen){let g=f-h.maxLen/2;return g<0?g=0:w+=g,t=t.substring(g,f+h.maxLen/2),v(f,S,t,w,h)}const m=Date.now(),L=f-1-w;let y=-1,_=null;for(let g=1;!(Date.now()-m>=h.timeBudget);g++){const C=L-h.windowSize*g;S.lastIndex=Math.max(0,C);const u=o(S,t,L,y);if(!u&&_||(_=u,C<=0))break;y=C}if(_){const g={word:_[0],startColumn:w+1+_.index,endColumn:w+1+_.index+_[0].length};return S.lastIndex=0,g}return null}i.getWordAtText=v;function o(f,S,t,w){let h;for(;h=f.exec(S);){const m=h.index||0;if(m<=t&&f.lastIndex>=t)return h;if(w>0&&m>w)return null}return null}}),X(Q[6],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OffsetRange=i.SequenceDiff=void 0;class A{constructor(l,p){this.seq1Range=l,this.seq2Range=p}reverse(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}i.SequenceDiff=A;class e{constructor(l,p){this.start=l,this.endExclusive=p}get isEmpty(){return this.start===this.endExclusive}delta(l){return new e(this.start+l,this.endExclusive+l)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(l){return new e(Math.min(this.start,l.start),Math.max(this.endExclusive,l.endExclusive))}}i.OffsetRange=e}),X(Q[33],J([0,1,6]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.shiftSequenceDiffs=i.joinSequenceDiffs=i.smoothenSequenceDiffs=i.optimizeSequenceDiffs=void 0;function e(o,f,S){let t=S;return t=l(o,f,t),t=p(o,f,t),t}i.optimizeSequenceDiffs=e;function E(o,f,S){const t=[];for(const w of S){const h=t[t.length-1];if(!h){t.push(w);continue}w.seq1Range.start-h.seq1Range.endExclusive<=2||w.seq2Range.start-h.seq2Range.endExclusive<=2?t[t.length-1]=new A.SequenceDiff(h.seq1Range.join(w.seq1Range),h.seq2Range.join(w.seq2Range)):t.push(w)}return t}i.smoothenSequenceDiffs=E;function l(o,f,S){const t=[];S.length>0&&t.push(S[0]);for(let w=1;w<S.length;w++){const h=t[t.length-1],m=S[w];if(m.seq1Range.isEmpty){let L=!0;const y=m.seq1Range.start-h.seq1Range.endExclusive;for(let _=1;_<=y;_++)if(f.getElement(m.seq2Range.start-_)!==f.getElement(m.seq2Range.endExclusive-_)){L=!1;break}if(L){t[t.length-1]=new A.SequenceDiff(h.seq1Range,new A.OffsetRange(h.seq2Range.start,m.seq2Range.endExclusive-y));continue}}t.push(m)}return t}i.joinSequenceDiffs=l;function p(o,f,S){if(!o.getBoundaryScore||!f.getBoundaryScore)return S;for(let t=0;t<S.length;t++){const w=S[t];if(w.seq1Range.isEmpty){const h=t>0?S[t-1].seq2Range.endExclusive:-1,m=t+1<S.length?S[t+1].seq2Range.start:f.length;S[t]=v(w,o,f,m,h)}else if(w.seq2Range.isEmpty){const h=t>0?S[t-1].seq1Range.endExclusive:-1,m=t+1<S.length?S[t+1].seq1Range.start:o.length;S[t]=v(w.reverse(),f,o,m,h).reverse()}}return S}i.shiftSequenceDiffs=p;function v(o,f,S,t,w){let m=1;for(;o.seq2Range.start-m>w&&S.getElement(o.seq2Range.start-m)===S.getElement(o.seq2Range.endExclusive-m)&&m<20;)m++;m--;let L=0;for(;o.seq2Range.start+L<t&&S.getElement(o.seq2Range.start+L)===S.getElement(o.seq2Range.endExclusive+L)&&L<20;)L++;if(m===0&&L===0)return o;let y=0,_=-1;for(let g=-m;g<=L;g++){const C=o.seq2Range.start+g,u=o.seq2Range.endExclusive+g,d=o.seq1Range.start+g,s=f.getBoundaryScore(d)+S.getBoundaryScore(C)+S.getBoundaryScore(u);s>_&&(_=s,y=g)}return y!==0?new A.SequenceDiff(o.seq1Range.delta(y),o.seq2Range.delta(y)):o}}),X(Q[34],J([0,1,6]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MyersDiffAlgorithm=void 0;class e{compute(o,f){if(o.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,0),new A.OffsetRange(0,f.length))];if(f.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,o.length),new A.OffsetRange(0,0))];function S(C,u){for(;C<o.length&&u<f.length&&o.getElement(C)===f.getElement(u);)C++,u++;return C}let t=0;const w=new l;w.set(0,S(0,0));const h=new p;h.set(0,w.get(0)===0?null:new E(null,0,0,w.get(0)));let m=0;e:for(;;)for(t++,m=-t;m<=t;m+=2){const C=m===t?-1:w.get(m+1),u=m===-t?-1:w.get(m-1)+1,d=Math.min(Math.max(C,u),o.length),s=d-m,a=S(d,s);w.set(m,a);const r=d===C?h.get(m+1):h.get(m-1);if(h.set(m,a!==d?new E(r,d,s,a-d):r),w.get(m)===o.length&&w.get(m)-m===f.length)break e}let L=h.get(m);const y=[];let _=o.length,g=f.length;for(;;){const C=L?L.x+L.length:0,u=L?L.y+L.length:0;if((C!==_||u!==g)&&y.push(new A.SequenceDiff(new A.OffsetRange(C,_),new A.OffsetRange(u,g))),!L)break;_=L.x,g=L.y,L=L.prev}return y.reverse(),y}}i.MyersDiffAlgorithm=e;class E{constructor(o,f,S,t){this.prev=o,this.x=f,this.y=S,this.length=t}}class l{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){if(o<0){if(o=-o-1,o>=this.b.length){const S=this.b;this.b=new Int32Array(S.length*2),this.b.set(S)}this.b[o]=f}else{if(o>=this.a.length){const S=this.a;this.a=new Int32Array(S.length*2),this.a.set(S)}this.a[o]=f}}}class p{constructor(){this.a=[],this.b=[]}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){o<0?(o=-o-1,this.b[o]=f):this.a[o]=f}}}),X(Q[35],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Array2D=void 0;class A{constructor(E,l){this.width=E,this.height=l,this.a=[],this.a=new Array(E*l)}get(E,l){return this.a[E+l*this.width]}set(E,l,p){this.a[E+l*this.width]=p}}i.Array2D=A}),X(Q[36],J([0,1,6,35]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DynamicProgrammingDiffing=void 0;class E{compute(p,v,o){const f=new e.Array2D(p.length,v.length),S=new e.Array2D(p.length,v.length),t=new e.Array2D(p.length,v.length);for(let g=0;g<p.length;g++)for(let C=0;C<v.length;C++){const u=g===0?0:f.get(g-1,C),d=C===0?0:f.get(g,C-1);let s;p.getElement(g)===v.getElement(C)?(g===0||C===0?s=0:s=f.get(g-1,C-1),g>0&&C>0&&S.get(g-1,C-1)===3&&(s+=t.get(g-1,C-1)),s+=o?o(g,C):1):s=-1;const a=Math.max(u,d,s);if(a===s){const r=g>0&&C>0?t.get(g-1,C-1):0;t.set(g,C,r+1),S.set(g,C,3)}else a===u?(t.set(g,C,0),S.set(g,C,1)):a===d&&(t.set(g,C,0),S.set(g,C,2));f.set(g,C,a)}const w=[];let h=p.length,m=v.length;function L(g,C){(g+1!==h||C+1!==m)&&w.push(new A.SequenceDiff(new A.OffsetRange(g+1,h),new A.OffsetRange(C+1,m))),h=g,m=C}let y=p.length-1,_=v.length-1;for(;y>=0&&_>=0;)S.get(y,_)===3?(L(y,_),y--,_--):S.get(y,_)===1?y--:_--;return L(-1,-1),w.reverse(),w}}i.DynamicProgrammingDiffing=E}),X(Q[19],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineRange=i.RangeMapping=i.LineRangeMapping=void 0;class A{constructor(p,v,o){this.originalRange=p,this.modifiedRange=v,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}i.LineRangeMapping=A;class e{constructor(p,v){this.originalRange=p,this.modifiedRange=v}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}i.RangeMapping=e;class E{constructor(p,v){this.startLineNumber=p,this.endLineNumberExclusive=v}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(p){return new E(this.startLineNumber+p,this.endLineNumberExclusive+p)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(p){return new E(Math.min(this.startLineNumber,p.startLineNumber),Math.max(this.endLineNumberExclusive,p.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}i.LineRange=E}),X(Q[37],J([0,1,15,19,4,2,9]),function(U,i,A,e,E,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiffComputer=i.SmartLinesDiffComputer=void 0;const v=3;class o{computeDiff(u,d,s){var a;const c=new L(u,d,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),b=[];let N=null;for(const M of c.changes){let R;M.originalEndLineNumber===0?R=new e.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):R=new e.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let P;M.modifiedEndLineNumber===0?P=new e.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):P=new e.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let F=new e.LineRangeMapping(R,P,(a=M.charChanges)===null||a===void 0?void 0:a.map(V=>new e.RangeMapping(new l.Range(V.originalStartLineNumber,V.originalStartColumn,V.originalEndLineNumber,V.originalEndColumn),new l.Range(V.modifiedStartLineNumber,V.modifiedStartColumn,V.modifiedEndLineNumber,V.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===F.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===F.originalRange.startLineNumber)&&(F=new e.LineRangeMapping(N.originalRange.join(F.originalRange),N.modifiedRange.join(F.modifiedRange),N.innerChanges&&F.innerChanges?N.innerChanges.concat(F.innerChanges):void 0),b.pop()),b.push(F),N=F}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(b,(M,R)=>R.originalRange.startLineNumber-M.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-M.modifiedRange.endLineNumberExclusive&&M.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&M.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),{quitEarly:c.quitEarly,changes:b}}}i.SmartLinesDiffComputer=o;function f(C,u,d,s){return new A.LcsDiff(C,u,d).ComputeDiff(s)}class S{constructor(u){const d=[],s=[];for(let a=0,r=u.length;a<r;a++)d[a]=y(u[a],1),s[a]=_(u[a],1);this.lines=u,this.a=d,this.b=s}getElements(){const u=[];for(let d=0,s=this.lines.length;d<s;d++)u[d]=this.lines[d].substring(this.a[d]-1,this.b[d]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,d,s){const a=[],r=[],c=[];let b=0;for(let N=d;N<=s;N++){const M=this.lines[N],R=u?this.a[N]:1,P=u?this.b[N]:M.length+1;for(let F=R;F<P;F++)a[b]=M.charCodeAt(F-1),r[b]=N+1,c[b]=F,b++;!u&&N<s&&(a[b]=10,r[b]=N+1,c[b]=M.length+1,b++)}return new t(a,r,c)}}class t{constructor(u,d,s){this.a=u,this.b=d,this.d=s}toString(){return"["+this.a.map((u,d)=>(u===10?"\\n":String.fromCharCode(u))+`-(${this.b[d]},${this.d[d]})`).join(", ")+"]"}e(u,d){if(u<0||u>=d.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(u){return u>0&&u===this.b.length?this.getEndLineNumber(u-1):(this.e(u,this.b),this.b[u])}getEndLineNumber(u){return u===-1?this.getStartLineNumber(u+1):(this.e(u,this.b),this.a[u]===10?this.b[u]+1:this.b[u])}getStartColumn(u){return u>0&&u===this.d.length?this.getEndColumn(u-1):(this.e(u,this.d),this.d[u])}getEndColumn(u){return u===-1?this.getStartColumn(u+1):(this.e(u,this.d),this.a[u]===10?1:this.d[u]+1)}}class w{constructor(u,d,s,a,r,c,b,N){this.originalStartLineNumber=u,this.originalStartColumn=d,this.originalEndLineNumber=s,this.originalEndColumn=a,this.modifiedStartLineNumber=r,this.modifiedStartColumn=c,this.modifiedEndLineNumber=b,this.modifiedEndColumn=N}static createFromDiffChange(u,d,s){const a=d.getStartLineNumber(u.originalStart),r=d.getStartColumn(u.originalStart),c=d.getEndLineNumber(u.originalStart+u.originalLength-1),b=d.getEndColumn(u.originalStart+u.originalLength-1),N=s.getStartLineNumber(u.modifiedStart),M=s.getStartColumn(u.modifiedStart),R=s.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),P=s.getEndColumn(u.modifiedStart+u.modifiedLength-1);return new w(a,r,c,b,N,M,R,P)}}function h(C){if(C.length<=1)return C;const u=[C[0]];let d=u[0];for(let s=1,a=C.length;s<a;s++){const r=C[s],c=r.originalStart-(d.originalStart+d.originalLength),b=r.modifiedStart-(d.modifiedStart+d.modifiedLength);Math.min(c,b)<v?(d.originalLength=r.originalStart+r.originalLength-d.originalStart,d.modifiedLength=r.modifiedStart+r.modifiedLength-d.modifiedStart):(u.push(r),d=r)}return u}class m{constructor(u,d,s,a,r){this.originalStartLineNumber=u,this.originalEndLineNumber=d,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=a,this.charChanges=r}static createFromDiffResult(u,d,s,a,r,c,b){let N,M,R,P,F;if(d.originalLength===0?(N=s.getStartLineNumber(d.originalStart)-1,M=0):(N=s.getStartLineNumber(d.originalStart),M=s.getEndLineNumber(d.originalStart+d.originalLength-1)),d.modifiedLength===0?(R=a.getStartLineNumber(d.modifiedStart)-1,P=0):(R=a.getStartLineNumber(d.modifiedStart),P=a.getEndLineNumber(d.modifiedStart+d.modifiedLength-1)),c&&d.originalLength>0&&d.originalLength<20&&d.modifiedLength>0&&d.modifiedLength<20&&r()){const V=s.createCharSequence(u,d.originalStart,d.originalStart+d.originalLength-1),O=a.createCharSequence(u,d.modifiedStart,d.modifiedStart+d.modifiedLength-1);if(V.getElements().length>0&&O.getElements().length>0){let q=f(V,O,r,!0).changes;b&&(q=h(q)),F=[];for(let k=0,I=q.length;k<I;k++)F.push(w.createFromDiffChange(q[k],V,O))}}return new m(N,M,R,P,F)}}class L{constructor(u,d,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=u,this.g=d,this.h=new S(u),this.j=new S(d),this.k=g(s.maxComputationTime),this.l=g(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const u=f(this.h,this.j,this.k,this.e),d=u.changes,s=u.quitEarly;if(this.d){const b=[];for(let N=0,M=d.length;N<M;N++)b.push(m.createFromDiffResult(this.d,d[N],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:b}}const a=[];let r=0,c=0;for(let b=-1,N=d.length;b<N;b++){const M=b+1<N?d[b+1]:null,R=M?M.originalStart:this.f.length,P=M?M.modifiedStart:this.g.length;for(;r<R&&c<P;){const F=this.f[r],V=this.g[c];if(F!==V){{let O=y(F,1),q=y(V,1);for(;O>1&&q>1;){const k=F.charCodeAt(O-2),I=V.charCodeAt(q-2);if(k!==I)break;O--,q--}(O>1||q>1)&&this.m(a,r+1,1,O,c+1,1,q)}{let O=_(F,1),q=_(V,1);const k=F.length+1,I=V.length+1;for(;O<k&&q<I;){const T=F.charCodeAt(O-1),W=F.charCodeAt(q-1);if(T!==W)break;O++,q++}(O<k||q<I)&&this.m(a,r+1,O,k,c+1,q,I)}}r++,c++}M&&(a.push(m.createFromDiffResult(this.d,M,this.h,this.j,this.l,this.a,this.b)),r+=M.originalLength,c+=M.modifiedLength)}return{quitEarly:s,changes:a}}m(u,d,s,a,r,c,b){if(this.n(u,d,s,a,r,c,b))return;let N;this.a&&(N=[new w(d,s,d,a,r,c,r,b)]),u.push(new m(d,d,r,r,N))}n(u,d,s,a,r,c,b){const N=u.length;if(N===0)return!1;const M=u[N-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber===d&&M.modifiedEndLineNumber===r?(this.a&&M.charChanges&&M.charChanges.push(new w(d,s,d,a,r,c,r,b)),!0):M.originalEndLineNumber+1===d&&M.modifiedEndLineNumber+1===r?(M.originalEndLineNumber=d,M.modifiedEndLineNumber=r,this.a&&M.charChanges&&M.charChanges.push(new w(d,s,d,a,r,c,r,b)),!0):!1}}i.DiffComputer=L;function y(C,u){const d=E.firstNonWhitespaceIndex(C);return d===-1?u:d+1}function _(C,u){const d=E.lastNonWhitespaceIndex(C);return d===-1?u:d+2}function g(C){if(C===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<C}}),X(Q[38],J([0,1,9,3,2,6,36,33,34,19]),function(U,i,A,e,E,l,p,v,o,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineSequence=i.lineRangeMappingFromRangeMappings=i.StandardLinesDiffComputer=void 0;class S{constructor(){this.b=new p.DynamicProgrammingDiffing,this.c=new o.MyersDiffAlgorithm}computeDiff(d,s,a){const r=new Map;function c(I){let T=r.get(I);return T===void 0&&(T=r.size,r.set(I,T)),T}const b=d.map(I=>c(I.trim())),N=s.map(I=>c(I.trim())),M=new h(b,d),R=new h(N,s);let P=(()=>M.length+R.length<1500?this.b.compute(M,R,(I,T)=>d[I]===s[T]?s[T].length===0?.1:1+Math.log(1+s[T].length):.99):this.c.compute(M,R))();P=(0,v.optimizeSequenceDiffs)(M,R,P);const F=[],V=I=>{for(let T=0;T<I;T++){const W=O+T,H=q+T;if(d[W]!==s[H]){const n=this.e(d,s,new l.SequenceDiff(new l.OffsetRange(W,W+1),new l.OffsetRange(H,H+1)));for(const se of n)F.push(se)}}};let O=0,q=0;for(const I of P){(0,A.assertFn)(()=>I.seq1Range.start-O===I.seq2Range.start-q);const T=I.seq1Range.start-O;V(T),O=I.seq1Range.endExclusive,q=I.seq2Range.endExclusive;const W=this.e(d,s,I);for(const H of W)F.push(H)}V(d.length-O);const k=t(F);return{quitEarly:!1,changes:k}}e(d,s,a){const r=new L(d,a.seq1Range),c=new L(s,a.seq2Range),b=r.length+c.length<500?this.b.compute(r,c):this.c.compute(r,c);let N=(0,v.optimizeSequenceDiffs)(r,c,b);return N=(0,v.smoothenSequenceDiffs)(r,c,N),N.map(R=>new f.RangeMapping(r.translateRange(R.seq1Range).delta(a.seq1Range.start),c.translateRange(R.seq2Range).delta(a.seq2Range.start)))}}i.StandardLinesDiffComputer=S;function t(u){const d=[];for(const s of w(u,(a,r)=>r.originalRange.startLineNumber-(a.originalRange.endLineNumber-(a.originalRange.endColumn>1?0:1))<=1||r.modifiedRange.startLineNumber-(a.modifiedRange.endLineNumber-(a.modifiedRange.endColumn>1?0:1))<=1)){const a=s[0],r=s[s.length-1];d.push(new f.LineRangeMapping(new f.LineRange(a.originalRange.startLineNumber,r.originalRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),new f.LineRange(a.modifiedRange.startLineNumber,r.modifiedRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),s))}return(0,A.assertFn)(()=>(0,A.checkAdjacentItems)(d,(s,a)=>a.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===a.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<a.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<a.modifiedRange.startLineNumber)),d}i.lineRangeMappingFromRangeMappings=t;function*w(u,d){let s,a;for(const r of u)a!==void 0&&d(a,r)?s.push(r):(s&&(yield s),s=[r]),a=r;s&&(yield s)}class h{constructor(d,s){this.b=d,this.c=s}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=d===0?0:m(this.c[d-1]),a=d===this.c.length?0:m(this.c[d]);return 1e3-(s+a)}}i.LineSequence=h;function m(u){let d=0;for(;d<u.length&&(u.charCodeAt(d)===32||u.charCodeAt(d)===9);)d++;return d}class L{constructor(d,s){this.lines=d,this.lineRange=s;let a=0;this.c=new Int32Array(s.length);for(let c=s.start;c<s.endExclusive;c++)a+=d[c].length,this.c[c-s.start]=a+1,a++;this.b=new Int32Array(a);let r=0;for(let c=s.start;c<s.endExclusive;c++){const b=d[c];for(let N=0;N<b.length;N++)this.b[r+N]=b.charCodeAt(N);r+=b.length,c<d.length-1&&(this.b[r]=`
`.charCodeAt(0),r+=1)}}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=g(d>0?this.b[d-1]:-1),a=g(d<this.b.length?this.b[d]:-1);if(s===6&&a===7)return 0;let r=0;return s!==a&&(r+=10,a===1&&(r+=1)),r+=_(s),r+=_(a),r}translateOffset(d){let s=0,a=this.c.length;for(;s<a;){const c=Math.floor((s+a)/2);this.c[c]>d?a=c:s=c+1}const r=s===0?0:this.c[s-1];return new e.Position(s+1,d-r+1)}translateRange(d){return E.Range.fromPositions(this.translateOffset(d.start),this.translateOffset(d.endExclusive))}}const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function _(u){return y[u]}function g(u){return u===10?7:u===13?6:C(u)?5:u>=97&&u<=122?0:u>=65&&u<=90?1:u>=48&&u<=57?2:u===-1?3:4}function C(u){return u===32||u===9}}),X(Q[39],J([0,1,37,38]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.linesDiffComputers=void 0,i.linesDiffComputers={smart:new A.SmartLinesDiffComputer,experimental:new e.StandardLinesDiffComputer}}),X(Q[40],J([0,1,17]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeLinks=i.LinkComputer=i.StateMachine=void 0;class e{constructor(w,h,m){const L=new Uint8Array(w*h);for(let y=0,_=w*h;y<_;y++)L[y]=m;this.a=L,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,m){this.a[w*this.cols+h]=m}}class E{constructor(w){let h=0,m=0;for(let y=0,_=w.length;y<_;y++){const[g,C,u]=w[y];C>h&&(h=C),g>m&&(m=g),u>m&&(m=u)}h++,m++;const L=new e(m,h,0);for(let y=0,_=w.length;y<_;y++){const[g,C,u]=w[y];L.set(g,C,u)}this.a=L,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}i.StateMachine=E;let l=null;function p(){return l===null&&(l=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let v=null;function o(){if(v===null){v=new A.CharacterClassifier(0);const t=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<t.length;h++)v.set(t.charCodeAt(h),1);const w=".;:";for(let h=0;h<w.length;h++)v.set(w.charCodeAt(h),2)}return v}class f{static a(w,h,m,L,y){let _=y-1;do{const g=h.charCodeAt(_);if(w.get(g)!==2)break;_--}while(_>L);if(L>0){const g=h.charCodeAt(L-1),C=h.charCodeAt(_);(g===40&&C===41||g===91&&C===93||g===123&&C===125)&&_--}return{range:{startLineNumber:m,startColumn:L+1,endLineNumber:m,endColumn:_+2},url:h.substring(L,_+1)}}static computeLinks(w,h=p()){const m=o(),L=[];for(let y=1,_=w.getLineCount();y<=_;y++){const g=w.getLineContent(y),C=g.length;let u=0,d=0,s=0,a=1,r=!1,c=!1,b=!1,N=!1;for(;u<C;){let M=!1;const R=g.charCodeAt(u);if(a===13){let P;switch(R){case 40:r=!0,P=0;break;case 41:P=r?0:1;break;case 91:b=!0,c=!0,P=0;break;case 93:b=!1,P=c?0:1;break;case 123:N=!0,P=0;break;case 125:P=N?0:1;break;case 39:case 34:case 96:s===R?P=1:s===39||s===34||s===96?P=0:P=1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=b?0:1;break;default:P=m.get(R)}P===1&&(L.push(f.a(m,g,y,d,u)),M=!0)}else if(a===12){let P;R===91?(c=!0,P=0):P=m.get(R),P===1?M=!0:a=13}else a=h.nextState(a,R),a===0&&(M=!0);M&&(a=1,r=!1,c=!1,N=!1,d=u+1,s=R),u++}a===13&&L.push(f.a(m,g,y,d,C))}return L}}i.LinkComputer=f;function S(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:f.computeLinks(t)}i.computeLinks=S}),X(Q[41],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.BasicInplaceReplace=void 0;class A{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(E,l,p,v,o){if(E&&l){const f=this.a(l,o);if(f)return{range:E,value:f}}if(p&&v){const f=this.a(v,o);if(f)return{range:p,value:f}}return null}a(E,l){const p=this.b(E,l);return p!==null?p:this.d(E,l)}b(E,l){const p=Math.pow(10,E.length-(E.lastIndexOf(".")+1));let v=Number(E);const o=parseFloat(E);return!isNaN(v)&&!isNaN(o)&&v===o?v===0&&!l?null:(v=Math.floor(v*p),v+=l?p:-p,String(v/p)):null}d(E,l){return this.e(this.c,E,l)}e(E,l,p){let v=null;for(let o=0,f=E.length;v===null&&o<f;o++)v=this.f(E[o],l,p);return v}f(E,l,p){let v=E.indexOf(l);return v>=0?(v+=p?1:-1,v<0?v=E.length-1:v%=E.length,E[v]):null}}i.BasicInplaceReplace=A,A.INSTANCE=new A}),X(Q[42],J([0,1,11]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.shouldSynchronizeModel=i.ApplyEditsResult=i.SearchData=i.ValidAnnotatedEditOperation=i.isITextSnapshot=i.FindMatch=i.TextModelResolvedOptions=i.InjectedTextCursorStops=i.MinimapPosition=i.OverviewRulerLane=void 0;var e;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(e=i.OverviewRulerLane||(i.OverviewRulerLane={}));var E;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(E=i.MinimapPosition||(i.MinimapPosition={}));var l;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(l=i.InjectedTextCursorStops||(i.InjectedTextCursorStops={}));class p{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}i.TextModelResolvedOptions=p;class v{constructor(m,L){this._findMatchBrand=void 0,this.range=m,this.matches=L}}i.FindMatch=v;function o(h){return h&&typeof h.read=="function"}i.isITextSnapshot=o;class f{constructor(m,L,y,_,g,C){this.identifier=m,this.range=L,this.text=y,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=g,this._isTracked=C}}i.ValidAnnotatedEditOperation=f;class S{constructor(m,L,y){this.regex=m,this.wordSeparators=L,this.simpleSearch=y}}i.SearchData=S;class t{constructor(m,L,y){this.reverseEdits=m,this.changes=L,this.trimAutoWhitespaceLineNumbers=y}}i.ApplyEditsResult=t;function w(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}i.shouldSynchronizeModel=w}),X(Q[43],J([0,1,22,16]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PrefixSumIndexOfResult=i.ConstantTimePrefixSumComputer=i.PrefixSumComputer=void 0;class E{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(o,f){o=(0,e.toUint32)(o);const S=this.a,t=this.b,w=f.length;return w===0?!1:(this.a=new Uint32Array(S.length+w),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o),o+w),this.a.set(f,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(t.subarray(0,this.c[0]+1)),!0)}setValue(o,f){return o=(0,e.toUint32)(o),f=(0,e.toUint32)(f),this.a[o]===f?!1:(this.a[o]=f,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,f){o=(0,e.toUint32)(o),f=(0,e.toUint32)(f);const S=this.a,t=this.b;if(o>=S.length)return!1;const w=S.length-o;return f>=w&&(f=w),f===0?!1:(this.a=new Uint32Array(S.length-f),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o+f),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(t.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,e.toUint32)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let f=this.c[0]+1;f===0&&(this.b[0]=this.a[0],f++),o>=this.a.length&&(o=this.a.length-1);for(let S=f;S<=o;S++)this.b[S]=this.b[S-1]+this.a[S];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let f=0,S=this.a.length-1,t=0,w=0,h=0;for(;f<=S;)if(t=f+(S-f)/2|0,w=this.b[t],h=w-this.a[t],o<h)S=t-1;else if(o>=w)f=t+1;else break;return new p(t,o-h)}}i.PrefixSumComputer=E;class l{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const f=this.e[o],S=f>0?this.d[f-1]:0;return new p(f,o-S)}removeValues(o,f){this.a.splice(o,f),this.f(o)}insertValues(o,f){this.a=(0,A.arrayInsert)(this.a,o,f),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,f=this.a.length;o<f;o++){const S=this.a[o],t=o>0?this.d[o-1]:0;this.d[o]=t+S;for(let w=0;w<S;w++)this.e[t+w]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,f){this.a[o]!==f&&(this.a[o]=f,this.f(o))}}i.ConstantTimePrefixSumComputer=l;class p{constructor(o,f){this.index=o,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=f}}i.PrefixSumIndexOfResult=p}),X(Q[44],J([0,1,4,3,43]),function(U,i,A,e,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MirrorTextModel=void 0;class l{constructor(v,o,f,S){this.c=v,this.d=o,this.f=f,this.g=S,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(v){v.eol&&v.eol!==this.f&&(this.f=v.eol,this.h=null);const o=v.changes;for(const f of o)this.n(f.range),this.o(new e.Position(f.range.startLineNumber,f.range.startColumn),f.text);this.g=v.versionId,this.j=null}k(){if(!this.h){const v=this.f.length,o=this.d.length,f=new Uint32Array(o);for(let S=0;S<o;S++)f[S]=this.d[S].length+v;this.h=new E.PrefixSumComputer(f)}}l(v,o){this.d[v]=o,this.h&&this.h.setValue(v,this.d[v].length+this.f.length)}n(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.l(v.startLineNumber-1,this.d[v.startLineNumber-1].substring(0,v.startColumn-1)+this.d[v.startLineNumber-1].substring(v.endColumn-1));return}this.l(v.startLineNumber-1,this.d[v.startLineNumber-1].substring(0,v.startColumn-1)+this.d[v.endLineNumber-1].substring(v.endColumn-1)),this.d.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.h&&this.h.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}o(v,o){if(o.length===0)return;const f=(0,A.splitLines)(o);if(f.length===1){this.l(v.lineNumber-1,this.d[v.lineNumber-1].substring(0,v.column-1)+f[0]+this.d[v.lineNumber-1].substring(v.column-1));return}f[f.length-1]+=this.d[v.lineNumber-1].substring(v.column-1),this.l(v.lineNumber-1,this.d[v.lineNumber-1].substring(0,v.column-1)+f[0]);const S=new Uint32Array(f.length-1);for(let t=1;t<f.length;t++)this.d.splice(v.lineNumber+t-1,0,f[t]),S[t-1]=f[t].length+this.f.length;this.h&&this.h.insertValues(v.lineNumber,S)}}i.MirrorTextModel=l}),X(Q[45],J([0,1,4,32,3,2,42]),function(U,i,A,e,E,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Searcher=i.isValidMatch=i.TextModelSearch=i.createFindMatch=i.isMultilineRegexSource=i.SearchParams=void 0;const v=999;class o{constructor(g,C,u,d){this.searchString=g,this.isRegex=C,this.matchCase=u,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=f(this.searchString):g=this.searchString.indexOf(`
`)>=0;let C=null;try{C=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!C)return null;let u=!this.isRegex&&!g;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new p.SearchData(C,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,u?this.searchString:null)}}i.SearchParams=o;function f(_){if(!_||_.length===0)return!1;for(let g=0,C=_.length;g<C;g++){const u=_.charCodeAt(g);if(u===10)return!0;if(u===92){if(g++,g>=C)break;const d=_.charCodeAt(g);if(d===110||d===114||d===87)return!0}}return!1}i.isMultilineRegexSource=f;function S(_,g,C){if(!C)return new p.FindMatch(_,null);const u=[];for(let d=0,s=g.length;d<s;d++)u[d]=g[d];return new p.FindMatch(_,u)}i.createFindMatch=S;class t{constructor(g){const C=[];let u=0;for(let d=0,s=g.length;d<s;d++)g.charCodeAt(d)===10&&(C[u++]=d);this.a=C}findLineFeedCountBeforeOffset(g){const C=this.a;let u=0,d=C.length-1;if(d===-1||g<=C[0])return 0;for(;u<d;){const s=u+((d-u)/2>>0);C[s]>=g?d=s-1:C[s+1]>=g?(u=s,d=s):u=s+1}return u+1}}class w{static findMatches(g,C,u,d,s){const a=C.parseSearchRequest();return a?a.regex.multiline?this.b(g,u,new y(a.wordSeparators,a.regex),d,s):this.c(g,u,a,d,s):[]}static a(g,C,u,d,s,a){let r,c=0;d?(c=d.findLineFeedCountBeforeOffset(s),r=C+s+c):r=C+s;let b;if(d){const P=d.findLineFeedCountBeforeOffset(s+a.length)-c;b=r+a.length+P}else b=r+a.length;const N=g.getPositionAt(r),M=g.getPositionAt(b);return new l.Range(N.lineNumber,N.column,M.lineNumber,M.column)}static b(g,C,u,d,s){const a=g.getOffsetAt(C.getStartPosition()),r=g.getValueInRange(C,1),c=g.getEOL()===`\r
`?new t(r):null,b=[];let N=0,M;for(u.reset(0);M=u.next(r);)if(b[N++]=S(this.a(g,a,r,c,M.index,M[0]),M,d),N>=s)return b;return b}static c(g,C,u,d,s){const a=[];let r=0;if(C.startLineNumber===C.endLineNumber){const b=g.getLineContent(C.startLineNumber).substring(C.startColumn-1,C.endColumn-1);return r=this.d(u,b,C.startLineNumber,C.startColumn-1,r,a,d,s),a}const c=g.getLineContent(C.startLineNumber).substring(C.startColumn-1);r=this.d(u,c,C.startLineNumber,C.startColumn-1,r,a,d,s);for(let b=C.startLineNumber+1;b<C.endLineNumber&&r<s;b++)r=this.d(u,g.getLineContent(b),b,0,r,a,d,s);if(r<s){const b=g.getLineContent(C.endLineNumber).substring(0,C.endColumn-1);r=this.d(u,b,C.endLineNumber,0,r,a,d,s)}return a}static d(g,C,u,d,s,a,r,c){const b=g.wordSeparators;if(!r&&g.simpleSearch){const R=g.simpleSearch,P=R.length,F=C.length;let V=-P;for(;(V=C.indexOf(R,V+P))!==-1;)if((!b||L(b,C,F,V,P))&&(a[s++]=new p.FindMatch(new l.Range(u,V+1+d,u,V+1+P+d),null),s>=c))return s;return s}const N=new y(g.wordSeparators,g.regex);let M;N.reset(0);do if(M=N.next(C),M&&(a[s++]=S(new l.Range(u,M.index+1+d,u,M.index+1+M[0].length+d),M,r),s>=c))return s;while(M);return s}static findNextMatch(g,C,u,d){const s=C.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.e(g,u,a,d):this.f(g,u,a,d)}static e(g,C,u,d){const s=new E.Position(C.lineNumber,1),a=g.getOffsetAt(s),r=g.getLineCount(),c=g.getValueInRange(new l.Range(s.lineNumber,s.column,r,g.getLineMaxColumn(r)),1),b=g.getEOL()===`\r
`?new t(c):null;u.reset(C.column-1);const N=u.next(c);return N?S(this.a(g,a,c,b,N.index,N[0]),N,d):C.lineNumber!==1||C.column!==1?this.e(g,new E.Position(1,1),u,d):null}static f(g,C,u,d){const s=g.getLineCount(),a=C.lineNumber,r=g.getLineContent(a),c=this.g(u,r,a,C.column,d);if(c)return c;for(let b=1;b<=s;b++){const N=(a+b-1)%s,M=g.getLineContent(N+1),R=this.g(u,M,N+1,1,d);if(R)return R}return null}static g(g,C,u,d,s){g.reset(d-1);const a=g.next(C);return a?S(new l.Range(u,a.index+1,u,a.index+1+a[0].length),a,s):null}static findPreviousMatch(g,C,u,d){const s=C.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.h(g,u,a,d):this.j(g,u,a,d)}static h(g,C,u,d){const s=this.b(g,new l.Range(1,1,C.lineNumber,C.column),u,d,10*v);if(s.length>0)return s[s.length-1];const a=g.getLineCount();return C.lineNumber!==a||C.column!==g.getLineMaxColumn(a)?this.h(g,new E.Position(a,g.getLineMaxColumn(a)),u,d):null}static j(g,C,u,d){const s=g.getLineCount(),a=C.lineNumber,r=g.getLineContent(a).substring(0,C.column-1),c=this.k(u,r,a,d);if(c)return c;for(let b=1;b<=s;b++){const N=(s+a-b-1)%s,M=g.getLineContent(N+1),R=this.k(u,M,N+1,d);if(R)return R}return null}static k(g,C,u,d){let s=null,a;for(g.reset(0);a=g.next(C);)s=S(new l.Range(u,a.index+1,u,a.index+1+a[0].length),a,d);return s}}i.TextModelSearch=w;function h(_,g,C,u,d){if(u===0)return!0;const s=g.charCodeAt(u-1);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(u);if(_.get(a)!==0)return!0}return!1}function m(_,g,C,u,d){if(u+d===C)return!0;const s=g.charCodeAt(u+d);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(u+d-1);if(_.get(a)!==0)return!0}return!1}function L(_,g,C,u,d){return h(_,g,C,u,d)&&m(_,g,C,u,d)}i.isValidMatch=L;class y{constructor(g,C){this._wordSeparators=g,this.a=C,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const C=g.length;let u;do{if(this.b+this.c===C||(u=this.a.exec(g),!u))return null;const d=u.index,s=u[0].length;if(d===this.b&&s===this.c){if(s===0){A.getNextCodePoint(g,C,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=d,this.c=s,!this._wordSeparators||L(this._wordSeparators,g,C,d,s))return u}while(u);return null}}i.Searcher=y}),X(Q[46],J([0,1,2,45,4,9,18]),function(U,i,A,e,E,l,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(w,h,m){const L=m?m.startLineNumber:1,y=m?m.endLineNumber:w.getLineCount(),_=new f(h),g=_.getCandidateCodePoints();let C;g==="allNonBasicAscii"?C=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):C=new RegExp(`${o(Array.from(g))}`,"g");const u=new e.Searcher(null,C),d=[];let s=!1,a,r=0,c=0,b=0;e:for(let N=L,M=y;N<=M;N++){const R=w.getLineContent(N),P=R.length;u.reset(0);do if(a=u.next(R),a){let F=a.index,V=a.index+a[0].length;if(F>0){const I=R.charCodeAt(F-1);E.isHighSurrogate(I)&&F--}if(V+1<P){const I=R.charCodeAt(V-1);E.isHighSurrogate(I)&&V++}const O=R.substring(F,V);let q=(0,p.getWordAtText)(F+1,p.DEFAULT_WORD_REGEXP,R,0);q&&q.endColumn<=F+1&&(q=null);const k=_.shouldHighlightNonBasicASCII(O,q?q.word:null);if(k!==0){k===3?r++:k===2?c++:k===1?b++:(0,l.assertNever)(k);const I=1e3;if(d.length>=I){s=!0;break e}d.push(new A.Range(N,F+1,N,V+1))}}while(a)}return{ranges:d,hasMore:s,ambiguousCharacterCount:r,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(w,h){const m=new f(h);switch(m.shouldHighlightNonBasicASCII(w,null)){case 0:return null;case 2:return{kind:1};case 3:{const y=w.codePointAt(0),_=m.ambiguousCharacters.getPrimaryConfusable(y),g=E.AmbiguousCharacters.getLocales().filter(C=>!E.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,C])).isAmbiguous(y));return{kind:0,confusableWith:String.fromCodePoint(_),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}i.UnicodeTextModelHighlighter=v;function o(t,w){return`[${E.escapeRegExpCharacters(t.map(m=>String.fromCodePoint(m)).join(""))}]`}class f{constructor(w){this.b=w,this.a=new Set(w.allowedCodePoints),this.ambiguousCharacters=E.AmbiguousCharacters.getInstance(new Set(w.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const w=new Set;if(this.b.invisibleCharacters)for(const h of E.InvisibleCharacters.codePoints)S(String.fromCodePoint(h))||w.add(h);if(this.b.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())w.add(h);for(const h of this.a)w.delete(h);return w}shouldHighlightNonBasicASCII(w,h){const m=w.codePointAt(0);if(this.a.has(m))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,y=!1;if(h)for(const _ of h){const g=_.codePointAt(0),C=E.isBasicASCII(_);L=L||C,!C&&!this.ambiguousCharacters.isAmbiguous(g)&&!E.InvisibleCharacters.isInvisibleCharacter(g)&&(y=!0)}return!L&&y?0:this.b.invisibleCharacters&&!S(w)&&E.InvisibleCharacters.isInvisibleCharacter(m)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(m)?3:0}}function S(t){return t===" "||t===`
`||t==="	"}}),X(Q[47],J([0,1]),function(U,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.MouseTargetType=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var A;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(A=i.AccessibilitySupport||(i.AccessibilitySupport={}));var e;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(e=i.CodeActionTriggerType||(i.CodeActionTriggerType={}));var E;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(E=i.CompletionItemInsertTextRule||(i.CompletionItemInsertTextRule={}));var l;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(l=i.CompletionItemKind||(i.CompletionItemKind={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p=i.CompletionItemTag||(i.CompletionItemTag={}));var v;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v=i.CompletionTriggerKind||(i.CompletionTriggerKind={}));var o;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(o=i.ContentWidgetPositionPreference||(i.ContentWidgetPositionPreference={}));var f;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(f=i.CursorChangeReason||(i.CursorChangeReason={}));var S;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(S=i.DefaultEndOfLine||(i.DefaultEndOfLine={}));var t;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(t=i.DocumentHighlightKind||(i.DocumentHighlightKind={}));var w;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(w=i.EditorAutoIndentStrategy||(i.EditorAutoIndentStrategy={}));var h;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(h=i.EditorOption||(i.EditorOption={}));var m;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m=i.EndOfLinePreference||(i.EndOfLinePreference={}));var L;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(L=i.EndOfLineSequence||(i.EndOfLineSequence={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y=i.IndentAction||(i.IndentAction={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_=i.InjectedTextCursorStops||(i.InjectedTextCursorStops={}));var g;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(g=i.InlayHintKind||(i.InlayHintKind={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C=i.InlineCompletionTriggerKind||(i.InlineCompletionTriggerKind={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(u=i.KeyCode||(i.KeyCode={}));var d;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(d=i.MarkerSeverity||(i.MarkerSeverity={}));var s;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(s=i.MarkerTag||(i.MarkerTag={}));var a;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(a=i.MinimapPosition||(i.MinimapPosition={}));var r;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(r=i.MouseTargetType||(i.MouseTargetType={}));var c;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(c=i.OverlayWidgetPositionPreference||(i.OverlayWidgetPositionPreference={}));var b;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(b=i.OverviewRulerLane||(i.OverviewRulerLane={}));var N;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(N=i.PositionAffinity||(i.PositionAffinity={}));var M;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(M=i.RenderLineNumbersType||(i.RenderLineNumbersType={}));var R;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(R=i.RenderMinimap||(i.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=i.ScrollType||(i.ScrollType={}));var F;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(F=i.ScrollbarVisibility||(i.ScrollbarVisibility={}));var V;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(V=i.SelectionDirection||(i.SelectionDirection={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O=i.SignatureHelpTriggerKind||(i.SignatureHelpTriggerKind={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q=i.SymbolKind||(i.SymbolKind={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k=i.SymbolTag||(i.SymbolTag={}));var I;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(I=i.TextEditorCursorBlinkingStyle||(i.TextEditorCursorBlinkingStyle={}));var T;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(T=i.TextEditorCursorStyle||(i.TextEditorCursorStyle={}));var W;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W=i.TrackedRangeStickiness||(i.TrackedRangeStickiness={}));var H;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(H=i.WrappingIndent||(i.WrappingIndent={}))}),X(Q[48],J([21,55]),function(U,i){return U.create("vs/base/common/platform",i)}),X(Q[5],J([0,1,48]),function(U,i,A){"use strict";var e;Object.defineProperty(i,"__esModule",{value:!0}),i.isAndroid=i.isEdge=i.isSafari=i.isFirefox=i.isChrome=i.isLittleEndian=i.OS=i.setTimeout0=i.setTimeout0IsFaster=i.language=i.userAgent=i.isMobile=i.isIOS=i.isWebWorker=i.isWeb=i.isNative=i.isLinux=i.isMacintosh=i.isWindows=i.globals=i.LANGUAGE_DEFAULT=void 0,i.LANGUAGE_DEFAULT="en";let E=!1,l=!1,p=!1,v=!1,o=!1,f=!1,S=!1,t=!1,w=!1,h=!1,m,L=i.LANGUAGE_DEFAULT,y,_;i.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof i.globals.vscode<"u"&&typeof i.globals.vscode.process<"u"?g=i.globals.vscode.process:typeof process<"u"&&(g=process);const C=typeof((e=g?.versions)===null||e===void 0?void 0:e.electron)=="string",u=C&&g?.type==="renderer";if(typeof navigator=="object"&&!u)_=navigator.userAgent,E=_.indexOf("Windows")>=0,l=_.indexOf("Macintosh")>=0,t=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=_.indexOf("Linux")>=0,h=_?.indexOf("Mobi")>=0,f=!0,m=A.getConfiguredDefaultLocale(A.localize(0,null))||i.LANGUAGE_DEFAULT,L=m;else if(typeof g=="object"){E=g.platform==="win32",l=g.platform==="darwin",p=g.platform==="linux",v=p&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,S=C,w=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=i.LANGUAGE_DEFAULT,L=i.LANGUAGE_DEFAULT;const c=g.env.VSCODE_NLS_CONFIG;if(c)try{const b=JSON.parse(c),N=b.availableLanguages["*"];m=b.locale,L=N||i.LANGUAGE_DEFAULT,y=b._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");let d=0;l?d=1:E?d=3:p&&(d=2),i.isWindows=E,i.isMacintosh=l,i.isLinux=p,i.isNative=o,i.isWeb=f,i.isWebWorker=f&&typeof i.globals.importScripts=="function",i.isIOS=t,i.isMobile=h,i.userAgent=_,i.language=L,i.setTimeout0IsFaster=typeof i.globals.postMessage=="function"&&!i.globals.importScripts,i.setTimeout0=(()=>{if(i.setTimeout0IsFaster){const c=[];i.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let M=0,R=c.length;M<R;M++){const P=c[M];if(P.id===N.data.vscodeScheduleAsyncWork){c.splice(M,1),P.callback();return}}});let b=0;return N=>{const M=++b;c.push({id:M,callback:N}),i.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return c=>setTimeout(c)})(),i.OS=l||t?2:E?1:3;let s=!0,a=!1;function r(){if(!a){a=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}i.isLittleEndian=r,i.isChrome=!!(i.userAgent&&i.userAgent.indexOf("Chrome")>=0),i.isFirefox=!!(i.userAgent&&i.userAgent.indexOf("Firefox")>=0),i.isSafari=!!(!i.isChrome&&i.userAgent&&i.userAgent.indexOf("Safari")>=0),i.isEdge=!!(i.userAgent&&i.userAgent.indexOf("Edg/")>=0),i.isAndroid=!!(i.userAgent&&i.userAgent.indexOf("Android")>=0)}),X(Q[49],J([0,1,5]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.platform=i.env=i.cwd=void 0;let e;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const E=A.globals.vscode.process;e={get platform(){return E.platform},get arch(){return E.arch},get env(){return E.env},cwd(){return E.cwd()}}}else typeof process<"u"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=e.cwd,i.env=e.env,i.platform=e.platform}),X(Q[50],J([0,1,49]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sep=i.extname=i.basename=i.dirname=i.relative=i.resolve=i.normalize=i.posix=i.win32=void 0;const e=65,E=97,l=90,p=122,v=46,o=47,f=92,S=58,t=63;class w extends Error{constructor(a,r,c){let b;typeof r=="string"&&r.indexOf("not ")===0?(b="must not be",r=r.replace(/^not /,"")):b="must be";const N=a.indexOf(".")!==-1?"property":"argument";let M=`The "${a}" ${N} ${b} of type ${r}`;M+=`. Received type ${typeof c}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,a){if(s===null||typeof s!="object")throw new w(a,"Object",s)}function m(s,a){if(typeof s!="string")throw new w(a,"string",s)}const L=A.platform==="win32";function y(s){return s===o||s===f}function _(s){return s===o}function g(s){return s>=e&&s<=l||s>=E&&s<=p}function C(s,a,r,c){let b="",N=0,M=-1,R=0,P=0;for(let F=0;F<=s.length;++F){if(F<s.length)P=s.charCodeAt(F);else{if(c(P))break;P=o}if(c(P)){if(!(M===F-1||R===1))if(R===2){if(b.length<2||N!==2||b.charCodeAt(b.length-1)!==v||b.charCodeAt(b.length-2)!==v){if(b.length>2){const V=b.lastIndexOf(r);V===-1?(b="",N=0):(b=b.slice(0,V),N=b.length-1-b.lastIndexOf(r)),M=F,R=0;continue}else if(b.length!==0){b="",N=0,M=F,R=0;continue}}a&&(b+=b.length>0?`${r}..`:"..",N=2)}else b.length>0?b+=`${r}${s.slice(M+1,F)}`:b=s.slice(M+1,F),N=F-M-1;M=F,R=0}else P===v&&R!==-1?++R:R=-1}return b}function u(s,a){h(a,"pathObject");const r=a.dir||a.root,c=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${c}`:`${r}${s}${c}`:c}i.win32={resolve(...s){let a="",r="",c=!1;for(let b=s.length-1;b>=-1;b--){let N;if(b>=0){if(N=s[b],m(N,"path"),N.length===0)continue}else a.length===0?N=A.cwd():(N=A.env[`=${a}`]||A.cwd(),(N===void 0||N.slice(0,2).toLowerCase()!==a.toLowerCase()&&N.charCodeAt(2)===f)&&(N=`${a}\\`));const M=N.length;let R=0,P="",F=!1;const V=N.charCodeAt(0);if(M===1)y(V)&&(R=1,F=!0);else if(y(V))if(F=!0,y(N.charCodeAt(1))){let O=2,q=O;for(;O<M&&!y(N.charCodeAt(O));)O++;if(O<M&&O!==q){const k=N.slice(q,O);for(q=O;O<M&&y(N.charCodeAt(O));)O++;if(O<M&&O!==q){for(q=O;O<M&&!y(N.charCodeAt(O));)O++;(O===M||O!==q)&&(P=`\\\\${k}\\${N.slice(q,O)}`,R=O)}}}else R=1;else g(V)&&N.charCodeAt(1)===S&&(P=N.slice(0,2),R=2,M>2&&y(N.charCodeAt(2))&&(F=!0,R=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(c){if(a.length>0)break}else if(r=`${N.slice(R)}\\${r}`,c=F,F&&a.length>0)break}return r=C(r,!c,"\\",y),c?`${a}\\${r}`:`${a}${r}`||"."},normalize(s){m(s,"path");const a=s.length;if(a===0)return".";let r=0,c,b=!1;const N=s.charCodeAt(0);if(a===1)return _(N)?"\\":s;if(y(N))if(b=!0,y(s.charCodeAt(1))){let R=2,P=R;for(;R<a&&!y(s.charCodeAt(R));)R++;if(R<a&&R!==P){const F=s.slice(P,R);for(P=R;R<a&&y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!y(s.charCodeAt(R));)R++;if(R===a)return`\\\\${F}\\${s.slice(P)}\\`;R!==P&&(c=`\\\\${F}\\${s.slice(P,R)}`,r=R)}}}else r=1;else g(N)&&s.charCodeAt(1)===S&&(c=s.slice(0,2),r=2,a>2&&y(s.charCodeAt(2))&&(b=!0,r=3));let M=r<a?C(s.slice(r),!b,"\\",y):"";return M.length===0&&!b&&(M="."),M.length>0&&y(s.charCodeAt(a-1))&&(M+="\\"),c===void 0?b?`\\${M}`:M:b?`${c}\\${M}`:`${c}${M}`},isAbsolute(s){m(s,"path");const a=s.length;if(a===0)return!1;const r=s.charCodeAt(0);return y(r)||a>2&&g(r)&&s.charCodeAt(1)===S&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,r;for(let N=0;N<s.length;++N){const M=s[N];m(M,"path"),M.length>0&&(a===void 0?a=r=M:a+=`\\${M}`)}if(a===void 0)return".";let c=!0,b=0;if(typeof r=="string"&&y(r.charCodeAt(0))){++b;const N=r.length;N>1&&y(r.charCodeAt(1))&&(++b,N>2&&(y(r.charCodeAt(2))?++b:c=!1))}if(c){for(;b<a.length&&y(a.charCodeAt(b));)b++;b>=2&&(a=`\\${a.slice(b)}`)}return i.win32.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a)return"";const r=i.win32.resolve(s),c=i.win32.resolve(a);if(r===c||(s=r.toLowerCase(),a=c.toLowerCase(),s===a))return"";let b=0;for(;b<s.length&&s.charCodeAt(b)===f;)b++;let N=s.length;for(;N-1>b&&s.charCodeAt(N-1)===f;)N--;const M=N-b;let R=0;for(;R<a.length&&a.charCodeAt(R)===f;)R++;let P=a.length;for(;P-1>R&&a.charCodeAt(P-1)===f;)P--;const F=P-R,V=M<F?M:F;let O=-1,q=0;for(;q<V;q++){const I=s.charCodeAt(b+q);if(I!==a.charCodeAt(R+q))break;I===f&&(O=q)}if(q!==V){if(O===-1)return c}else{if(F>V){if(a.charCodeAt(R+q)===f)return c.slice(R+q+1);if(q===2)return c.slice(R+q)}M>V&&(s.charCodeAt(b+q)===f?O=q:q===2&&(O=3)),O===-1&&(O=0)}let k="";for(q=b+O+1;q<=N;++q)(q===N||s.charCodeAt(q)===f)&&(k+=k.length===0?"..":"\\..");return R+=O,k.length>0?`${k}${c.slice(R,P)}`:(c.charCodeAt(R)===f&&++R,c.slice(R,P))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=i.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const r=a.charCodeAt(2);if(r!==t&&r!==v)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return s},dirname(s){m(s,"path");const a=s.length;if(a===0)return".";let r=-1,c=0;const b=s.charCodeAt(0);if(a===1)return y(b)?s:".";if(y(b)){if(r=c=1,y(s.charCodeAt(1))){let R=2,P=R;for(;R<a&&!y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!y(s.charCodeAt(R));)R++;if(R===a)return s;R!==P&&(r=c=R+1)}}}}else g(b)&&s.charCodeAt(1)===S&&(r=a>2&&y(s.charCodeAt(2))?3:2,c=r);let N=-1,M=!0;for(let R=a-1;R>=c;--R)if(y(s.charCodeAt(R))){if(!M){N=R;break}}else M=!1;if(N===-1){if(r===-1)return".";N=r}return s.slice(0,N)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let r=0,c=-1,b=!0,N;if(s.length>=2&&g(s.charCodeAt(0))&&s.charCodeAt(1)===S&&(r=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let M=a.length-1,R=-1;for(N=s.length-1;N>=r;--N){const P=s.charCodeAt(N);if(y(P)){if(!b){r=N+1;break}}else R===-1&&(b=!1,R=N+1),M>=0&&(P===a.charCodeAt(M)?--M===-1&&(c=N):(M=-1,c=R))}return r===c?c=R:c===-1&&(c=s.length),s.slice(r,c)}for(N=s.length-1;N>=r;--N)if(y(s.charCodeAt(N))){if(!b){r=N+1;break}}else c===-1&&(b=!1,c=N+1);return c===-1?"":s.slice(r,c)},extname(s){m(s,"path");let a=0,r=-1,c=0,b=-1,N=!0,M=0;s.length>=2&&s.charCodeAt(1)===S&&g(s.charCodeAt(0))&&(a=c=2);for(let R=s.length-1;R>=a;--R){const P=s.charCodeAt(R);if(y(P)){if(!N){c=R+1;break}continue}b===-1&&(N=!1,b=R+1),P===v?r===-1?r=R:M!==1&&(M=1):r!==-1&&(M=-1)}return r===-1||b===-1||M===0||M===1&&r===b-1&&r===c+1?"":s.slice(r,b)},format:u.bind(null,"\\"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.length;let c=0,b=s.charCodeAt(0);if(r===1)return y(b)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(y(b)){if(c=1,y(s.charCodeAt(1))){let O=2,q=O;for(;O<r&&!y(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&y(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&!y(s.charCodeAt(O));)O++;O===r?c=O:O!==q&&(c=O+1)}}}}else if(g(b)&&s.charCodeAt(1)===S){if(r<=2)return a.root=a.dir=s,a;if(c=2,y(s.charCodeAt(2))){if(r===3)return a.root=a.dir=s,a;c=3}}c>0&&(a.root=s.slice(0,c));let N=-1,M=c,R=-1,P=!0,F=s.length-1,V=0;for(;F>=c;--F){if(b=s.charCodeAt(F),y(b)){if(!P){M=F+1;break}continue}R===-1&&(P=!1,R=F+1),b===v?N===-1?N=F:V!==1&&(V=1):N!==-1&&(V=-1)}return R!==-1&&(N===-1||V===0||V===1&&N===R-1&&N===M+1?a.base=a.name=s.slice(M,R):(a.name=s.slice(M,N),a.base=s.slice(M,R),a.ext=s.slice(N,R))),M>0&&M!==c?a.dir=s.slice(0,M-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(L){const s=/\\/g;return()=>{const a=A.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>A.cwd()})();i.posix={resolve(...s){let a="",r=!1;for(let c=s.length-1;c>=-1&&!r;c--){const b=c>=0?s[c]:d();m(b,"path"),b.length!==0&&(a=`${b}/${a}`,r=b.charCodeAt(0)===o)}return a=C(a,!r,"/",_),r?`/${a}`:a.length>0?a:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o,r=s.charCodeAt(s.length-1)===o;return s=C(s,!a,"/",_),s.length===0?a?"/":r?"./":".":(r&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let a;for(let r=0;r<s.length;++r){const c=s[r];m(c,"path"),c.length>0&&(a===void 0?a=c:a+=`/${c}`)}return a===void 0?".":i.posix.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a||(s=i.posix.resolve(s),a=i.posix.resolve(a),s===a))return"";const r=1,c=s.length,b=c-r,N=1,M=a.length-N,R=b<M?b:M;let P=-1,F=0;for(;F<R;F++){const O=s.charCodeAt(r+F);if(O!==a.charCodeAt(N+F))break;O===o&&(P=F)}if(F===R)if(M>R){if(a.charCodeAt(N+F)===o)return a.slice(N+F+1);if(F===0)return a.slice(N+F)}else b>R&&(s.charCodeAt(r+F)===o?P=F:F===0&&(P=0));let V="";for(F=r+P+1;F<=c;++F)(F===c||s.charCodeAt(F)===o)&&(V+=V.length===0?"..":"/..");return`${V}${a.slice(N+P)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o;let r=-1,c=!0;for(let b=s.length-1;b>=1;--b)if(s.charCodeAt(b)===o){if(!c){r=b;break}}else c=!1;return r===-1?a?"/":".":a&&r===1?"//":s.slice(0,r)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let r=0,c=-1,b=!0,N;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let M=a.length-1,R=-1;for(N=s.length-1;N>=0;--N){const P=s.charCodeAt(N);if(P===o){if(!b){r=N+1;break}}else R===-1&&(b=!1,R=N+1),M>=0&&(P===a.charCodeAt(M)?--M===-1&&(c=N):(M=-1,c=R))}return r===c?c=R:c===-1&&(c=s.length),s.slice(r,c)}for(N=s.length-1;N>=0;--N)if(s.charCodeAt(N)===o){if(!b){r=N+1;break}}else c===-1&&(b=!1,c=N+1);return c===-1?"":s.slice(r,c)},extname(s){m(s,"path");let a=-1,r=0,c=-1,b=!0,N=0;for(let M=s.length-1;M>=0;--M){const R=s.charCodeAt(M);if(R===o){if(!b){r=M+1;break}continue}c===-1&&(b=!1,c=M+1),R===v?a===-1?a=M:N!==1&&(N=1):a!==-1&&(N=-1)}return a===-1||c===-1||N===0||N===1&&a===c-1&&a===r+1?"":s.slice(a,c)},format:u.bind(null,"/"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.charCodeAt(0)===o;let c;r?(a.root="/",c=1):c=0;let b=-1,N=0,M=-1,R=!0,P=s.length-1,F=0;for(;P>=c;--P){const V=s.charCodeAt(P);if(V===o){if(!R){N=P+1;break}continue}M===-1&&(R=!1,M=P+1),V===v?b===-1?b=P:F!==1&&(F=1):b!==-1&&(F=-1)}if(M!==-1){const V=N===0&&r?1:N;b===-1||F===0||F===1&&b===M-1&&b===N+1?a.base=a.name=s.slice(V,M):(a.name=s.slice(V,b),a.base=s.slice(V,M),a.ext=s.slice(b,M))}return N>0?a.dir=s.slice(0,N-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},i.posix.win32=i.win32.win32=i.win32,i.posix.posix=i.win32.posix=i.posix,i.normalize=L?i.win32.normalize:i.posix.normalize,i.resolve=L?i.win32.resolve:i.posix.resolve,i.relative=L?i.win32.relative:i.posix.relative,i.dirname=L?i.win32.dirname:i.posix.dirname,i.basename=L?i.win32.basename:i.posix.basename,i.extname=L?i.win32.extname:i.posix.extname,i.sep=L?i.win32.sep:i.posix.sep}),X(Q[20],J([0,1,5]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StopWatch=void 0;const e=A.globals.performance&&typeof A.globals.performance.now=="function";class E{static create(p=!0){return new E(p)}constructor(p){this.a=e&&p,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}i.StopWatch=E}),X(Q[7],J([0,1,8,10,14,20]),function(U,i,A,e,E,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Relay=i.EventBufferer=i.MicrotaskEmitter=i.DebounceEmitter=i.PauseableEmitter=i.EventDeliveryQueue=i.Emitter=i.EventProfiling=i.Event=void 0;const p=!1,v=!1;var o;(function(a){a.None=()=>e.Disposable.None;function r(Z){if(v){const{onDidAddListener:j}=Z,Y=w.create();let G=0;Z.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),j?.()}}}function c(Z,j){return q(Z,()=>{},0,void 0,void 0,j)}a.defer=c;function b(Z){return(j,Y=null,G)=>{let x=!1,ee;return ee=Z(te=>{if(!x)return ee?ee.dispose():x=!0,j.call(Y,te)},null,G),x&&ee.dispose(),ee}}a.once=b;function N(Z,j,Y){return O((G,x=null,ee)=>Z(te=>G.call(x,j(te)),null,ee),Y)}a.map=N;function M(Z,j,Y){return O((G,x=null,ee)=>Z(te=>{j(te),G.call(x,te)},null,ee),Y)}a.forEach=M;function R(Z,j,Y){return O((G,x=null,ee)=>Z(te=>j(te)&&G.call(x,te),null,ee),Y)}a.filter=R;function P(Z){return Z}a.signal=P;function F(...Z){return(j,Y=null,G)=>(0,e.combinedDisposable)(...Z.map(x=>x(ee=>j.call(Y,ee),null,G)))}a.any=F;function V(Z,j,Y,G){let x=Y;return N(Z,ee=>(x=j(x,ee),x),G)}a.reduce=V;function O(Z,j){let Y;const G={onWillAddFirstListener(){Y=Z(x.fire,x)},onDidRemoveLastListener(){Y?.dispose()}};j||r(G);const x=new m(G);return j?.add(x),x.event}function q(Z,j,Y=100,G=!1,x,ee){let te,ne,we,Ce=0;const Le={leakWarningThreshold:x,onWillAddFirstListener(){te=Z(ue=>{Ce++,ne=j(ne,ue),G&&!we&&(ve.fire(ne),ne=void 0),clearTimeout(we),we=setTimeout(()=>{const me=ne;ne=void 0,we=void 0,(!G||Ce>1)&&ve.fire(me),Ce=0},Y)})},onDidRemoveLastListener(){te.dispose()}};ee||r(Le);const ve=new m(Le);return ee?.add(ve),ve.event}a.debounce=q;function k(Z,j=0,Y){return a.debounce(Z,(G,x)=>G?(G.push(x),G):[x],j,void 0,void 0,Y)}a.accumulate=k;function I(Z,j=(G,x)=>G===x,Y){let G=!0,x;return R(Z,ee=>{const te=G||!j(ee,x);return G=!1,x=ee,te},Y)}a.latch=I;function T(Z,j,Y){return[a.filter(Z,j,Y),a.filter(Z,G=>!j(G),Y)]}a.split=T;function W(Z,j=!1,Y=[]){let G=Y.slice(),x=Z(ne=>{G?G.push(ne):te.fire(ne)});const ee=()=>{G?.forEach(ne=>te.fire(ne)),G=null},te=new m({onWillAddFirstListener(){x||(x=Z(ne=>te.fire(ne)))},onDidAddFirstListener(){G&&(j?setTimeout(ee):ee())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return te.event}a.buffer=W;class H{constructor(j){this.event=j,this.c=new e.DisposableStore}map(j){return new H(N(this.event,j,this.c))}forEach(j){return new H(M(this.event,j,this.c))}filter(j){return new H(R(this.event,j,this.c))}reduce(j,Y){return new H(V(this.event,j,Y,this.c))}latch(){return new H(I(this.event,void 0,this.c))}debounce(j,Y=100,G=!1,x){return new H(q(this.event,j,Y,G,x,this.c))}on(j,Y,G){return this.event(j,Y,G)}once(j,Y,G){return b(this.event)(j,Y,G)}dispose(){this.c.dispose()}}function n(Z){return new H(Z)}a.chain=n;function se(Z,j,Y=G=>G){const G=(...ne)=>te.fire(Y(...ne)),x=()=>Z.on(j,G),ee=()=>Z.removeListener(j,G),te=new m({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}a.fromNodeEventEmitter=se;function de(Z,j,Y=G=>G){const G=(...ne)=>te.fire(Y(...ne)),x=()=>Z.addEventListener(j,G),ee=()=>Z.removeEventListener(j,G),te=new m({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}a.fromDOMEventEmitter=de;function ge(Z){return new Promise(j=>b(Z)(j))}a.toPromise=ge;function ye(Z,j){return j(void 0),Z(Y=>j(Y))}a.runAndSubscribe=ye;function Se(Z,j){let Y=null;function G(ee){Y?.dispose(),Y=new e.DisposableStore,j(ee,Y)}G(void 0);const x=Z(ee=>G(ee));return(0,e.toDisposable)(()=>{x.dispose(),Y?.dispose()})}a.runAndSubscribeWithStore=Se;class Ne{constructor(j,Y){this.obs=j,this.c=0,this.d=!1;const G={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};Y||r(G),this.emitter=new m(G),Y&&Y.add(this.emitter)}beginUpdate(j){this.c++}handleChange(j,Y){this.d=!0}endUpdate(j){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function _e(Z,j){return new Ne(Z,j).emitter.event}a.fromObservable=_e})(o=i.Event||(i.Event={}));class f{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${f.c++}`,f.all.add(this)}start(r){this.d=new l.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}i.EventProfiling=f,f.all=new Set,f.c=0;let S=-1;class t{constructor(r,c=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=c,this.d=0}dispose(){var r;(r=this.c)===null||r===void 0||r.clear()}check(r,c){const b=this.threshold;if(b<=0||c<b)return;this.c||(this.c=new Map);const N=this.c.get(r.value)||0;if(this.c.set(r.value,N+1),this.d-=1,this.d<=0){this.d=b*.5;let M,R=0;for(const[P,F]of this.c)(!M||R<F)&&(M=P,R=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${R}):`),console.warn(M)}return()=>{const M=this.c.get(r.value)||0;this.c.set(r.value,M-1)}}}class w{static create(){var r;return new w((r=new Error().stack)!==null&&r!==void 0?r:"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(r,c,b){this.callback=r,this.callbackThis=c,this.stack=b,this.subscription=new e.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class m{constructor(r){var c,b,N,M,R;this.j=!1,this.d=r,this.f=S>0||((c=this.d)===null||c===void 0?void 0:c.leakWarningThreshold)?new t((N=(b=this.d)===null||b===void 0?void 0:b.leakWarningThreshold)!==null&&N!==void 0?N:S):void 0,this.g=!((M=this.d)===null||M===void 0)&&M._profName?new f(this.d._profName):void 0,this.m=(R=this.d)===null||R===void 0?void 0:R.deliveryQueue}dispose(){var r,c,b,N;if(!this.j){if(this.j=!0,this.n){if(p){const M=Array.from(this.n);queueMicrotask(()=>{var R;for(const P of M)P.subscription.isset()&&(P.subscription.unset(),(R=P.stack)===null||R===void 0||R.print())})}this.n.clear()}(r=this.m)===null||r===void 0||r.clear(this),(b=(c=this.d)===null||c===void 0?void 0:c.onDidRemoveLastListener)===null||b===void 0||b.call(c),(N=this.f)===null||N===void 0||N.dispose()}}get event(){return this.l||(this.l=(r,c,b)=>{var N,M,R;if(this.n||(this.n=new E.LinkedList),this.f&&this.n.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),e.Disposable.None;const P=this.n.isEmpty();P&&((N=this.d)===null||N===void 0?void 0:N.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this);let F,V;this.f&&this.n.size>=Math.ceil(this.f.threshold*.2)&&(V=w.create(),F=this.f.check(V,this.n.size+1)),p&&(V=V??w.create());const O=new h(r,c,V),q=this.n.push(O);P&&((M=this.d)===null||M===void 0?void 0:M.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),!((R=this.d)===null||R===void 0)&&R.onDidAddListener&&this.d.onDidAddListener(this,r,c);const k=O.subscription.set(()=>{F?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof e.DisposableStore?b.add(k):Array.isArray(b)&&b.push(k),k}),this.l}fire(r){var c,b;if(this.n){this.m||(this.m=new y);for(const N of this.n)this.m.push(this,N,r);(c=this.g)===null||c===void 0||c.start(this.m.size),this.m.deliver(),(b=this.g)===null||b===void 0||b.stop()}}hasListeners(){return this.n?!this.n.isEmpty():!1}}i.Emitter=m;class L{constructor(){this.c=new E.LinkedList}get size(){return this.c.size}push(r,c,b){this.c.push(new _(r,c,b))}clear(r){const c=new E.LinkedList;for(const b of this.c)b.emitter!==r&&c.push(b);this.c=c}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(c){(0,A.onUnexpectedError)(c)}}}}i.EventDeliveryQueue=L;class y extends L{clear(r){this.c.clear()}}class _{constructor(r,c,b){this.emitter=r,this.listener=c,this.event=b}}class g extends m{constructor(r){super(r),this.c=0,this.h=new E.LinkedList,this.k=r?.merge}pause(){this.c++}resume(){if(this.c!==0&&--this.c===0)if(this.k){if(this.h.size>0){const r=Array.from(this.h);this.h.clear(),super.fire(this.k(r))}}else for(;!this.c&&this.h.size!==0;)super.fire(this.h.shift())}fire(r){this.n&&(this.c!==0?this.h.push(r):super.fire(r))}}i.PauseableEmitter=g;class C extends g{constructor(r){var c;super(r),this.o=(c=r.delay)!==null&&c!==void 0?c:100}fire(r){this.p||(this.pause(),this.p=setTimeout(()=>{this.p=void 0,this.resume()},this.o)),super.fire(r)}}i.DebounceEmitter=C;class u extends m{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(c=>super.fire(c)),this.c=[]}))}}i.MicrotaskEmitter=u;class d{constructor(){this.c=[]}wrapEvent(r){return(c,b,N)=>r(M=>{const R=this.c[this.c.length-1];R?R.push(()=>c.call(b,M)):c.call(b,M)},void 0,N)}bufferEvents(r){const c=[];this.c.push(c);const b=r();return this.c.pop(),c.forEach(N=>N()),b}}i.EventBufferer=d;class s{constructor(){this.c=!1,this.d=o.None,this.f=e.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}i.Relay=s}),X(Q[51],J([0,1,7]),function(U,i,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CancellationTokenSource=i.CancellationToken=void 0;const e=Object.freeze(function(v,o){const f=setTimeout(v.bind(o),0);return{dispose(){clearTimeout(f)}}});var E;(function(v){function o(f){return f===v.None||f===v.Cancelled||f instanceof l?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}v.isCancellationToken=o,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(E=i.CancellationToken||(i.CancellationToken={}));class l{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?e:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(o){this.a=void 0,this.b=void 0,this.b=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new l),this.a}cancel(){this.a?this.a instanceof l&&this.a.cancel():this.a=E.Cancelled}dispose(o=!1){var f;o&&this.cancel(),(f=this.b)===null||f===void 0||f.dispose(),this.a?this.a instanceof l&&this.a.dispose():this.a=E.None}}i.CancellationTokenSource=p}),X(Q[12],J([0,1,50,5]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.uriToFsPath=i.URI=void 0;const E=/^\w[\w\d+.-]*$/,l=/^\//,p=/^\/\//;function v(r,c){if(!r.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!E.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!l.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(r,c){return!r&&!c?"file":r}function f(r,c){switch(r){case"https":case"http":case"file":c?c[0]!==t&&(c=t+c):c=t;break}return c}const S="",t="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(c){return c instanceof h?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,b,N,M,R,P=!1){typeof c=="object"?(this.scheme=c.scheme||S,this.authority=c.authority||S,this.path=c.path||S,this.query=c.query||S,this.fragment=c.fragment||S):(this.scheme=o(c,P),this.authority=b||S,this.path=f(this.scheme,N||S),this.query=M||S,this.fragment=R||S,v(this,P))}get fsPath(){return C(this,!1)}with(c){if(!c)return this;let{scheme:b,authority:N,path:M,query:R,fragment:P}=c;return b===void 0?b=this.scheme:b===null&&(b=S),N===void 0?N=this.authority:N===null&&(N=S),M===void 0?M=this.path:M===null&&(M=S),R===void 0?R=this.query:R===null&&(R=S),P===void 0?P=this.fragment:P===null&&(P=S),b===this.scheme&&N===this.authority&&M===this.path&&R===this.query&&P===this.fragment?this:new L(b,N,M,R,P)}static parse(c,b=!1){const N=w.exec(c);return N?new L(N[2]||S,a(N[4]||S),a(N[5]||S),a(N[7]||S),a(N[9]||S),b):new L(S,S,S,S,S)}static file(c){let b=S;if(e.isWindows&&(c=c.replace(/\\/g,t)),c[0]===t&&c[1]===t){const N=c.indexOf(t,2);N===-1?(b=c.substring(2),c=t):(b=c.substring(2,N),c=c.substring(N)||t)}return new L("file",b,c,S,S)}static from(c){const b=new L(c.scheme,c.authority,c.path,c.query,c.fragment);return v(b,!0),b}static joinPath(c,...b){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return e.isWindows&&c.scheme==="file"?N=h.file(A.win32.join(C(c,!0),...b)).path:N=A.posix.join(c.path,...b),c.with({path:N})}toString(c=!1){return u(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof h)return c;{const b=new L(c);return b._formatted=c.external,b._fsPath=c._sep===m?c.fsPath:null,b}}else return c}}i.URI=h;const m=e.isWindows?1:void 0;class L extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(c=!1){return c?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=m),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,c,b){let N,M=-1;for(let R=0;R<r.length;R++){const P=r.charCodeAt(R);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||c&&P===47||b&&P===91||b&&P===93||b&&P===58)M!==-1&&(N+=encodeURIComponent(r.substring(M,R)),M=-1),N!==void 0&&(N+=r.charAt(R));else{N===void 0&&(N=r.substr(0,R));const F=y[P];F!==void 0?(M!==-1&&(N+=encodeURIComponent(r.substring(M,R)),M=-1),N+=F):M===-1&&(M=R)}}return M!==-1&&(N+=encodeURIComponent(r.substring(M))),N!==void 0?N:r}function g(r){let c;for(let b=0;b<r.length;b++){const N=r.charCodeAt(b);N===35||N===63?(c===void 0&&(c=r.substr(0,b)),c+=y[N]):c!==void 0&&(c+=r[b])}return c!==void 0?c:r}function C(r,c){let b;return r.authority&&r.path.length>1&&r.scheme==="file"?b=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?c?b=r.path.substr(1):b=r.path[1].toLowerCase()+r.path.substr(2):b=r.path,e.isWindows&&(b=b.replace(/\//g,"\\")),b}i.uriToFsPath=C;function u(r,c){const b=c?g:_;let N="",{scheme:M,authority:R,path:P,query:F,fragment:V}=r;if(M&&(N+=M,N+=":"),(R||M==="file")&&(N+=t,N+=t),R){let O=R.indexOf("@");if(O!==-1){const q=R.substr(0,O);R=R.substr(O+1),O=q.lastIndexOf(":"),O===-1?N+=b(q,!1,!1):(N+=b(q.substr(0,O),!1,!1),N+=":",N+=b(q.substr(O+1),!1,!0)),N+="@"}R=R.toLowerCase(),O=R.lastIndexOf(":"),O===-1?N+=b(R,!1,!0):(N+=b(R.substr(0,O),!1,!0),N+=R.substr(O))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const O=P.charCodeAt(1);O>=65&&O<=90&&(P=`/${String.fromCharCode(O+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const O=P.charCodeAt(0);O>=65&&O<=90&&(P=`${String.fromCharCode(O+32)}:${P.substr(2)}`)}N+=b(P,!0,!1)}return F&&(N+="?",N+=b(F,!1,!1)),V&&(N+="#",N+=c?V:_(V,!1,!1)),N}function d(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+d(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(s)?r.replace(s,c=>d(c)):r}}),X(Q[56],J([0,1,8,7,10,11,5,4]),function(U,i,A,e,E,l,p,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.create=i.SimpleWorkerServer=i.SimpleWorkerClient=i.logOnceWebWorkerWarning=void 0;const o="$initialize";let f=!1;function S(a){!p.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}i.logOnceWebWorkerWarning=S;class t{constructor(r,c,b,N){this.vsWorker=r,this.req=c,this.method=b,this.args=N,this.type=0}}class w{constructor(r,c,b,N){this.vsWorker=r,this.seq=c,this.res=b,this.err=N,this.type=1}}class h{constructor(r,c,b,N){this.vsWorker=r,this.req=c,this.eventName=b,this.arg=N,this.type=2}}class m{constructor(r,c,b){this.vsWorker=r,this.req=c,this.event=b,this.type=3}}class L{constructor(r,c){this.vsWorker=r,this.req=c,this.type=4}}class y{constructor(r){this.a=-1,this.g=r,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(r){this.a=r}sendMessage(r,c){const b=String(++this.b);return new Promise((N,M)=>{this.c[b]={resolve:N,reject:M},this.o(new t(this.a,b,r,c))})}listen(r,c){let b=null;const N=new e.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,N),this.o(new h(this.a,b,r,c))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new L(this.a,b)),b=null}});return N.event}handleMessage(r){!r||!r.vsWorker||this.a!==-1&&r.vsWorker!==this.a||this.h(r)}h(r){switch(r.type){case 1:return this.j(r);case 0:return this.k(r);case 2:return this.l(r);case 3:return this.m(r);case 4:return this.n(r)}}j(r){if(!this.c[r.seq]){console.warn("Got reply to unknown seq");return}const c=this.c[r.seq];if(delete this.c[r.seq],r.err){let b=r.err;r.err.$isError&&(b=new Error,b.name=r.err.name,b.message=r.err.message,b.stack=r.err.stack),c.reject(b);return}c.resolve(r.res)}k(r){const c=r.req;this.g.handleMessage(r.method,r.args).then(N=>{this.o(new w(this.a,c,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,A.transformErrorForSerialization)(N.detail)),this.o(new w(this.a,c,void 0,(0,A.transformErrorForSerialization)(N)))})}l(r){const c=r.req,b=this.g.handleEvent(r.eventName,r.arg)(N=>{this.o(new m(this.a,c,N))});this.f.set(c,b)}m(r){if(!this.d.has(r.req)){console.warn("Got event for unknown req");return}this.d.get(r.req).fire(r.event)}n(r){if(!this.f.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(r.req).dispose(),this.f.delete(r.req)}o(r){const c=[];if(r.type===0)for(let b=0;b<r.args.length;b++)r.args[b]instanceof ArrayBuffer&&c.push(r.args[b]);else r.type===1&&r.res instanceof ArrayBuffer&&c.push(r.res);this.g.sendMessage(r,c)}}class _ extends E.Disposable{constructor(r,c,b){super();let N=null;this.a=this.q(r.create("vs/base/common/worker/simpleWorker",V=>{this.c.handleMessage(V)},V=>{N?.(V)})),this.c=new y({sendMessage:(V,O)=>{this.a.postMessage(V,O)},handleMessage:(V,O)=>{if(typeof b[V]!="function")return Promise.reject(new Error("Missing method "+V+" on main thread host."));try{return Promise.resolve(b[V].apply(b,O))}catch(q){return Promise.reject(q)}},handleEvent:(V,O)=>{if(C(V)){const q=b[V].call(b,O);if(typeof q!="function")throw new Error(`Missing dynamic event ${V} on main thread host.`);return q}if(g(V)){const q=b[V];if(typeof q!="function")throw new Error(`Missing event ${V} on main thread host.`);return q}throw new Error(`Malformed event name ${V}`)}}),this.c.setWorkerId(this.a.getId());let M=null;typeof p.globals.require<"u"&&typeof p.globals.require.getConfig=="function"?M=p.globals.require.getConfig():typeof p.globals.requirejs<"u"&&(M=p.globals.requirejs.s.contexts._.config);const R=(0,l.getAllMethodNames)(b);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(M)),c,R]);const P=(V,O)=>this.h(V,O),F=(V,O)=>this.c.listen(V,O);this.g=new Promise((V,O)=>{N=O,this.b.then(q=>{V(u(q,P,F))},q=>{O(q),this.j("Worker failed to load "+c,q)})})}getProxyObject(){return this.g}h(r,c){return new Promise((b,N)=>{this.b.then(()=>{this.c.sendMessage(r,c).then(b,N)},N)})}j(r,c){console.error(r),console.info(c)}}i.SimpleWorkerClient=_;function g(a){return a[0]==="o"&&a[1]==="n"&&v.isUpperAsciiLetter(a.charCodeAt(2))}function C(a){return/^onDynamic/.test(a)&&v.isUpperAsciiLetter(a.charCodeAt(9))}function u(a,r,c){const b=R=>function(){const P=Array.prototype.slice.call(arguments,0);return r(R,P)},N=R=>function(P){return c(R,P)},M={};for(const R of a){if(C(R)){M[R]=N(R);continue}if(g(R)){M[R]=c(R,void 0);continue}M[R]=b(R)}return M}class d{constructor(r,c){this.a=c,this.b=null,this.c=new y({sendMessage:(b,N)=>{r(b,N)},handleMessage:(b,N)=>this.d(b,N),handleEvent:(b,N)=>this.f(b,N)})}onmessage(r){this.c.handleMessage(r)}d(r,c){if(r===o)return this.g(c[0],c[1],c[2],c[3]);if(!this.b||typeof this.b[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.b[r].apply(this.b,c))}catch(b){return Promise.reject(b)}}f(r,c){if(!this.b)throw new Error("Missing requestHandler");if(C(r)){const b=this.b[r].call(this.b,c);if(typeof b!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return b}if(g(r)){const b=this.b[r];if(typeof b!="function")throw new Error(`Missing event ${r} on request handler.`);return b}throw new Error(`Malformed event name ${r}`)}g(r,c,b,N){this.c.setWorkerId(r);const P=u(N,(F,V)=>this.c.sendMessage(F,V),(F,V)=>this.c.listen(F,V));return this.a?(this.b=this.a(P),Promise.resolve((0,l.getAllMethodNames)(this.b))):(c&&(typeof c.baseUrl<"u"&&delete c.baseUrl,typeof c.paths<"u"&&typeof c.paths.vs<"u"&&delete c.paths.vs,typeof c.trustedTypesPolicy!==void 0&&delete c.trustedTypesPolicy,c.catchError=!0,p.globals.require.config(c)),new Promise((F,V)=>{(p.globals.require||U)([b],q=>{if(this.b=q.create(P),!this.b){V(new Error("No RequestHandler!"));return}F((0,l.getAllMethodNames)(this.b))},V)}))}}i.SimpleWorkerServer=d;function s(a){return new d(a,null)}i.create=s}),X(Q[52],J([0,1,7,10]),function(U,i,A,e){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=void 0;class E{constructor(){this.a=new Map,this.b=new Map,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=null}fire(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,o){return this.a.set(v,o),this.fire([v]),(0,e.toDisposable)(()=>{this.a.get(v)===o&&(this.a.delete(v),this.fire([v]))})}registerFactory(v,o){var f;(f=this.b.get(v))===null||f===void 0||f.dispose();const S=new l(this,v,o);return this.b.set(v,S),(0,e.toDisposable)(()=>{const t=this.b.get(v);!t||t!==S||(this.b.delete(v),t.dispose())})}getOrCreate(v){return le(this,void 0,void 0,function*(){const o=this.get(v);if(o)return o;const f=this.b.get(v);return!f||f.isResolved?null:(yield f.resolve(),this.get(v))})}get(v){return this.a.get(v)||null}isResolved(v){if(this.get(v))return!0;const f=this.b.get(v);return!!(!f||f.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}i.TokenizationRegistry=E;class l extends e.Disposable{get isResolved(){return this.c}constructor(v,o,f){super(),this.g=v,this.h=o,this.i=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this.b||(this.b=this.j()),this.b})}j(){return le(this,void 0,void 0,function*(){const v=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,v&&!this.a&&this.q(this.g.register(this.h,v))})}}}),X(Q[53],J([0,1,24,12,2,52]),function(U,i,A,e,E,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TokenizationRegistry=i.InlayHintKind=i.Command=i.FoldingRangeKind=i.SymbolKinds=i.isLocationLink=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.InlineCompletionTriggerKind=i.CompletionItemKinds=i.EncodedTokenizationResult=i.TokenizationResult=i.Token=void 0;class p{constructor(C,u,d){this._tokenBrand=void 0,this.offset=C,this.type=u,this.language=d}toString(){return"("+this.offset+", "+this.type+")"}}i.Token=p;class v{constructor(C,u){this._tokenizationResultBrand=void 0,this.tokens=C,this.endState=u}}i.TokenizationResult=v;class o{constructor(C,u){this._encodedTokenizationResultBrand=void 0,this.tokens=C,this.endState=u}}i.EncodedTokenizationResult=o;var f;(function(g){const C=new Map;C.set(0,A.Codicon.symbolMethod),C.set(1,A.Codicon.symbolFunction),C.set(2,A.Codicon.symbolConstructor),C.set(3,A.Codicon.symbolField),C.set(4,A.Codicon.symbolVariable),C.set(5,A.Codicon.symbolClass),C.set(6,A.Codicon.symbolStruct),C.set(7,A.Codicon.symbolInterface),C.set(8,A.Codicon.symbolModule),C.set(9,A.Codicon.symbolProperty),C.set(10,A.Codicon.symbolEvent),C.set(11,A.Codicon.symbolOperator),C.set(12,A.Codicon.symbolUnit),C.set(13,A.Codicon.symbolValue),C.set(15,A.Codicon.symbolEnum),C.set(14,A.Codicon.symbolConstant),C.set(15,A.Codicon.symbolEnum),C.set(16,A.Codicon.symbolEnumMember),C.set(17,A.Codicon.symbolKeyword),C.set(27,A.Codicon.symbolSnippet),C.set(18,A.Codicon.symbolText),C.set(19,A.Codicon.symbolColor),C.set(20,A.Codicon.symbolFile),C.set(21,A.Codicon.symbolReference),C.set(22,A.Codicon.symbolCustomColor),C.set(23,A.Codicon.symbolFolder),C.set(24,A.Codicon.symbolTypeParameter),C.set(25,A.Codicon.account),C.set(26,A.Codicon.issues);function u(a){let r=C.get(a);return r||(console.info("No codicon found for CompletionItemKind "+a),r=A.Codicon.symbolProperty),r}g.toIcon=u;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function s(a,r){let c=d.get(a);return typeof c>"u"&&!r&&(c=9),c}g.fromString=s})(f=i.CompletionItemKinds||(i.CompletionItemKinds={}));var S;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(S=i.InlineCompletionTriggerKind||(i.InlineCompletionTriggerKind={}));var t;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(t=i.SignatureHelpTriggerKind||(i.SignatureHelpTriggerKind={}));var w;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(w=i.DocumentHighlightKind||(i.DocumentHighlightKind={}));function h(g){return g&&e.URI.isUri(g.uri)&&E.Range.isIRange(g.range)&&(E.Range.isIRange(g.originSelectionRange)||E.Range.isIRange(g.targetSelectionRange))}i.isLocationLink=h;var m;(function(g){const C=new Map;C.set(0,A.Codicon.symbolFile),C.set(1,A.Codicon.symbolModule),C.set(2,A.Codicon.symbolNamespace),C.set(3,A.Codicon.symbolPackage),C.set(4,A.Codicon.symbolClass),C.set(5,A.Codicon.symbolMethod),C.set(6,A.Codicon.symbolProperty),C.set(7,A.Codicon.symbolField),C.set(8,A.Codicon.symbolConstructor),C.set(9,A.Codicon.symbolEnum),C.set(10,A.Codicon.symbolInterface),C.set(11,A.Codicon.symbolFunction),C.set(12,A.Codicon.symbolVariable),C.set(13,A.Codicon.symbolConstant),C.set(14,A.Codicon.symbolString),C.set(15,A.Codicon.symbolNumber),C.set(16,A.Codicon.symbolBoolean),C.set(17,A.Codicon.symbolArray),C.set(18,A.Codicon.symbolObject),C.set(19,A.Codicon.symbolKey),C.set(20,A.Codicon.symbolNull),C.set(21,A.Codicon.symbolEnumMember),C.set(22,A.Codicon.symbolStruct),C.set(23,A.Codicon.symbolEvent),C.set(24,A.Codicon.symbolOperator),C.set(25,A.Codicon.symbolTypeParameter);function u(d){let s=C.get(d);return s||(console.info("No codicon found for SymbolKind "+d),s=A.Codicon.symbolProperty),s}g.toIcon=u})(m=i.SymbolKinds||(i.SymbolKinds={}));class L{constructor(C){this.value=C}}i.FoldingRangeKind=L,L.Comment=new L("comment"),L.Imports=new L("imports"),L.Region=new L("region");var y;(function(g){function C(u){return!u||typeof u!="object"?!1:typeof u.id=="string"&&typeof u.title=="string"}g.is=C})(y=i.Command||(i.Command={}));var _;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(_=i.InlayHintKind||(i.InlayHintKind={})),i.TokenizationRegistry=new l.TokenizationRegistry}),X(Q[54],J([0,1,51,7,27,12,3,2,31,53,47]),function(U,i,A,e,E,l,p,v,o,f,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createMonacoBaseAPI=i.KeyMod=void 0;class t{static chord(m,L){return(0,E.KeyChord)(m,L)}}i.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:e.Emitter,KeyCode:S.KeyCode,KeyMod:t,Position:p.Position,Range:v.Range,Selection:o.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:l.URI,Token:f.Token}}i.createMonacoBaseAPI=w}),X(Q[57],J([0,1,15,5,12,3,2,44,18,40,41,54,20,46,39,11]),function(U,i,A,e,E,l,p,v,o,f,S,t,w,h,m,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.create=i.EditorSimpleWorker=void 0;class y extends v.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(u){return this.d[u-1]}getWordAtPosition(u,d){const s=(0,o.getWordAtText)(u.column,(0,o.ensureValidWordDefinition)(d),this.d[u.lineNumber-1],0);return s?new p.Range(u.lineNumber,s.startColumn,u.lineNumber,s.endColumn):null}words(u){const d=this.d,s=this.p.bind(this);let a=0,r="",c=0,b=[];return{*[Symbol.iterator](){for(;;)if(c<b.length){const N=r.substring(b[c].start,b[c].end);c+=1,yield N}else if(a<d.length)r=d[a],b=s(r,u),c=0,a+=1;else break}}}getLineWords(u,d){const s=this.d[u-1],a=this.p(s,d),r=[];for(const c of a)r.push({word:s.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return r}p(u,d){const s=[];let a;for(d.lastIndex=0;(a=d.exec(u))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(u){if(u=this.q(u),u.startLineNumber===u.endLineNumber)return this.d[u.startLineNumber-1].substring(u.startColumn-1,u.endColumn-1);const d=this.f,s=u.startLineNumber-1,a=u.endLineNumber-1,r=[];r.push(this.d[s].substring(u.startColumn-1));for(let c=s+1;c<a;c++)r.push(this.d[c]);return r.push(this.d[a].substring(0,u.endColumn-1)),r.join(d)}offsetAt(u){return u=this.r(u),this.k(),this.h.getPrefixSum(u.lineNumber-2)+(u.column-1)}positionAt(u){u=Math.floor(u),u=Math.max(0,u),this.k();const d=this.h.getIndexOf(u),s=this.d[d.index].length;return{lineNumber:1+d.index,column:1+Math.min(d.remainder,s)}}q(u){const d=this.r({lineNumber:u.startLineNumber,column:u.startColumn}),s=this.r({lineNumber:u.endLineNumber,column:u.endColumn});return d.lineNumber!==u.startLineNumber||d.column!==u.startColumn||s.lineNumber!==u.endLineNumber||s.column!==u.endColumn?{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:s.lineNumber,endColumn:s.column}:u}r(u){if(!l.Position.isIPosition(u))throw new Error("bad position");let{lineNumber:d,column:s}=u,a=!1;if(d<1)d=1,s=1,a=!0;else if(d>this.d.length)d=this.d.length,s=this.d[d-1].length+1,a=!0;else{const r=this.d[d-1].length+1;s<1?(s=1,a=!0):s>r&&(s=r,a=!0)}return a?{lineNumber:d,column:s}:u}}class _{constructor(u,d){this.c=u,this.d=Object.create(null),this.f=d,this.g=null}dispose(){this.d=Object.create(null)}h(u){return this.d[u]}j(){const u=[];return Object.keys(this.d).forEach(d=>u.push(this.d[d])),u}acceptNewModel(u){this.d[u.url]=new y(E.URI.parse(u.url),u.lines,u.EOL,u.versionId)}acceptModelChanged(u,d){if(!this.d[u])return;this.d[u].onEvents(d)}acceptRemovedModel(u){!this.d[u]||delete this.d[u]}computeUnicodeHighlights(u,d,s){return le(this,void 0,void 0,function*(){const a=this.h(u);return a?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,d,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(u,d,s,a){return le(this,void 0,void 0,function*(){const r=this.h(u),c=this.h(d);return!r||!c?null:_.k(r,c,s,a)})}static k(u,d,s,a){const r=a==="experimental"?m.linesDiffComputers.experimental:m.linesDiffComputers.smart,c=u.getLinesContent(),b=d.getLinesContent(),N=r.computeDiff(c,b,s);return{identical:N.changes.length>0?!1:this.l(u,d),quitEarly:N.quitEarly,changes:N.changes.map(R=>{var P;return[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,(P=R.innerChanges)===null||P===void 0?void 0:P.map(F=>[F.originalRange.startLineNumber,F.originalRange.startColumn,F.originalRange.endLineNumber,F.originalRange.endColumn,F.modifiedRange.startLineNumber,F.modifiedRange.startColumn,F.modifiedRange.endLineNumber,F.modifiedRange.endColumn])]})}}static l(u,d){const s=u.getLineCount(),a=d.getLineCount();if(s!==a)return!1;for(let r=1;r<=s;r++){const c=u.getLineContent(r),b=d.getLineContent(r);if(c!==b)return!1}return!0}computeMoreMinimalEdits(u,d){return le(this,void 0,void 0,function*(){const s=this.h(u);if(!s)return d;const a=[];let r;d=d.slice(0).sort((c,b)=>{if(c.range&&b.range)return p.Range.compareRangesUsingStarts(c.range,b.range);const N=c.range?0:1,M=b.range?0:1;return N-M});for(let{range:c,text:b,eol:N}of d){if(typeof N=="number"&&(r=N),p.Range.isEmpty(c)&&!b)continue;const M=s.getValueInRange(c);if(b=b.replace(/\r\n|\n|\r/g,s.eol),M===b)continue;if(Math.max(b.length,M.length)>_.n){a.push({range:c,text:b});continue}const R=(0,A.stringDiff)(M,b,!1),P=s.offsetAt(p.Range.lift(c).getStartPosition());for(const F of R){const V=s.positionAt(P+F.originalStart),O=s.positionAt(P+F.originalStart+F.originalLength),q={text:b.substr(F.modifiedStart,F.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:O.lineNumber,endColumn:O.column}};s.getValueInRange(q.range)!==q.text&&a.push(q)}}return typeof r=="number"&&a.push({eol:r,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(u){return le(this,void 0,void 0,function*(){const d=this.h(u);return d?(0,f.computeLinks)(d):null})}textualSuggest(u,d,s,a){return le(this,void 0,void 0,function*(){const r=new w.StopWatch(!0),c=new RegExp(s,a),b=new Set;e:for(const N of u){const M=this.h(N);if(!!M){for(const R of M.words(c))if(!(R===d||!isNaN(Number(R)))&&(b.add(R),b.size>_.o))break e}}return{words:Array.from(b),duration:r.elapsed()}})}computeWordRanges(u,d,s,a){return le(this,void 0,void 0,function*(){const r=this.h(u);if(!r)return Object.create(null);const c=new RegExp(s,a),b=Object.create(null);for(let N=d.startLineNumber;N<d.endLineNumber;N++){const M=r.getLineWords(N,c);for(const R of M){if(!isNaN(Number(R.word)))continue;let P=b[R.word];P||(P=[],b[R.word]=P),P.push({startLineNumber:N,startColumn:R.startColumn,endLineNumber:N,endColumn:R.endColumn})}}return b})}navigateValueSet(u,d,s,a,r){return le(this,void 0,void 0,function*(){const c=this.h(u);if(!c)return null;const b=new RegExp(a,r);d.startColumn===d.endColumn&&(d={startLineNumber:d.startLineNumber,startColumn:d.startColumn,endLineNumber:d.endLineNumber,endColumn:d.endColumn+1});const N=c.getValueInRange(d),M=c.getWordAtPosition({lineNumber:d.startLineNumber,column:d.startColumn},b);if(!M)return null;const R=c.getValueInRange(M);return S.BasicInplaceReplace.INSTANCE.navigateValueSet(d,N,M,R,s)})}loadForeignModule(u,d,s){const a=(b,N)=>this.c.fhr(b,N),c={host:(0,L.createProxyObject)(s,a),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(c,d),Promise.resolve((0,L.getAllMethodNames)(this.g))):new Promise((b,N)=>{U([u],M=>{this.g=M.create(c,d),b((0,L.getAllMethodNames)(this.g))},N)})}fmr(u,d){if(!this.g||typeof this.g[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this.g[u].apply(this.g,d))}catch(s){return Promise.reject(s)}}}i.EditorSimpleWorker=_,_.n=1e5,_.o=1e4;function g(C){return new _(C,null)}i.create=g,typeof importScripts=="function"&&(e.globals.monaco=(0,t.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map